# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.user_base import UserBase
from openapi_server import util


class Account(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, state: str=None, created_at: datetime=None, updated_at: datetime=None, owner: UserBase=None):
        """Account - a model defined in OpenAPI

        :param id: The id of this Account.
        :param etag: The etag of this Account.
        :param name: The name of this Account.
        :param state: The state of this Account.
        :param created_at: The created_at of this Account.
        :param updated_at: The updated_at of this Account.
        :param owner: The owner of this Account.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'state': str,
            'created_at': datetime,
            'updated_at': datetime,
            'owner': UserBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'state': 'state',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'owner': 'owner'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._state = state
        self._created_at = created_at
        self._updated_at = updated_at
        self._owner = owner

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Account':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Account of this Account.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Account.

        Unique identifier for the *Account*

        :return: The id of this Account.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Account.

        Unique identifier for the *Account*

        :param id: The id of this Account.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Account.

        ETag for the *Account*

        :return: The etag of this Account.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Account.

        ETag for the *Account*

        :param etag: The etag of this Account.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this Account.

        The name of the *Account*

        :return: The name of this Account.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Account.

        The name of the *Account*

        :param name: The name of this Account.
        :type name: str
        """

        self._name = name

    @property
    def state(self):
        """Gets the state of this Account.

        Account state

        :return: The state of this Account.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this Account.

        Account state

        :param state: The state of this Account.
        :type state: str
        """

        self._state = state

    @property
    def created_at(self):
        """Gets the created_at of this Account.

        The time the *Account* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Account.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Account.

        The time the *Account* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Account.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Account.

        The time the *Account* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Account.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Account.

        The time the *Account* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Account.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this Account.


        :return: The owner of this Account.
        :rtype: UserBase
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this Account.


        :param owner: The owner of this Account.
        :type owner: UserBase
        """

        self._owner = owner
