# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class AccountBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, state: str=None, created_at: datetime=None, updated_at: datetime=None):
        """AccountBase - a model defined in OpenAPI

        :param id: The id of this AccountBase.
        :param etag: The etag of this AccountBase.
        :param name: The name of this AccountBase.
        :param state: The state of this AccountBase.
        :param created_at: The created_at of this AccountBase.
        :param updated_at: The updated_at of this AccountBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'state': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'state': 'state',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._state = state
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'AccountBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Account_base of this AccountBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this AccountBase.

        Unique identifier for the *Account*

        :return: The id of this AccountBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AccountBase.

        Unique identifier for the *Account*

        :param id: The id of this AccountBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this AccountBase.

        ETag for the *Account*

        :return: The etag of this AccountBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this AccountBase.

        ETag for the *Account*

        :param etag: The etag of this AccountBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this AccountBase.

        The name of the *Account*

        :return: The name of this AccountBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AccountBase.

        The name of the *Account*

        :param name: The name of this AccountBase.
        :type name: str
        """

        self._name = name

    @property
    def state(self):
        """Gets the state of this AccountBase.

        Account state

        :return: The state of this AccountBase.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this AccountBase.

        Account state

        :param state: The state of this AccountBase.
        :type state: str
        """

        self._state = state

    @property
    def created_at(self):
        """Gets the created_at of this AccountBase.

        The time the *Account* was created (as a ISO-8601 timestamp)

        :return: The created_at of this AccountBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AccountBase.

        The time the *Account* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this AccountBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this AccountBase.

        The time the *Account* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this AccountBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this AccountBase.

        The time the *Account* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this AccountBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
