# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.group_base import GroupBase
from openapi_server.models.user_base import UserBase
from openapi_server import util


class ActivityRate(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, rate: float=None, flat_rate: bool=None, created_at: datetime=None, updated_at: datetime=None, contact_id: int=None, co_counsel_contact_id: int=None, user: UserBase=None, group: GroupBase=None):
        """ActivityRate - a model defined in OpenAPI

        :param id: The id of this ActivityRate.
        :param etag: The etag of this ActivityRate.
        :param rate: The rate of this ActivityRate.
        :param flat_rate: The flat_rate of this ActivityRate.
        :param created_at: The created_at of this ActivityRate.
        :param updated_at: The updated_at of this ActivityRate.
        :param contact_id: The contact_id of this ActivityRate.
        :param co_counsel_contact_id: The co_counsel_contact_id of this ActivityRate.
        :param user: The user of this ActivityRate.
        :param group: The group of this ActivityRate.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'rate': float,
            'flat_rate': bool,
            'created_at': datetime,
            'updated_at': datetime,
            'contact_id': int,
            'co_counsel_contact_id': int,
            'user': UserBase,
            'group': GroupBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'rate': 'rate',
            'flat_rate': 'flat_rate',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'contact_id': 'contact_id',
            'co_counsel_contact_id': 'co_counsel_contact_id',
            'user': 'user',
            'group': 'group'
        }

        self._id = id
        self._etag = etag
        self._rate = rate
        self._flat_rate = flat_rate
        self._created_at = created_at
        self._updated_at = updated_at
        self._contact_id = contact_id
        self._co_counsel_contact_id = co_counsel_contact_id
        self._user = user
        self._group = group

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ActivityRate':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ActivityRate of this ActivityRate.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ActivityRate.

        Unique identifier for the *ActivityRate*

        :return: The id of this ActivityRate.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ActivityRate.

        Unique identifier for the *ActivityRate*

        :param id: The id of this ActivityRate.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ActivityRate.

        ETag for the *ActivityRate*

        :return: The etag of this ActivityRate.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ActivityRate.

        ETag for the *ActivityRate*

        :param etag: The etag of this ActivityRate.
        :type etag: str
        """

        self._etag = etag

    @property
    def rate(self):
        """Gets the rate of this ActivityRate.

        Monetary value of this rate. Either hourly value or flat rate value

        :return: The rate of this ActivityRate.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this ActivityRate.

        Monetary value of this rate. Either hourly value or flat rate value

        :param rate: The rate of this ActivityRate.
        :type rate: float
        """

        self._rate = rate

    @property
    def flat_rate(self):
        """Gets the flat_rate of this ActivityRate.

        Whether this is a flat rate

        :return: The flat_rate of this ActivityRate.
        :rtype: bool
        """
        return self._flat_rate

    @flat_rate.setter
    def flat_rate(self, flat_rate):
        """Sets the flat_rate of this ActivityRate.

        Whether this is a flat rate

        :param flat_rate: The flat_rate of this ActivityRate.
        :type flat_rate: bool
        """

        self._flat_rate = flat_rate

    @property
    def created_at(self):
        """Gets the created_at of this ActivityRate.

        The time the *ActivityRate* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ActivityRate.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ActivityRate.

        The time the *ActivityRate* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ActivityRate.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ActivityRate.

        The time the *ActivityRate* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ActivityRate.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ActivityRate.

        The time the *ActivityRate* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ActivityRate.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def contact_id(self):
        """Gets the contact_id of this ActivityRate.

        Filter ActivityRate records for the contact.

        :return: The contact_id of this ActivityRate.
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this ActivityRate.

        Filter ActivityRate records for the contact.

        :param contact_id: The contact_id of this ActivityRate.
        :type contact_id: int
        """

        self._contact_id = contact_id

    @property
    def co_counsel_contact_id(self):
        """Gets the co_counsel_contact_id of this ActivityRate.

        Filter ActivityRate records for the co-counsel.

        :return: The co_counsel_contact_id of this ActivityRate.
        :rtype: int
        """
        return self._co_counsel_contact_id

    @co_counsel_contact_id.setter
    def co_counsel_contact_id(self, co_counsel_contact_id):
        """Sets the co_counsel_contact_id of this ActivityRate.

        Filter ActivityRate records for the co-counsel.

        :param co_counsel_contact_id: The co_counsel_contact_id of this ActivityRate.
        :type co_counsel_contact_id: int
        """

        self._co_counsel_contact_id = co_counsel_contact_id

    @property
    def user(self):
        """Gets the user of this ActivityRate.


        :return: The user of this ActivityRate.
        :rtype: UserBase
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this ActivityRate.


        :param user: The user of this ActivityRate.
        :type user: UserBase
        """

        self._user = user

    @property
    def group(self):
        """Gets the group of this ActivityRate.


        :return: The group of this ActivityRate.
        :rtype: GroupBase
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this ActivityRate.


        :param group: The group of this ActivityRate.
        :type group: GroupBase
        """

        self._group = group
