# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.bill_recipient_contact_base import BillRecipientContactBase
from openapi_server import util


class BillRecipient(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, created_at: datetime=None, etag: str=None, id: int=None, on_all_matters: bool=None, updated_at: datetime=None, recipient: BillRecipientContactBase=None):
        """BillRecipient - a model defined in OpenAPI

        :param created_at: The created_at of this BillRecipient.
        :param etag: The etag of this BillRecipient.
        :param id: The id of this BillRecipient.
        :param on_all_matters: The on_all_matters of this BillRecipient.
        :param updated_at: The updated_at of this BillRecipient.
        :param recipient: The recipient of this BillRecipient.
        """
        self.openapi_types = {
            'created_at': datetime,
            'etag': str,
            'id': int,
            'on_all_matters': bool,
            'updated_at': datetime,
            'recipient': BillRecipientContactBase
        }

        self.attribute_map = {
            'created_at': 'created_at',
            'etag': 'etag',
            'id': 'id',
            'on_all_matters': 'on_all_matters',
            'updated_at': 'updated_at',
            'recipient': 'recipient'
        }

        self._created_at = created_at
        self._etag = etag
        self._id = id
        self._on_all_matters = on_all_matters
        self._updated_at = updated_at
        self._recipient = recipient

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BillRecipient':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The BillRecipient of this BillRecipient.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def created_at(self):
        """Gets the created_at of this BillRecipient.

        The time the *BillRecipient* was created (as a ISO-8601 timestamp)

        :return: The created_at of this BillRecipient.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this BillRecipient.

        The time the *BillRecipient* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this BillRecipient.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def etag(self):
        """Gets the etag of this BillRecipient.

        ETag for the *BillRecipient*

        :return: The etag of this BillRecipient.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this BillRecipient.

        ETag for the *BillRecipient*

        :param etag: The etag of this BillRecipient.
        :type etag: str
        """

        self._etag = etag

    @property
    def id(self):
        """Gets the id of this BillRecipient.

        Unique identifier for the *BillRecipient*

        :return: The id of this BillRecipient.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this BillRecipient.

        Unique identifier for the *BillRecipient*

        :param id: The id of this BillRecipient.
        :type id: int
        """

        self._id = id

    @property
    def on_all_matters(self):
        """Gets the on_all_matters of this BillRecipient.

        If the associated contact is a recipient for all of the bill's matters

        :return: The on_all_matters of this BillRecipient.
        :rtype: bool
        """
        return self._on_all_matters

    @on_all_matters.setter
    def on_all_matters(self, on_all_matters):
        """Sets the on_all_matters of this BillRecipient.

        If the associated contact is a recipient for all of the bill's matters

        :param on_all_matters: The on_all_matters of this BillRecipient.
        :type on_all_matters: bool
        """

        self._on_all_matters = on_all_matters

    @property
    def updated_at(self):
        """Gets the updated_at of this BillRecipient.

        The time the *BillRecipient* was updated (as a ISO-8601 timestamp)

        :return: The updated_at of this BillRecipient.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this BillRecipient.

        The time the *BillRecipient* was updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this BillRecipient.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def recipient(self):
        """Gets the recipient of this BillRecipient.


        :return: The recipient of this BillRecipient.
        :rtype: BillRecipientContactBase
        """
        return self._recipient

    @recipient.setter
    def recipient(self, recipient):
        """Sets the recipient of this BillRecipient.


        :param recipient: The recipient of this BillRecipient.
        :type recipient: BillRecipientContactBase
        """

        self._recipient = recipient
