# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class BillTheme(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, account_id: int=None, default: bool=None, name: str=None, config: str=None):
        """BillTheme - a model defined in OpenAPI

        :param id: The id of this BillTheme.
        :param etag: The etag of this BillTheme.
        :param created_at: The created_at of this BillTheme.
        :param updated_at: The updated_at of this BillTheme.
        :param account_id: The account_id of this BillTheme.
        :param default: The default of this BillTheme.
        :param name: The name of this BillTheme.
        :param config: The config of this BillTheme.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'account_id': int,
            'default': bool,
            'name': str,
            'config': str
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'account_id': 'account_id',
            'default': 'default',
            'name': 'name',
            'config': 'config'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._account_id = account_id
        self._default = default
        self._name = name
        self._config = config

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BillTheme':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The BillTheme of this BillTheme.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this BillTheme.

        Unique identifier for the *BillTheme*

        :return: The id of this BillTheme.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this BillTheme.

        Unique identifier for the *BillTheme*

        :param id: The id of this BillTheme.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this BillTheme.

        ETag for the *BillTheme*

        :return: The etag of this BillTheme.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this BillTheme.

        ETag for the *BillTheme*

        :param etag: The etag of this BillTheme.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this BillTheme.

        The time the *BillTheme* was created (as a ISO-8601 timestamp)

        :return: The created_at of this BillTheme.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this BillTheme.

        The time the *BillTheme* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this BillTheme.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this BillTheme.

        The time the *BillTheme* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this BillTheme.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this BillTheme.

        The time the *BillTheme* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this BillTheme.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def account_id(self):
        """Gets the account_id of this BillTheme.

        The account number the *BillTheme* belongs to

        :return: The account_id of this BillTheme.
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this BillTheme.

        The account number the *BillTheme* belongs to

        :param account_id: The account_id of this BillTheme.
        :type account_id: int
        """

        self._account_id = account_id

    @property
    def default(self):
        """Gets the default of this BillTheme.

        Whether the *BillTheme* is the default for its account

        :return: The default of this BillTheme.
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this BillTheme.

        Whether the *BillTheme* is the default for its account

        :param default: The default of this BillTheme.
        :type default: bool
        """

        self._default = default

    @property
    def name(self):
        """Gets the name of this BillTheme.

        The name of the *BillTheme*

        :return: The name of this BillTheme.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BillTheme.

        The name of the *BillTheme*

        :param name: The name of this BillTheme.
        :type name: str
        """

        self._name = name

    @property
    def config(self):
        """Gets the config of this BillTheme.

        The configuration of the *BillTheme*

        :return: The config of this BillTheme.
        :rtype: str
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this BillTheme.

        The configuration of the *BillTheme*

        :param config: The config of this BillTheme.
        :type config: str
        """

        self._config = config
