# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class BillUpdateRequestDataDiscount(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, rate: float=None, type: str=None, note: str=None):
        """BillUpdateRequestDataDiscount - a model defined in OpenAPI

        :param rate: The rate of this BillUpdateRequestDataDiscount.
        :param type: The type of this BillUpdateRequestDataDiscount.
        :param note: The note of this BillUpdateRequestDataDiscount.
        """
        self.openapi_types = {
            'rate': float,
            'type': str,
            'note': str
        }

        self.attribute_map = {
            'rate': 'rate',
            'type': 'type',
            'note': 'note'
        }

        self._rate = rate
        self._type = type
        self._note = note

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BillUpdateRequestDataDiscount':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Bill_update_request_data_discount of this BillUpdateRequestDataDiscount.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def rate(self):
        """Gets the rate of this BillUpdateRequestDataDiscount.

        Discount amount for the Bill. This can either be a percentage or monetary value, this is determined by the `discount[type]`.

        :return: The rate of this BillUpdateRequestDataDiscount.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this BillUpdateRequestDataDiscount.

        Discount amount for the Bill. This can either be a percentage or monetary value, this is determined by the `discount[type]`.

        :param rate: The rate of this BillUpdateRequestDataDiscount.
        :type rate: float
        """

        self._rate = rate

    @property
    def type(self):
        """Gets the type of this BillUpdateRequestDataDiscount.

        The type of discount you are applying to your Bill with the `discount[rate]`.

        :return: The type of this BillUpdateRequestDataDiscount.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this BillUpdateRequestDataDiscount.

        The type of discount you are applying to your Bill with the `discount[rate]`.

        :param type: The type of this BillUpdateRequestDataDiscount.
        :type type: str
        """
        allowed_values = ["percentage", "money"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def note(self):
        """Gets the note of this BillUpdateRequestDataDiscount.

        A note for your Bill's discount.

        :return: The note of this BillUpdateRequestDataDiscount.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this BillUpdateRequestDataDiscount.

        A note for your Bill's discount.

        :param note: The note of this BillUpdateRequestDataDiscount.
        :type note: str
        """

        self._note = note
