# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class BillUpdateRequestDataInterest(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, rate: float=None, type: str=None, period: int=None):
        """BillUpdateRequestDataInterest - a model defined in OpenAPI

        :param rate: The rate of this BillUpdateRequestDataInterest.
        :param type: The type of this BillUpdateRequestDataInterest.
        :param period: The period of this BillUpdateRequestDataInterest.
        """
        self.openapi_types = {
            'rate': float,
            'type': str,
            'period': int
        }

        self.attribute_map = {
            'rate': 'rate',
            'type': 'type',
            'period': 'period'
        }

        self._rate = rate
        self._type = type
        self._period = period

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BillUpdateRequestDataInterest':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Bill_update_request_data_interest of this BillUpdateRequestDataInterest.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def rate(self):
        """Gets the rate of this BillUpdateRequestDataInterest.

        Interest amount for the Bill as percentage.

        :return: The rate of this BillUpdateRequestDataInterest.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this BillUpdateRequestDataInterest.

        Interest amount for the Bill as percentage.

        :param rate: The rate of this BillUpdateRequestDataInterest.
        :type rate: float
        """

        self._rate = rate

    @property
    def type(self):
        """Gets the type of this BillUpdateRequestDataInterest.

        The type of interest you are applying to your Bill with the `interest[rate]`.

        :return: The type of this BillUpdateRequestDataInterest.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this BillUpdateRequestDataInterest.

        The type of interest you are applying to your Bill with the `interest[rate]`.

        :param type: The type of this BillUpdateRequestDataInterest.
        :type type: str
        """
        allowed_values = ["simple", "compound"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def period(self):
        """Gets the period of this BillUpdateRequestDataInterest.

        The interest period for how frequently your Bill will charge interest.

        :return: The period of this BillUpdateRequestDataInterest.
        :rtype: int
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this BillUpdateRequestDataInterest.

        The interest period for how frequently your Bill will charge interest.

        :param period: The period of this BillUpdateRequestDataInterest.
        :type period: int
        """

        self._period = period
