# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class BillableClientBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, unbilled_hours: float=None, unbilled_amount: float=None, amount_in_trust: float=None, name: str=None, billable_matters_count: int=None):
        """BillableClientBase - a model defined in OpenAPI

        :param id: The id of this BillableClientBase.
        :param unbilled_hours: The unbilled_hours of this BillableClientBase.
        :param unbilled_amount: The unbilled_amount of this BillableClientBase.
        :param amount_in_trust: The amount_in_trust of this BillableClientBase.
        :param name: The name of this BillableClientBase.
        :param billable_matters_count: The billable_matters_count of this BillableClientBase.
        """
        self.openapi_types = {
            'id': int,
            'unbilled_hours': float,
            'unbilled_amount': float,
            'amount_in_trust': float,
            'name': str,
            'billable_matters_count': int
        }

        self.attribute_map = {
            'id': 'id',
            'unbilled_hours': 'unbilled_hours',
            'unbilled_amount': 'unbilled_amount',
            'amount_in_trust': 'amount_in_trust',
            'name': 'name',
            'billable_matters_count': 'billable_matters_count'
        }

        self._id = id
        self._unbilled_hours = unbilled_hours
        self._unbilled_amount = unbilled_amount
        self._amount_in_trust = amount_in_trust
        self._name = name
        self._billable_matters_count = billable_matters_count

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BillableClientBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The BillableClient_base of this BillableClientBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this BillableClientBase.

        Unique identifier for the *BillableClient*

        :return: The id of this BillableClientBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this BillableClientBase.

        Unique identifier for the *BillableClient*

        :param id: The id of this BillableClientBase.
        :type id: int
        """

        self._id = id

    @property
    def unbilled_hours(self):
        """Gets the unbilled_hours of this BillableClientBase.

        The unbilled hours of  the client

        :return: The unbilled_hours of this BillableClientBase.
        :rtype: float
        """
        return self._unbilled_hours

    @unbilled_hours.setter
    def unbilled_hours(self, unbilled_hours):
        """Sets the unbilled_hours of this BillableClientBase.

        The unbilled hours of  the client

        :param unbilled_hours: The unbilled_hours of this BillableClientBase.
        :type unbilled_hours: float
        """

        self._unbilled_hours = unbilled_hours

    @property
    def unbilled_amount(self):
        """Gets the unbilled_amount of this BillableClientBase.

        The unbilled amount of the client

        :return: The unbilled_amount of this BillableClientBase.
        :rtype: float
        """
        return self._unbilled_amount

    @unbilled_amount.setter
    def unbilled_amount(self, unbilled_amount):
        """Sets the unbilled_amount of this BillableClientBase.

        The unbilled amount of the client

        :param unbilled_amount: The unbilled_amount of this BillableClientBase.
        :type unbilled_amount: float
        """

        self._unbilled_amount = unbilled_amount

    @property
    def amount_in_trust(self):
        """Gets the amount_in_trust of this BillableClientBase.

        The trust amount available for the client

        :return: The amount_in_trust of this BillableClientBase.
        :rtype: float
        """
        return self._amount_in_trust

    @amount_in_trust.setter
    def amount_in_trust(self, amount_in_trust):
        """Sets the amount_in_trust of this BillableClientBase.

        The trust amount available for the client

        :param amount_in_trust: The amount_in_trust of this BillableClientBase.
        :type amount_in_trust: float
        """

        self._amount_in_trust = amount_in_trust

    @property
    def name(self):
        """Gets the name of this BillableClientBase.

        The name of the Client

        :return: The name of this BillableClientBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BillableClientBase.

        The name of the Client

        :param name: The name of this BillableClientBase.
        :type name: str
        """

        self._name = name

    @property
    def billable_matters_count(self):
        """Gets the billable_matters_count of this BillableClientBase.

        The total number of billable matters the client has

        :return: The billable_matters_count of this BillableClientBase.
        :rtype: int
        """
        return self._billable_matters_count

    @billable_matters_count.setter
    def billable_matters_count(self, billable_matters_count):
        """Sets the billable_matters_count of this BillableClientBase.

        The total number of billable matters the client has

        :param billable_matters_count: The billable_matters_count of this BillableClientBase.
        :type billable_matters_count: int
        """

        self._billable_matters_count = billable_matters_count
