# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.user_base import UserBase
from openapi_server import util


class Calendar(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, color: str=None, light_color: str=None, court_rules_default_calendar: bool=None, name: str=None, permission: str=None, type: str=None, visible: bool=None, created_at: datetime=None, updated_at: datetime=None, source: str=None, creator: UserBase=None):
        """Calendar - a model defined in OpenAPI

        :param id: The id of this Calendar.
        :param etag: The etag of this Calendar.
        :param color: The color of this Calendar.
        :param light_color: The light_color of this Calendar.
        :param court_rules_default_calendar: The court_rules_default_calendar of this Calendar.
        :param name: The name of this Calendar.
        :param permission: The permission of this Calendar.
        :param type: The type of this Calendar.
        :param visible: The visible of this Calendar.
        :param created_at: The created_at of this Calendar.
        :param updated_at: The updated_at of this Calendar.
        :param source: The source of this Calendar.
        :param creator: The creator of this Calendar.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'color': str,
            'light_color': str,
            'court_rules_default_calendar': bool,
            'name': str,
            'permission': str,
            'type': str,
            'visible': bool,
            'created_at': datetime,
            'updated_at': datetime,
            'source': str,
            'creator': UserBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'color': 'color',
            'light_color': 'light_color',
            'court_rules_default_calendar': 'court_rules_default_calendar',
            'name': 'name',
            'permission': 'permission',
            'type': 'type',
            'visible': 'visible',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'source': 'source',
            'creator': 'creator'
        }

        self._id = id
        self._etag = etag
        self._color = color
        self._light_color = light_color
        self._court_rules_default_calendar = court_rules_default_calendar
        self._name = name
        self._permission = permission
        self._type = type
        self._visible = visible
        self._created_at = created_at
        self._updated_at = updated_at
        self._source = source
        self._creator = creator

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Calendar':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Calendar of this Calendar.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Calendar.

        Unique identifier for the *Calendar*

        :return: The id of this Calendar.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Calendar.

        Unique identifier for the *Calendar*

        :param id: The id of this Calendar.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Calendar.

        ETag for the *Calendar*

        :return: The etag of this Calendar.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Calendar.

        ETag for the *Calendar*

        :param etag: The etag of this Calendar.
        :type etag: str
        """

        self._etag = etag

    @property
    def color(self):
        """Gets the color of this Calendar.

        Color

        :return: The color of this Calendar.
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this Calendar.

        Color

        :param color: The color of this Calendar.
        :type color: str
        """
        allowed_values = ["#367B9C", "#FFA5A4", "#83D17F", "#FFAC7B", "#8E3F64", "#C75300", "#009CEC", "#62D6B1", "#9EEDCB", "#F9A2C4", "#616161", "#BBDA81", "#DFD3F8", "#D6C4A5", "#FFD478", "#6AC9DE", "#EABBB0", "#BFC2E1", "#DADADA", "#CDE2F5"]  # noqa: E501
        if color not in allowed_values:
            raise ValueError(
                "Invalid value for `color` ({0}), must be one of {1}"
                .format(color, allowed_values)
            )

        self._color = color

    @property
    def light_color(self):
        """Gets the light_color of this Calendar.

        Accent color to complement the main calendar color.

        :return: The light_color of this Calendar.
        :rtype: str
        """
        return self._light_color

    @light_color.setter
    def light_color(self, light_color):
        """Sets the light_color of this Calendar.

        Accent color to complement the main calendar color.

        :param light_color: The light_color of this Calendar.
        :type light_color: str
        """
        allowed_values = ["#5DA5C7", "#F95957", "#209412", "#FF7715", "#DE649D", "#FF6B02", "#56C4FC", "#00B177", "#50D19B", "#F14A8C", "#A3A2A2", "#84AB3B", "#B091EE", "#BD9E69", "#F2A000", "#00A5CA", "#CB5A3D", "#959CD0", "#B0B0B0", "#7BA6CD"]  # noqa: E501
        if light_color not in allowed_values:
            raise ValueError(
                "Invalid value for `light_color` ({0}), must be one of {1}"
                .format(light_color, allowed_values)
            )

        self._light_color = light_color

    @property
    def court_rules_default_calendar(self):
        """Gets the court_rules_default_calendar of this Calendar.

        Whether the calendar is default court rules calendar for current user

        :return: The court_rules_default_calendar of this Calendar.
        :rtype: bool
        """
        return self._court_rules_default_calendar

    @court_rules_default_calendar.setter
    def court_rules_default_calendar(self, court_rules_default_calendar):
        """Sets the court_rules_default_calendar of this Calendar.

        Whether the calendar is default court rules calendar for current user

        :param court_rules_default_calendar: The court_rules_default_calendar of this Calendar.
        :type court_rules_default_calendar: bool
        """

        self._court_rules_default_calendar = court_rules_default_calendar

    @property
    def name(self):
        """Gets the name of this Calendar.

        The name of the *Calendar*

        :return: The name of this Calendar.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Calendar.

        The name of the *Calendar*

        :param name: The name of this Calendar.
        :type name: str
        """

        self._name = name

    @property
    def permission(self):
        """Gets the permission of this Calendar.

        The user's permission to the *Calendar*

        :return: The permission of this Calendar.
        :rtype: str
        """
        return self._permission

    @permission.setter
    def permission(self, permission):
        """Sets the permission of this Calendar.

        The user's permission to the *Calendar*

        :param permission: The permission of this Calendar.
        :type permission: str
        """
        allowed_values = ["owner", "editor", "viewer", "limited_viewer", "none"]  # noqa: E501
        if permission not in allowed_values:
            raise ValueError(
                "Invalid value for `permission` ({0}), must be one of {1}"
                .format(permission, allowed_values)
            )

        self._permission = permission

    @property
    def type(self):
        """Gets the type of this Calendar.

        The type of the *Calendar*

        :return: The type of this Calendar.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Calendar.

        The type of the *Calendar*

        :param type: The type of this Calendar.
        :type type: str
        """
        allowed_values = ["AccountCalendar", "AdhocCalendar", "UserCalendar"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def visible(self):
        """Gets the visible of this Calendar.

        Whether the *Calendar* will be shown by default in the Clio Web UI (assuming no source is provided).

        :return: The visible of this Calendar.
        :rtype: bool
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this Calendar.

        Whether the *Calendar* will be shown by default in the Clio Web UI (assuming no source is provided).

        :param visible: The visible of this Calendar.
        :type visible: bool
        """

        self._visible = visible

    @property
    def created_at(self):
        """Gets the created_at of this Calendar.

        The time the *Calendar* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Calendar.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Calendar.

        The time the *Calendar* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Calendar.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Calendar.

        The time the *Calendar* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Calendar.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Calendar.

        The time the *Calendar* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Calendar.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def source(self):
        """Gets the source of this Calendar.

        The source that visible applies to, by default the Clio Web UI (Expects 'mobile' or 'web').

        :return: The source of this Calendar.
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this Calendar.

        The source that visible applies to, by default the Clio Web UI (Expects 'mobile' or 'web').

        :param source: The source of this Calendar.
        :type source: str
        """
        allowed_values = ["web", "mobile"]  # noqa: E501
        if source not in allowed_values:
            raise ValueError(
                "Invalid value for `source` ({0}), must be one of {1}"
                .format(source, allowed_values)
            )

        self._source = source

    @property
    def creator(self):
        """Gets the creator of this Calendar.


        :return: The creator of this Calendar.
        :rtype: UserBase
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this Calendar.


        :param creator: The creator of this Calendar.
        :type creator: UserBase
        """

        self._creator = creator
