# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.activity_base import ActivityBase
from openapi_server.models.attendee_base import AttendeeBase
from openapi_server.models.calendar_base import CalendarBase
from openapi_server.models.calendar_entry_base import CalendarEntryBase
from openapi_server.models.calendar_entry_event_type_base import CalendarEntryEventTypeBase
from openapi_server.models.conference_meeting_base import ConferenceMeetingBase
from openapi_server.models.external_property_base import ExternalPropertyBase
from openapi_server.models.matter_base import MatterBase
from openapi_server.models.matter_docket_base import MatterDocketBase
from openapi_server.models.reminder_base import ReminderBase
from openapi_server import util


class CalendarEntry(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: str=None, etag: str=None, summary: str=None, description: str=None, location: str=None, start_at: datetime=None, end_at: datetime=None, all_day: bool=None, recurrence_rule: str=None, parent_calendar_entry_id: int=None, court_rule: bool=None, created_at: datetime=None, updated_at: datetime=None, permission: str=None, calendar_owner_id: int=None, start_at_time_zone: str=None, time_entries_count: int=None, time_entries: List[ActivityBase]=None, conference_meeting: ConferenceMeetingBase=None, matter: MatterBase=None, matter_docket: MatterDocketBase=None, calendar_owner: CalendarBase=None, parent_calendar_entry: CalendarEntryBase=None, calendar_entry_event_type: CalendarEntryEventTypeBase=None, attendees: List[AttendeeBase]=None, calendars: List[CalendarBase]=None, reminders: List[ReminderBase]=None, external_properties: List[ExternalPropertyBase]=None):
        """CalendarEntry - a model defined in OpenAPI

        :param id: The id of this CalendarEntry.
        :param etag: The etag of this CalendarEntry.
        :param summary: The summary of this CalendarEntry.
        :param description: The description of this CalendarEntry.
        :param location: The location of this CalendarEntry.
        :param start_at: The start_at of this CalendarEntry.
        :param end_at: The end_at of this CalendarEntry.
        :param all_day: The all_day of this CalendarEntry.
        :param recurrence_rule: The recurrence_rule of this CalendarEntry.
        :param parent_calendar_entry_id: The parent_calendar_entry_id of this CalendarEntry.
        :param court_rule: The court_rule of this CalendarEntry.
        :param created_at: The created_at of this CalendarEntry.
        :param updated_at: The updated_at of this CalendarEntry.
        :param permission: The permission of this CalendarEntry.
        :param calendar_owner_id: The calendar_owner_id of this CalendarEntry.
        :param start_at_time_zone: The start_at_time_zone of this CalendarEntry.
        :param time_entries_count: The time_entries_count of this CalendarEntry.
        :param time_entries: The time_entries of this CalendarEntry.
        :param conference_meeting: The conference_meeting of this CalendarEntry.
        :param matter: The matter of this CalendarEntry.
        :param matter_docket: The matter_docket of this CalendarEntry.
        :param calendar_owner: The calendar_owner of this CalendarEntry.
        :param parent_calendar_entry: The parent_calendar_entry of this CalendarEntry.
        :param calendar_entry_event_type: The calendar_entry_event_type of this CalendarEntry.
        :param attendees: The attendees of this CalendarEntry.
        :param calendars: The calendars of this CalendarEntry.
        :param reminders: The reminders of this CalendarEntry.
        :param external_properties: The external_properties of this CalendarEntry.
        """
        self.openapi_types = {
            'id': str,
            'etag': str,
            'summary': str,
            'description': str,
            'location': str,
            'start_at': datetime,
            'end_at': datetime,
            'all_day': bool,
            'recurrence_rule': str,
            'parent_calendar_entry_id': int,
            'court_rule': bool,
            'created_at': datetime,
            'updated_at': datetime,
            'permission': str,
            'calendar_owner_id': int,
            'start_at_time_zone': str,
            'time_entries_count': int,
            'time_entries': List[ActivityBase],
            'conference_meeting': ConferenceMeetingBase,
            'matter': MatterBase,
            'matter_docket': MatterDocketBase,
            'calendar_owner': CalendarBase,
            'parent_calendar_entry': CalendarEntryBase,
            'calendar_entry_event_type': CalendarEntryEventTypeBase,
            'attendees': List[AttendeeBase],
            'calendars': List[CalendarBase],
            'reminders': List[ReminderBase],
            'external_properties': List[ExternalPropertyBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'summary': 'summary',
            'description': 'description',
            'location': 'location',
            'start_at': 'start_at',
            'end_at': 'end_at',
            'all_day': 'all_day',
            'recurrence_rule': 'recurrence_rule',
            'parent_calendar_entry_id': 'parent_calendar_entry_id',
            'court_rule': 'court_rule',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'permission': 'permission',
            'calendar_owner_id': 'calendar_owner_id',
            'start_at_time_zone': 'start_at_time_zone',
            'time_entries_count': 'time_entries_count',
            'time_entries': 'time_entries',
            'conference_meeting': 'conference_meeting',
            'matter': 'matter',
            'matter_docket': 'matter_docket',
            'calendar_owner': 'calendar_owner',
            'parent_calendar_entry': 'parent_calendar_entry',
            'calendar_entry_event_type': 'calendar_entry_event_type',
            'attendees': 'attendees',
            'calendars': 'calendars',
            'reminders': 'reminders',
            'external_properties': 'external_properties'
        }

        self._id = id
        self._etag = etag
        self._summary = summary
        self._description = description
        self._location = location
        self._start_at = start_at
        self._end_at = end_at
        self._all_day = all_day
        self._recurrence_rule = recurrence_rule
        self._parent_calendar_entry_id = parent_calendar_entry_id
        self._court_rule = court_rule
        self._created_at = created_at
        self._updated_at = updated_at
        self._permission = permission
        self._calendar_owner_id = calendar_owner_id
        self._start_at_time_zone = start_at_time_zone
        self._time_entries_count = time_entries_count
        self._time_entries = time_entries
        self._conference_meeting = conference_meeting
        self._matter = matter
        self._matter_docket = matter_docket
        self._calendar_owner = calendar_owner
        self._parent_calendar_entry = parent_calendar_entry
        self._calendar_entry_event_type = calendar_entry_event_type
        self._attendees = attendees
        self._calendars = calendars
        self._reminders = reminders
        self._external_properties = external_properties

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CalendarEntry':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CalendarEntry of this CalendarEntry.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this CalendarEntry.

        Unique identifier for the *CalendarEntry*

        :return: The id of this CalendarEntry.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CalendarEntry.

        Unique identifier for the *CalendarEntry*

        :param id: The id of this CalendarEntry.
        :type id: str
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this CalendarEntry.

        ETag for the *CalendarEntry*

        :return: The etag of this CalendarEntry.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this CalendarEntry.

        ETag for the *CalendarEntry*

        :param etag: The etag of this CalendarEntry.
        :type etag: str
        """

        self._etag = etag

    @property
    def summary(self):
        """Gets the summary of this CalendarEntry.

        A short summary of the *CalendarEntry*

        :return: The summary of this CalendarEntry.
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this CalendarEntry.

        A short summary of the *CalendarEntry*

        :param summary: The summary of this CalendarEntry.
        :type summary: str
        """

        self._summary = summary

    @property
    def description(self):
        """Gets the description of this CalendarEntry.

        A detailed description of the *CalendarEntry*

        :return: The description of this CalendarEntry.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CalendarEntry.

        A detailed description of the *CalendarEntry*

        :param description: The description of this CalendarEntry.
        :type description: str
        """

        self._description = description

    @property
    def location(self):
        """Gets the location of this CalendarEntry.

        The geographic location of the *CalendarEntry*

        :return: The location of this CalendarEntry.
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this CalendarEntry.

        The geographic location of the *CalendarEntry*

        :param location: The location of this CalendarEntry.
        :type location: str
        """

        self._location = location

    @property
    def start_at(self):
        """Gets the start_at of this CalendarEntry.

        The time the *CalendarEntry* starts (as an ISO-8601 timestamp)

        :return: The start_at of this CalendarEntry.
        :rtype: datetime
        """
        return self._start_at

    @start_at.setter
    def start_at(self, start_at):
        """Sets the start_at of this CalendarEntry.

        The time the *CalendarEntry* starts (as an ISO-8601 timestamp)

        :param start_at: The start_at of this CalendarEntry.
        :type start_at: datetime
        """

        self._start_at = start_at

    @property
    def end_at(self):
        """Gets the end_at of this CalendarEntry.

        The time the *CalendarEntry* ends (as an ISO-8601 timestamp)

        :return: The end_at of this CalendarEntry.
        :rtype: datetime
        """
        return self._end_at

    @end_at.setter
    def end_at(self, end_at):
        """Sets the end_at of this CalendarEntry.

        The time the *CalendarEntry* ends (as an ISO-8601 timestamp)

        :param end_at: The end_at of this CalendarEntry.
        :type end_at: datetime
        """

        self._end_at = end_at

    @property
    def all_day(self):
        """Gets the all_day of this CalendarEntry.

        Whether the event is all day

        :return: The all_day of this CalendarEntry.
        :rtype: bool
        """
        return self._all_day

    @all_day.setter
    def all_day(self, all_day):
        """Sets the all_day of this CalendarEntry.

        Whether the event is all day

        :param all_day: The all_day of this CalendarEntry.
        :type all_day: bool
        """

        self._all_day = all_day

    @property
    def recurrence_rule(self):
        """Gets the recurrence_rule of this CalendarEntry.

        Recurrence rule for expanding

        :return: The recurrence_rule of this CalendarEntry.
        :rtype: str
        """
        return self._recurrence_rule

    @recurrence_rule.setter
    def recurrence_rule(self, recurrence_rule):
        """Sets the recurrence_rule of this CalendarEntry.

        Recurrence rule for expanding

        :param recurrence_rule: The recurrence_rule of this CalendarEntry.
        :type recurrence_rule: str
        """

        self._recurrence_rule = recurrence_rule

    @property
    def parent_calendar_entry_id(self):
        """Gets the parent_calendar_entry_id of this CalendarEntry.

        Identifier for the parent *CalendarEntry*

        :return: The parent_calendar_entry_id of this CalendarEntry.
        :rtype: int
        """
        return self._parent_calendar_entry_id

    @parent_calendar_entry_id.setter
    def parent_calendar_entry_id(self, parent_calendar_entry_id):
        """Sets the parent_calendar_entry_id of this CalendarEntry.

        Identifier for the parent *CalendarEntry*

        :param parent_calendar_entry_id: The parent_calendar_entry_id of this CalendarEntry.
        :type parent_calendar_entry_id: int
        """

        self._parent_calendar_entry_id = parent_calendar_entry_id

    @property
    def court_rule(self):
        """Gets the court_rule of this CalendarEntry.

        Whether this event is associated with a Court Rule

        :return: The court_rule of this CalendarEntry.
        :rtype: bool
        """
        return self._court_rule

    @court_rule.setter
    def court_rule(self, court_rule):
        """Sets the court_rule of this CalendarEntry.

        Whether this event is associated with a Court Rule

        :param court_rule: The court_rule of this CalendarEntry.
        :type court_rule: bool
        """

        self._court_rule = court_rule

    @property
    def created_at(self):
        """Gets the created_at of this CalendarEntry.

        The time the *CalendarEntry* was created (as a ISO-8601 timestamp)

        :return: The created_at of this CalendarEntry.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this CalendarEntry.

        The time the *CalendarEntry* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this CalendarEntry.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this CalendarEntry.

        The time the *CalendarEntry* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this CalendarEntry.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this CalendarEntry.

        The time the *CalendarEntry* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this CalendarEntry.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def permission(self):
        """Gets the permission of this CalendarEntry.

        The view permission for the current user, will return 'viewer' when permission is 'limited_viewer' and the user is an attendee.

        :return: The permission of this CalendarEntry.
        :rtype: str
        """
        return self._permission

    @permission.setter
    def permission(self, permission):
        """Sets the permission of this CalendarEntry.

        The view permission for the current user, will return 'viewer' when permission is 'limited_viewer' and the user is an attendee.

        :param permission: The permission of this CalendarEntry.
        :type permission: str
        """

        self._permission = permission

    @property
    def calendar_owner_id(self):
        """Gets the calendar_owner_id of this CalendarEntry.

        The id of the calendar owner.

        :return: The calendar_owner_id of this CalendarEntry.
        :rtype: int
        """
        return self._calendar_owner_id

    @calendar_owner_id.setter
    def calendar_owner_id(self, calendar_owner_id):
        """Sets the calendar_owner_id of this CalendarEntry.

        The id of the calendar owner.

        :param calendar_owner_id: The calendar_owner_id of this CalendarEntry.
        :type calendar_owner_id: int
        """

        self._calendar_owner_id = calendar_owner_id

    @property
    def start_at_time_zone(self):
        """Gets the start_at_time_zone of this CalendarEntry.

        Original start at time zone of the event.

        :return: The start_at_time_zone of this CalendarEntry.
        :rtype: str
        """
        return self._start_at_time_zone

    @start_at_time_zone.setter
    def start_at_time_zone(self, start_at_time_zone):
        """Sets the start_at_time_zone of this CalendarEntry.

        Original start at time zone of the event.

        :param start_at_time_zone: The start_at_time_zone of this CalendarEntry.
        :type start_at_time_zone: str
        """

        self._start_at_time_zone = start_at_time_zone

    @property
    def time_entries_count(self):
        """Gets the time_entries_count of this CalendarEntry.

        The number of `TimeEntry` activities associated with the *CalendarEntry*

        :return: The time_entries_count of this CalendarEntry.
        :rtype: int
        """
        return self._time_entries_count

    @time_entries_count.setter
    def time_entries_count(self, time_entries_count):
        """Sets the time_entries_count of this CalendarEntry.

        The number of `TimeEntry` activities associated with the *CalendarEntry*

        :param time_entries_count: The time_entries_count of this CalendarEntry.
        :type time_entries_count: int
        """

        self._time_entries_count = time_entries_count

    @property
    def time_entries(self):
        """Gets the time_entries of this CalendarEntry.

        Activity

        :return: The time_entries of this CalendarEntry.
        :rtype: List[ActivityBase]
        """
        return self._time_entries

    @time_entries.setter
    def time_entries(self, time_entries):
        """Sets the time_entries of this CalendarEntry.

        Activity

        :param time_entries: The time_entries of this CalendarEntry.
        :type time_entries: List[ActivityBase]
        """

        self._time_entries = time_entries

    @property
    def conference_meeting(self):
        """Gets the conference_meeting of this CalendarEntry.


        :return: The conference_meeting of this CalendarEntry.
        :rtype: ConferenceMeetingBase
        """
        return self._conference_meeting

    @conference_meeting.setter
    def conference_meeting(self, conference_meeting):
        """Sets the conference_meeting of this CalendarEntry.


        :param conference_meeting: The conference_meeting of this CalendarEntry.
        :type conference_meeting: ConferenceMeetingBase
        """

        self._conference_meeting = conference_meeting

    @property
    def matter(self):
        """Gets the matter of this CalendarEntry.


        :return: The matter of this CalendarEntry.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this CalendarEntry.


        :param matter: The matter of this CalendarEntry.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def matter_docket(self):
        """Gets the matter_docket of this CalendarEntry.


        :return: The matter_docket of this CalendarEntry.
        :rtype: MatterDocketBase
        """
        return self._matter_docket

    @matter_docket.setter
    def matter_docket(self, matter_docket):
        """Sets the matter_docket of this CalendarEntry.


        :param matter_docket: The matter_docket of this CalendarEntry.
        :type matter_docket: MatterDocketBase
        """

        self._matter_docket = matter_docket

    @property
    def calendar_owner(self):
        """Gets the calendar_owner of this CalendarEntry.


        :return: The calendar_owner of this CalendarEntry.
        :rtype: CalendarBase
        """
        return self._calendar_owner

    @calendar_owner.setter
    def calendar_owner(self, calendar_owner):
        """Sets the calendar_owner of this CalendarEntry.


        :param calendar_owner: The calendar_owner of this CalendarEntry.
        :type calendar_owner: CalendarBase
        """

        self._calendar_owner = calendar_owner

    @property
    def parent_calendar_entry(self):
        """Gets the parent_calendar_entry of this CalendarEntry.


        :return: The parent_calendar_entry of this CalendarEntry.
        :rtype: CalendarEntryBase
        """
        return self._parent_calendar_entry

    @parent_calendar_entry.setter
    def parent_calendar_entry(self, parent_calendar_entry):
        """Sets the parent_calendar_entry of this CalendarEntry.


        :param parent_calendar_entry: The parent_calendar_entry of this CalendarEntry.
        :type parent_calendar_entry: CalendarEntryBase
        """

        self._parent_calendar_entry = parent_calendar_entry

    @property
    def calendar_entry_event_type(self):
        """Gets the calendar_entry_event_type of this CalendarEntry.


        :return: The calendar_entry_event_type of this CalendarEntry.
        :rtype: CalendarEntryEventTypeBase
        """
        return self._calendar_entry_event_type

    @calendar_entry_event_type.setter
    def calendar_entry_event_type(self, calendar_entry_event_type):
        """Sets the calendar_entry_event_type of this CalendarEntry.


        :param calendar_entry_event_type: The calendar_entry_event_type of this CalendarEntry.
        :type calendar_entry_event_type: CalendarEntryEventTypeBase
        """

        self._calendar_entry_event_type = calendar_entry_event_type

    @property
    def attendees(self):
        """Gets the attendees of this CalendarEntry.

        Attendee

        :return: The attendees of this CalendarEntry.
        :rtype: List[AttendeeBase]
        """
        return self._attendees

    @attendees.setter
    def attendees(self, attendees):
        """Sets the attendees of this CalendarEntry.

        Attendee

        :param attendees: The attendees of this CalendarEntry.
        :type attendees: List[AttendeeBase]
        """

        self._attendees = attendees

    @property
    def calendars(self):
        """Gets the calendars of this CalendarEntry.

        Calendar

        :return: The calendars of this CalendarEntry.
        :rtype: List[CalendarBase]
        """
        return self._calendars

    @calendars.setter
    def calendars(self, calendars):
        """Sets the calendars of this CalendarEntry.

        Calendar

        :param calendars: The calendars of this CalendarEntry.
        :type calendars: List[CalendarBase]
        """

        self._calendars = calendars

    @property
    def reminders(self):
        """Gets the reminders of this CalendarEntry.

        Reminder

        :return: The reminders of this CalendarEntry.
        :rtype: List[ReminderBase]
        """
        return self._reminders

    @reminders.setter
    def reminders(self, reminders):
        """Sets the reminders of this CalendarEntry.

        Reminder

        :param reminders: The reminders of this CalendarEntry.
        :type reminders: List[ReminderBase]
        """

        self._reminders = reminders

    @property
    def external_properties(self):
        """Gets the external_properties of this CalendarEntry.

        ExternalProperty

        :return: The external_properties of this CalendarEntry.
        :rtype: List[ExternalPropertyBase]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this CalendarEntry.

        ExternalProperty

        :param external_properties: The external_properties of this CalendarEntry.
        :type external_properties: List[ExternalPropertyBase]
        """

        self._external_properties = external_properties
