# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.calendar_entry_create_request_data_attendees_inner import CalendarEntryCreateRequestDataAttendeesInner
from openapi_server.models.calendar_entry_create_request_data_calendar_entry_event_type import CalendarEntryCreateRequestDataCalendarEntryEventType
from openapi_server.models.calendar_entry_create_request_data_conference_meeting import CalendarEntryCreateRequestDataConferenceMeeting
from openapi_server.models.calendar_entry_create_request_data_matter import CalendarEntryCreateRequestDataMatter
from openapi_server.models.calendar_entry_update_request_data_calendar_owner import CalendarEntryUpdateRequestDataCalendarOwner
from openapi_server.models.calendar_entry_update_request_data_external_properties_inner import CalendarEntryUpdateRequestDataExternalPropertiesInner
from openapi_server import util


class CalendarEntryUpdateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, deleted: str=None, all_day: bool=None, attendees: List[CalendarEntryCreateRequestDataAttendeesInner]=None, calendar_entry_event_type: CalendarEntryCreateRequestDataCalendarEntryEventType=None, calendar_owner: CalendarEntryUpdateRequestDataCalendarOwner=None, conference_meeting: CalendarEntryCreateRequestDataConferenceMeeting=None, description: str=None, end_at: datetime=None, external_properties: List[CalendarEntryUpdateRequestDataExternalPropertiesInner]=None, location: str=None, matter: CalendarEntryCreateRequestDataMatter=None, recurrence_rule: str=None, send_email_notification: bool=None, start_at: datetime=None, summary: str=None):
        """CalendarEntryUpdateRequestData - a model defined in OpenAPI

        :param deleted: The deleted of this CalendarEntryUpdateRequestData.
        :param all_day: The all_day of this CalendarEntryUpdateRequestData.
        :param attendees: The attendees of this CalendarEntryUpdateRequestData.
        :param calendar_entry_event_type: The calendar_entry_event_type of this CalendarEntryUpdateRequestData.
        :param calendar_owner: The calendar_owner of this CalendarEntryUpdateRequestData.
        :param conference_meeting: The conference_meeting of this CalendarEntryUpdateRequestData.
        :param description: The description of this CalendarEntryUpdateRequestData.
        :param end_at: The end_at of this CalendarEntryUpdateRequestData.
        :param external_properties: The external_properties of this CalendarEntryUpdateRequestData.
        :param location: The location of this CalendarEntryUpdateRequestData.
        :param matter: The matter of this CalendarEntryUpdateRequestData.
        :param recurrence_rule: The recurrence_rule of this CalendarEntryUpdateRequestData.
        :param send_email_notification: The send_email_notification of this CalendarEntryUpdateRequestData.
        :param start_at: The start_at of this CalendarEntryUpdateRequestData.
        :param summary: The summary of this CalendarEntryUpdateRequestData.
        """
        self.openapi_types = {
            'deleted': str,
            'all_day': bool,
            'attendees': List[CalendarEntryCreateRequestDataAttendeesInner],
            'calendar_entry_event_type': CalendarEntryCreateRequestDataCalendarEntryEventType,
            'calendar_owner': CalendarEntryUpdateRequestDataCalendarOwner,
            'conference_meeting': CalendarEntryCreateRequestDataConferenceMeeting,
            'description': str,
            'end_at': datetime,
            'external_properties': List[CalendarEntryUpdateRequestDataExternalPropertiesInner],
            'location': str,
            'matter': CalendarEntryCreateRequestDataMatter,
            'recurrence_rule': str,
            'send_email_notification': bool,
            'start_at': datetime,
            'summary': str
        }

        self.attribute_map = {
            'deleted': '_deleted',
            'all_day': 'all_day',
            'attendees': 'attendees',
            'calendar_entry_event_type': 'calendar_entry_event_type',
            'calendar_owner': 'calendar_owner',
            'conference_meeting': 'conference_meeting',
            'description': 'description',
            'end_at': 'end_at',
            'external_properties': 'external_properties',
            'location': 'location',
            'matter': 'matter',
            'recurrence_rule': 'recurrence_rule',
            'send_email_notification': 'send_email_notification',
            'start_at': 'start_at',
            'summary': 'summary'
        }

        self._deleted = deleted
        self._all_day = all_day
        self._attendees = attendees
        self._calendar_entry_event_type = calendar_entry_event_type
        self._calendar_owner = calendar_owner
        self._conference_meeting = conference_meeting
        self._description = description
        self._end_at = end_at
        self._external_properties = external_properties
        self._location = location
        self._matter = matter
        self._recurrence_rule = recurrence_rule
        self._send_email_notification = send_email_notification
        self._start_at = start_at
        self._summary = summary

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CalendarEntryUpdateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CalendarEntry_update_request_data of this CalendarEntryUpdateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def deleted(self):
        """Gets the deleted of this CalendarEntryUpdateRequestData.

        Flag to delete a specific instance of a recurring event.

        :return: The deleted of this CalendarEntryUpdateRequestData.
        :rtype: str
        """
        return self._deleted

    @deleted.setter
    def deleted(self, deleted):
        """Sets the deleted of this CalendarEntryUpdateRequestData.

        Flag to delete a specific instance of a recurring event.

        :param deleted: The deleted of this CalendarEntryUpdateRequestData.
        :type deleted: str
        """
        allowed_values = ["single", "future"]  # noqa: E501
        if deleted not in allowed_values:
            raise ValueError(
                "Invalid value for `deleted` ({0}), must be one of {1}"
                .format(deleted, allowed_values)
            )

        self._deleted = deleted

    @property
    def all_day(self):
        """Gets the all_day of this CalendarEntryUpdateRequestData.

        Whether or not the CalendarEntry is for all day.

        :return: The all_day of this CalendarEntryUpdateRequestData.
        :rtype: bool
        """
        return self._all_day

    @all_day.setter
    def all_day(self, all_day):
        """Sets the all_day of this CalendarEntryUpdateRequestData.

        Whether or not the CalendarEntry is for all day.

        :param all_day: The all_day of this CalendarEntryUpdateRequestData.
        :type all_day: bool
        """

        self._all_day = all_day

    @property
    def attendees(self):
        """Gets the attendees of this CalendarEntryUpdateRequestData.


        :return: The attendees of this CalendarEntryUpdateRequestData.
        :rtype: List[CalendarEntryCreateRequestDataAttendeesInner]
        """
        return self._attendees

    @attendees.setter
    def attendees(self, attendees):
        """Sets the attendees of this CalendarEntryUpdateRequestData.


        :param attendees: The attendees of this CalendarEntryUpdateRequestData.
        :type attendees: List[CalendarEntryCreateRequestDataAttendeesInner]
        """

        self._attendees = attendees

    @property
    def calendar_entry_event_type(self):
        """Gets the calendar_entry_event_type of this CalendarEntryUpdateRequestData.


        :return: The calendar_entry_event_type of this CalendarEntryUpdateRequestData.
        :rtype: CalendarEntryCreateRequestDataCalendarEntryEventType
        """
        return self._calendar_entry_event_type

    @calendar_entry_event_type.setter
    def calendar_entry_event_type(self, calendar_entry_event_type):
        """Sets the calendar_entry_event_type of this CalendarEntryUpdateRequestData.


        :param calendar_entry_event_type: The calendar_entry_event_type of this CalendarEntryUpdateRequestData.
        :type calendar_entry_event_type: CalendarEntryCreateRequestDataCalendarEntryEventType
        """

        self._calendar_entry_event_type = calendar_entry_event_type

    @property
    def calendar_owner(self):
        """Gets the calendar_owner of this CalendarEntryUpdateRequestData.


        :return: The calendar_owner of this CalendarEntryUpdateRequestData.
        :rtype: CalendarEntryUpdateRequestDataCalendarOwner
        """
        return self._calendar_owner

    @calendar_owner.setter
    def calendar_owner(self, calendar_owner):
        """Sets the calendar_owner of this CalendarEntryUpdateRequestData.


        :param calendar_owner: The calendar_owner of this CalendarEntryUpdateRequestData.
        :type calendar_owner: CalendarEntryUpdateRequestDataCalendarOwner
        """

        self._calendar_owner = calendar_owner

    @property
    def conference_meeting(self):
        """Gets the conference_meeting of this CalendarEntryUpdateRequestData.


        :return: The conference_meeting of this CalendarEntryUpdateRequestData.
        :rtype: CalendarEntryCreateRequestDataConferenceMeeting
        """
        return self._conference_meeting

    @conference_meeting.setter
    def conference_meeting(self, conference_meeting):
        """Sets the conference_meeting of this CalendarEntryUpdateRequestData.


        :param conference_meeting: The conference_meeting of this CalendarEntryUpdateRequestData.
        :type conference_meeting: CalendarEntryCreateRequestDataConferenceMeeting
        """

        self._conference_meeting = conference_meeting

    @property
    def description(self):
        """Gets the description of this CalendarEntryUpdateRequestData.

        A detailed description of the CalendarEntry.

        :return: The description of this CalendarEntryUpdateRequestData.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CalendarEntryUpdateRequestData.

        A detailed description of the CalendarEntry.

        :param description: The description of this CalendarEntryUpdateRequestData.
        :type description: str
        """

        self._description = description

    @property
    def end_at(self):
        """Gets the end_at of this CalendarEntryUpdateRequestData.

        The time the CalendarEntry ends (Expects an ISO-8601 timestamp).

        :return: The end_at of this CalendarEntryUpdateRequestData.
        :rtype: datetime
        """
        return self._end_at

    @end_at.setter
    def end_at(self, end_at):
        """Sets the end_at of this CalendarEntryUpdateRequestData.

        The time the CalendarEntry ends (Expects an ISO-8601 timestamp).

        :param end_at: The end_at of this CalendarEntryUpdateRequestData.
        :type end_at: datetime
        """

        self._end_at = end_at

    @property
    def external_properties(self):
        """Gets the external_properties of this CalendarEntryUpdateRequestData.


        :return: The external_properties of this CalendarEntryUpdateRequestData.
        :rtype: List[CalendarEntryUpdateRequestDataExternalPropertiesInner]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this CalendarEntryUpdateRequestData.


        :param external_properties: The external_properties of this CalendarEntryUpdateRequestData.
        :type external_properties: List[CalendarEntryUpdateRequestDataExternalPropertiesInner]
        """

        self._external_properties = external_properties

    @property
    def location(self):
        """Gets the location of this CalendarEntryUpdateRequestData.

        The geographic location of the CalendarEntry.

        :return: The location of this CalendarEntryUpdateRequestData.
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this CalendarEntryUpdateRequestData.

        The geographic location of the CalendarEntry.

        :param location: The location of this CalendarEntryUpdateRequestData.
        :type location: str
        """

        self._location = location

    @property
    def matter(self):
        """Gets the matter of this CalendarEntryUpdateRequestData.


        :return: The matter of this CalendarEntryUpdateRequestData.
        :rtype: CalendarEntryCreateRequestDataMatter
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this CalendarEntryUpdateRequestData.


        :param matter: The matter of this CalendarEntryUpdateRequestData.
        :type matter: CalendarEntryCreateRequestDataMatter
        """

        self._matter = matter

    @property
    def recurrence_rule(self):
        """Gets the recurrence_rule of this CalendarEntryUpdateRequestData.

        Recurrence rule for expanding recurring CalendarEntry. To convert an existing recurring event to a non-recurring event, `''` or `null` are valid values.

        :return: The recurrence_rule of this CalendarEntryUpdateRequestData.
        :rtype: str
        """
        return self._recurrence_rule

    @recurrence_rule.setter
    def recurrence_rule(self, recurrence_rule):
        """Sets the recurrence_rule of this CalendarEntryUpdateRequestData.

        Recurrence rule for expanding recurring CalendarEntry. To convert an existing recurring event to a non-recurring event, `''` or `null` are valid values.

        :param recurrence_rule: The recurrence_rule of this CalendarEntryUpdateRequestData.
        :type recurrence_rule: str
        """

        self._recurrence_rule = recurrence_rule

    @property
    def send_email_notification(self):
        """Gets the send_email_notification of this CalendarEntryUpdateRequestData.

        Whether the calendar Entry should send email notifications to attendees

        :return: The send_email_notification of this CalendarEntryUpdateRequestData.
        :rtype: bool
        """
        return self._send_email_notification

    @send_email_notification.setter
    def send_email_notification(self, send_email_notification):
        """Sets the send_email_notification of this CalendarEntryUpdateRequestData.

        Whether the calendar Entry should send email notifications to attendees

        :param send_email_notification: The send_email_notification of this CalendarEntryUpdateRequestData.
        :type send_email_notification: bool
        """

        self._send_email_notification = send_email_notification

    @property
    def start_at(self):
        """Gets the start_at of this CalendarEntryUpdateRequestData.

        The time the CalendarEntry starts (Expects an ISO-8601 timestamp).

        :return: The start_at of this CalendarEntryUpdateRequestData.
        :rtype: datetime
        """
        return self._start_at

    @start_at.setter
    def start_at(self, start_at):
        """Sets the start_at of this CalendarEntryUpdateRequestData.

        The time the CalendarEntry starts (Expects an ISO-8601 timestamp).

        :param start_at: The start_at of this CalendarEntryUpdateRequestData.
        :type start_at: datetime
        """

        self._start_at = start_at

    @property
    def summary(self):
        """Gets the summary of this CalendarEntryUpdateRequestData.

        A short summary of the CalendarEntry.

        :return: The summary of this CalendarEntryUpdateRequestData.
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this CalendarEntryUpdateRequestData.

        A short summary of the CalendarEntry.

        :param summary: The summary of this CalendarEntryUpdateRequestData.
        :type summary: str
        """

        self._summary = summary
