# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class CalendarEntryUpdateRequestDataExternalPropertiesInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, name: str=None, value: str=None, destroy: bool=None):
        """CalendarEntryUpdateRequestDataExternalPropertiesInner - a model defined in OpenAPI

        :param id: The id of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :param name: The name of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :param value: The value of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :param destroy: The destroy of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        """
        self.openapi_types = {
            'id': int,
            'name': str,
            'value': str,
            'destroy': bool
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'value': 'value',
            'destroy': '_destroy'
        }

        self._id = id
        self._name = name
        self._value = value
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CalendarEntryUpdateRequestDataExternalPropertiesInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CalendarEntry_update_request_data_external_properties_inner of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The unique identifier for a single ExternalProperty associated with the CalendarEntry. The keyword `null` is not valid for this field.

        :return: The id of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The unique identifier for a single ExternalProperty associated with the CalendarEntry. The keyword `null` is not valid for this field.

        :param id: The id of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :type id: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The ExternalProperty name. Note: **there is a limit of 5 external_properties per CalendarEntry**

        :return: The name of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The ExternalProperty name. Note: **there is a limit of 5 external_properties per CalendarEntry**

        :param name: The name of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :type name: str
        """

        self._name = name

    @property
    def value(self):
        """Gets the value of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The ExternalProperty value.

        :return: The value of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The ExternalProperty value.

        :param value: The value of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :type value: str
        """

        self._value = value

    @property
    def destroy(self):
        """Gets the destroy of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated ExternalProperty is present, the ExternalProperty is deleted from the CalendarEntry.

        :return: The destroy of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this CalendarEntryUpdateRequestDataExternalPropertiesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated ExternalProperty is present, the ExternalProperty is deleted from the CalendarEntry.

        :param destroy: The destroy of this CalendarEntryUpdateRequestDataExternalPropertiesInner.
        :type destroy: bool
        """

        self._destroy = destroy
