# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class CalendarVisibility(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, color: str=None, light_color: str=None, visible: bool=None, name: str=None, created_at: datetime=None, updated_at: datetime=None):
        """CalendarVisibility - a model defined in OpenAPI

        :param id: The id of this CalendarVisibility.
        :param etag: The etag of this CalendarVisibility.
        :param color: The color of this CalendarVisibility.
        :param light_color: The light_color of this CalendarVisibility.
        :param visible: The visible of this CalendarVisibility.
        :param name: The name of this CalendarVisibility.
        :param created_at: The created_at of this CalendarVisibility.
        :param updated_at: The updated_at of this CalendarVisibility.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'color': str,
            'light_color': str,
            'visible': bool,
            'name': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'color': 'color',
            'light_color': 'light_color',
            'visible': 'visible',
            'name': 'name',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._color = color
        self._light_color = light_color
        self._visible = visible
        self._name = name
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CalendarVisibility':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CalendarVisibility of this CalendarVisibility.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this CalendarVisibility.

        Unique identifier for the *CalendarVisibility*

        :return: The id of this CalendarVisibility.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CalendarVisibility.

        Unique identifier for the *CalendarVisibility*

        :param id: The id of this CalendarVisibility.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this CalendarVisibility.

        ETag for the *CalendarVisibility*

        :return: The etag of this CalendarVisibility.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this CalendarVisibility.

        ETag for the *CalendarVisibility*

        :param etag: The etag of this CalendarVisibility.
        :type etag: str
        """

        self._etag = etag

    @property
    def color(self):
        """Gets the color of this CalendarVisibility.

        Calendar color

        :return: The color of this CalendarVisibility.
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this CalendarVisibility.

        Calendar color

        :param color: The color of this CalendarVisibility.
        :type color: str
        """
        allowed_values = ["#658CDA", "#DA6666", "#49B050", "#E7804C", "#8C66DA", "#C4A882", "#64AD88", "#84AAA5", "#56BFB3", "#E77399", "#BFBF4B", "#8BBF3C", "#B473B4", "#A7A77D", "#F2A53D", "#658CB3", "#BE9494", "#A992A9", "#8897A5", "#93A2BE"]  # noqa: E501
        if color not in allowed_values:
            raise ValueError(
                "Invalid value for `color` ({0}), must be one of {1}"
                .format(color, allowed_values)
            )

        self._color = color

    @property
    def light_color(self):
        """Gets the light_color of this CalendarVisibility.

        Accent color to complement the main calendar color.

        :return: The light_color of this CalendarVisibility.
        :rtype: str
        """
        return self._light_color

    @light_color.setter
    def light_color(self, light_color):
        """Sets the light_color of this CalendarVisibility.

        Accent color to complement the main calendar color.

        :param light_color: The light_color of this CalendarVisibility.
        :type light_color: str
        """
        allowed_values = ["#5DA5C7", "#F95957", "#209412", "#FF7715", "#DE649D", "#FF6B02", "#56C4FC", "#00B177", "#50D19B", "#F14A8C", "#A3A2A2", "#84AB3B", "#B091EE", "#BD9E69", "#F2A000", "#00A5CA", "#CB5A3D", "#959CD0", "#B0B0B0", "#7BA6CD"]  # noqa: E501
        if light_color not in allowed_values:
            raise ValueError(
                "Invalid value for `light_color` ({0}), must be one of {1}"
                .format(light_color, allowed_values)
            )

        self._light_color = light_color

    @property
    def visible(self):
        """Gets the visible of this CalendarVisibility.

        Whether the *CalendarVisibility* will be shown by default in the Clio Web UI.

        :return: The visible of this CalendarVisibility.
        :rtype: bool
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this CalendarVisibility.

        Whether the *CalendarVisibility* will be shown by default in the Clio Web UI.

        :param visible: The visible of this CalendarVisibility.
        :type visible: bool
        """

        self._visible = visible

    @property
    def name(self):
        """Gets the name of this CalendarVisibility.

        Calendar name

        :return: The name of this CalendarVisibility.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CalendarVisibility.

        Calendar name

        :param name: The name of this CalendarVisibility.
        :type name: str
        """

        self._name = name

    @property
    def created_at(self):
        """Gets the created_at of this CalendarVisibility.

        The time the *CalendarVisibility* was created (as a ISO-8601 timestamp)

        :return: The created_at of this CalendarVisibility.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this CalendarVisibility.

        The time the *CalendarVisibility* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this CalendarVisibility.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this CalendarVisibility.

        The time the *CalendarVisibility* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this CalendarVisibility.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this CalendarVisibility.

        The time the *CalendarVisibility* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this CalendarVisibility.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
