# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class CalendarVisibilityUpdateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, color: str=None, visible: str=None):
        """CalendarVisibilityUpdateRequestData - a model defined in OpenAPI

        :param color: The color of this CalendarVisibilityUpdateRequestData.
        :param visible: The visible of this CalendarVisibilityUpdateRequestData.
        """
        self.openapi_types = {
            'color': str,
            'visible': str
        }

        self.attribute_map = {
            'color': 'color',
            'visible': 'visible'
        }

        self._color = color
        self._visible = visible

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CalendarVisibilityUpdateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CalendarVisibility_update_request_data of this CalendarVisibilityUpdateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def color(self):
        """Gets the color of this CalendarVisibilityUpdateRequestData.

        Calendar color as seen in the Clio Web UI.

        :return: The color of this CalendarVisibilityUpdateRequestData.
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this CalendarVisibilityUpdateRequestData.

        Calendar color as seen in the Clio Web UI.

        :param color: The color of this CalendarVisibilityUpdateRequestData.
        :type color: str
        """
        allowed_values = ["#367B9C", "#FFA5A4", "#83D17F", "#FFAC7B", "#8E3F64", "#C75300", "#009CEC", "#62D6B1", "#9EEDCB", "#F9A2C4", "#616161", "#BBDA81", "#DFD3F8", "#D6C4A5", "#FFD478", "#6AC9DE", "#EABBB0", "#BFC2E1", "#DADADA", "#CDE2F5"]  # noqa: E501
        if color not in allowed_values:
            raise ValueError(
                "Invalid value for `color` ({0}), must be one of {1}"
                .format(color, allowed_values)
            )

        self._color = color

    @property
    def visible(self):
        """Gets the visible of this CalendarVisibilityUpdateRequestData.

        Whether or not the CalendarVisibility should be visible by default in the Clio Web UI.

        :return: The visible of this CalendarVisibilityUpdateRequestData.
        :rtype: str
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this CalendarVisibilityUpdateRequestData.

        Whether or not the CalendarVisibility should be visible by default in the Clio Web UI.

        :param visible: The visible of this CalendarVisibilityUpdateRequestData.
        :type visible: str
        """

        self._visible = visible
