# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ClientPortalBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, unread_count: int=None, unread_notifiable_count: int=None):
        """ClientPortalBase - a model defined in OpenAPI

        :param id: The id of this ClientPortalBase.
        :param etag: The etag of this ClientPortalBase.
        :param created_at: The created_at of this ClientPortalBase.
        :param updated_at: The updated_at of this ClientPortalBase.
        :param unread_count: The unread_count of this ClientPortalBase.
        :param unread_notifiable_count: The unread_notifiable_count of this ClientPortalBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'unread_count': int,
            'unread_notifiable_count': int
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'unread_count': 'unread_count',
            'unread_notifiable_count': 'unread_notifiable_count'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._unread_count = unread_count
        self._unread_notifiable_count = unread_notifiable_count

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ClientPortalBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ClientPortal_base of this ClientPortalBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ClientPortalBase.

        Unique identifier for the *ClientPortal*

        :return: The id of this ClientPortalBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ClientPortalBase.

        Unique identifier for the *ClientPortal*

        :param id: The id of this ClientPortalBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ClientPortalBase.

        ETag for the *ClientPortal*

        :return: The etag of this ClientPortalBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ClientPortalBase.

        ETag for the *ClientPortal*

        :param etag: The etag of this ClientPortalBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this ClientPortalBase.

        The time the *ClientPortal* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ClientPortalBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ClientPortalBase.

        The time the *ClientPortal* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ClientPortalBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ClientPortalBase.

        The time the *ClientPortal* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ClientPortalBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ClientPortalBase.

        The time the *ClientPortal* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ClientPortalBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def unread_count(self):
        """Gets the unread_count of this ClientPortalBase.

        The number of unread count messages for the current user.

        :return: The unread_count of this ClientPortalBase.
        :rtype: int
        """
        return self._unread_count

    @unread_count.setter
    def unread_count(self, unread_count):
        """Sets the unread_count of this ClientPortalBase.

        The number of unread count messages for the current user.

        :param unread_count: The unread_count of this ClientPortalBase.
        :type unread_count: int
        """

        self._unread_count = unread_count

    @property
    def unread_notifiable_count(self):
        """Gets the unread_notifiable_count of this ClientPortalBase.

        The number of unread messages for the current user once their notification settings have been applied.

        :return: The unread_notifiable_count of this ClientPortalBase.
        :rtype: int
        """
        return self._unread_notifiable_count

    @unread_notifiable_count.setter
    def unread_notifiable_count(self, unread_notifiable_count):
        """Sets the unread_notifiable_count of this ClientPortalBase.

        The number of unread messages for the current user once their notification settings have been applied.

        :param unread_notifiable_count: The unread_notifiable_count of this ClientPortalBase.
        :type unread_notifiable_count: int
        """

        self._unread_notifiable_count = unread_notifiable_count
