# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ClioCreatorBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, account_owner: bool=None, clio_connect: bool=None, court_rules_default_attendee: bool=None, default_calendar_id: int=None, email: str=None, enabled: bool=None, etag: str=None, id: int=None, type: str=None, initials: str=None, first_name: str=None, last_name: str=None, name: str=None, phone_number: str=None, rate: float=None, subscription_type: str=None, time_zone: str=None, roles: List[str]=None, created_at: datetime=None, updated_at: datetime=None):
        """ClioCreatorBase - a model defined in OpenAPI

        :param account_owner: The account_owner of this ClioCreatorBase.
        :param clio_connect: The clio_connect of this ClioCreatorBase.
        :param court_rules_default_attendee: The court_rules_default_attendee of this ClioCreatorBase.
        :param default_calendar_id: The default_calendar_id of this ClioCreatorBase.
        :param email: The email of this ClioCreatorBase.
        :param enabled: The enabled of this ClioCreatorBase.
        :param etag: The etag of this ClioCreatorBase.
        :param id: The id of this ClioCreatorBase.
        :param type: The type of this ClioCreatorBase.
        :param initials: The initials of this ClioCreatorBase.
        :param first_name: The first_name of this ClioCreatorBase.
        :param last_name: The last_name of this ClioCreatorBase.
        :param name: The name of this ClioCreatorBase.
        :param phone_number: The phone_number of this ClioCreatorBase.
        :param rate: The rate of this ClioCreatorBase.
        :param subscription_type: The subscription_type of this ClioCreatorBase.
        :param time_zone: The time_zone of this ClioCreatorBase.
        :param roles: The roles of this ClioCreatorBase.
        :param created_at: The created_at of this ClioCreatorBase.
        :param updated_at: The updated_at of this ClioCreatorBase.
        """
        self.openapi_types = {
            'account_owner': bool,
            'clio_connect': bool,
            'court_rules_default_attendee': bool,
            'default_calendar_id': int,
            'email': str,
            'enabled': bool,
            'etag': str,
            'id': int,
            'type': str,
            'initials': str,
            'first_name': str,
            'last_name': str,
            'name': str,
            'phone_number': str,
            'rate': float,
            'subscription_type': str,
            'time_zone': str,
            'roles': List[str],
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'account_owner': 'account_owner',
            'clio_connect': 'clio_connect',
            'court_rules_default_attendee': 'court_rules_default_attendee',
            'default_calendar_id': 'default_calendar_id',
            'email': 'email',
            'enabled': 'enabled',
            'etag': 'etag',
            'id': 'id',
            'type': 'type',
            'initials': 'initials',
            'first_name': 'first_name',
            'last_name': 'last_name',
            'name': 'name',
            'phone_number': 'phone_number',
            'rate': 'rate',
            'subscription_type': 'subscription_type',
            'time_zone': 'time_zone',
            'roles': 'roles',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._account_owner = account_owner
        self._clio_connect = clio_connect
        self._court_rules_default_attendee = court_rules_default_attendee
        self._default_calendar_id = default_calendar_id
        self._email = email
        self._enabled = enabled
        self._etag = etag
        self._id = id
        self._type = type
        self._initials = initials
        self._first_name = first_name
        self._last_name = last_name
        self._name = name
        self._phone_number = phone_number
        self._rate = rate
        self._subscription_type = subscription_type
        self._time_zone = time_zone
        self._roles = roles
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ClioCreatorBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ClioCreator_base of this ClioCreatorBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def account_owner(self):
        """Gets the account_owner of this ClioCreatorBase.

        Whether the *ClioCreator* is the owner of the account

        :return: The account_owner of this ClioCreatorBase.
        :rtype: bool
        """
        return self._account_owner

    @account_owner.setter
    def account_owner(self, account_owner):
        """Sets the account_owner of this ClioCreatorBase.

        Whether the *ClioCreator* is the owner of the account

        :param account_owner: The account_owner of this ClioCreatorBase.
        :type account_owner: bool
        """

        self._account_owner = account_owner

    @property
    def clio_connect(self):
        """Gets the clio_connect of this ClioCreatorBase.

        Whether the *ClioCreator* is a Clio Connect user

        :return: The clio_connect of this ClioCreatorBase.
        :rtype: bool
        """
        return self._clio_connect

    @clio_connect.setter
    def clio_connect(self, clio_connect):
        """Sets the clio_connect of this ClioCreatorBase.

        Whether the *ClioCreator* is a Clio Connect user

        :param clio_connect: The clio_connect of this ClioCreatorBase.
        :type clio_connect: bool
        """

        self._clio_connect = clio_connect

    @property
    def court_rules_default_attendee(self):
        """Gets the court_rules_default_attendee of this ClioCreatorBase.

        Whether the *ClioCreator* is a default attendee for court rules events

        :return: The court_rules_default_attendee of this ClioCreatorBase.
        :rtype: bool
        """
        return self._court_rules_default_attendee

    @court_rules_default_attendee.setter
    def court_rules_default_attendee(self, court_rules_default_attendee):
        """Sets the court_rules_default_attendee of this ClioCreatorBase.

        Whether the *ClioCreator* is a default attendee for court rules events

        :param court_rules_default_attendee: The court_rules_default_attendee of this ClioCreatorBase.
        :type court_rules_default_attendee: bool
        """

        self._court_rules_default_attendee = court_rules_default_attendee

    @property
    def default_calendar_id(self):
        """Gets the default_calendar_id of this ClioCreatorBase.

        Default calendar id for *ClioCreator*.

        :return: The default_calendar_id of this ClioCreatorBase.
        :rtype: int
        """
        return self._default_calendar_id

    @default_calendar_id.setter
    def default_calendar_id(self, default_calendar_id):
        """Sets the default_calendar_id of this ClioCreatorBase.

        Default calendar id for *ClioCreator*.

        :param default_calendar_id: The default_calendar_id of this ClioCreatorBase.
        :type default_calendar_id: int
        """

        self._default_calendar_id = default_calendar_id

    @property
    def email(self):
        """Gets the email of this ClioCreatorBase.

        The email of the *ClioCreator*

        :return: The email of this ClioCreatorBase.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this ClioCreatorBase.

        The email of the *ClioCreator*

        :param email: The email of this ClioCreatorBase.
        :type email: str
        """

        self._email = email

    @property
    def enabled(self):
        """Gets the enabled of this ClioCreatorBase.

        Whether the *ClioCreator* is allowed to log in

        :return: The enabled of this ClioCreatorBase.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this ClioCreatorBase.

        Whether the *ClioCreator* is allowed to log in

        :param enabled: The enabled of this ClioCreatorBase.
        :type enabled: bool
        """

        self._enabled = enabled

    @property
    def etag(self):
        """Gets the etag of this ClioCreatorBase.

        ETag for the *ClioCreator*

        :return: The etag of this ClioCreatorBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ClioCreatorBase.

        ETag for the *ClioCreator*

        :param etag: The etag of this ClioCreatorBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def id(self):
        """Gets the id of this ClioCreatorBase.

        Unique identifier for the *ClioCreator*

        :return: The id of this ClioCreatorBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ClioCreatorBase.

        Unique identifier for the *ClioCreator*

        :param id: The id of this ClioCreatorBase.
        :type id: int
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this ClioCreatorBase.

        The type of the *ClioCreator*

        :return: The type of this ClioCreatorBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ClioCreatorBase.

        The type of the *ClioCreator*

        :param type: The type of this ClioCreatorBase.
        :type type: str
        """
        allowed_values = ["ManageUser", "ClientUser"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def initials(self):
        """Gets the initials of this ClioCreatorBase.

        The initials of the *ClioCreator*

        :return: The initials of this ClioCreatorBase.
        :rtype: str
        """
        return self._initials

    @initials.setter
    def initials(self, initials):
        """Sets the initials of this ClioCreatorBase.

        The initials of the *ClioCreator*

        :param initials: The initials of this ClioCreatorBase.
        :type initials: str
        """

        self._initials = initials

    @property
    def first_name(self):
        """Gets the first_name of this ClioCreatorBase.

        The first name of the *ClioCreator*

        :return: The first_name of this ClioCreatorBase.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this ClioCreatorBase.

        The first name of the *ClioCreator*

        :param first_name: The first_name of this ClioCreatorBase.
        :type first_name: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this ClioCreatorBase.

        The last name of the *ClioCreator*

        :return: The last_name of this ClioCreatorBase.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this ClioCreatorBase.

        The last name of the *ClioCreator*

        :param last_name: The last_name of this ClioCreatorBase.
        :type last_name: str
        """

        self._last_name = last_name

    @property
    def name(self):
        """Gets the name of this ClioCreatorBase.

        The full name of the *ClioCreator*

        :return: The name of this ClioCreatorBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ClioCreatorBase.

        The full name of the *ClioCreator*

        :param name: The name of this ClioCreatorBase.
        :type name: str
        """

        self._name = name

    @property
    def phone_number(self):
        """Gets the phone_number of this ClioCreatorBase.

        The primary phone number for the *ClioCreator*.

        :return: The phone_number of this ClioCreatorBase.
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this ClioCreatorBase.

        The primary phone number for the *ClioCreator*.

        :param phone_number: The phone_number of this ClioCreatorBase.
        :type phone_number: str
        """

        self._phone_number = phone_number

    @property
    def rate(self):
        """Gets the rate of this ClioCreatorBase.

        Default user activity rate for *ClioCreator*.

        :return: The rate of this ClioCreatorBase.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this ClioCreatorBase.

        Default user activity rate for *ClioCreator*.

        :param rate: The rate of this ClioCreatorBase.
        :type rate: float
        """

        self._rate = rate

    @property
    def subscription_type(self):
        """Gets the subscription_type of this ClioCreatorBase.

        The subscription type of the *ClioCreator*

        :return: The subscription_type of this ClioCreatorBase.
        :rtype: str
        """
        return self._subscription_type

    @subscription_type.setter
    def subscription_type(self, subscription_type):
        """Sets the subscription_type of this ClioCreatorBase.

        The subscription type of the *ClioCreator*

        :param subscription_type: The subscription_type of this ClioCreatorBase.
        :type subscription_type: str
        """
        allowed_values = ["Attorney", "NonAttorney"]  # noqa: E501
        if subscription_type not in allowed_values:
            raise ValueError(
                "Invalid value for `subscription_type` ({0}), must be one of {1}"
                .format(subscription_type, allowed_values)
            )

        self._subscription_type = subscription_type

    @property
    def time_zone(self):
        """Gets the time_zone of this ClioCreatorBase.

        The selected time zone of the *ClioCreator*

        :return: The time_zone of this ClioCreatorBase.
        :rtype: str
        """
        return self._time_zone

    @time_zone.setter
    def time_zone(self, time_zone):
        """Sets the time_zone of this ClioCreatorBase.

        The selected time zone of the *ClioCreator*

        :param time_zone: The time_zone of this ClioCreatorBase.
        :type time_zone: str
        """

        self._time_zone = time_zone

    @property
    def roles(self):
        """Gets the roles of this ClioCreatorBase.

        An array of roles assigned to this *ClioCreator*

        :return: The roles of this ClioCreatorBase.
        :rtype: List[str]
        """
        return self._roles

    @roles.setter
    def roles(self, roles):
        """Sets the roles of this ClioCreatorBase.

        An array of roles assigned to this *ClioCreator*

        :param roles: The roles of this ClioCreatorBase.
        :type roles: List[str]
        """

        self._roles = roles

    @property
    def created_at(self):
        """Gets the created_at of this ClioCreatorBase.

        The time the *ClioCreator* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ClioCreatorBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ClioCreatorBase.

        The time the *ClioCreator* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ClioCreatorBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ClioCreatorBase.

        The time the *ClioCreator* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ClioCreatorBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ClioCreatorBase.

        The time the *ClioCreator* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ClioCreatorBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
