# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ClioPaymentsLinkBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, active: bool=None, amount: float=None, created_at: datetime=None, currency: str=None, description: str=None, email_address: str=None, etag: str=None, expires_at: datetime=None, id: int=None, is_allocated_as_revenue: bool=None, redirect_url: str=None, url: str=None):
        """ClioPaymentsLinkBase - a model defined in OpenAPI

        :param active: The active of this ClioPaymentsLinkBase.
        :param amount: The amount of this ClioPaymentsLinkBase.
        :param created_at: The created_at of this ClioPaymentsLinkBase.
        :param currency: The currency of this ClioPaymentsLinkBase.
        :param description: The description of this ClioPaymentsLinkBase.
        :param email_address: The email_address of this ClioPaymentsLinkBase.
        :param etag: The etag of this ClioPaymentsLinkBase.
        :param expires_at: The expires_at of this ClioPaymentsLinkBase.
        :param id: The id of this ClioPaymentsLinkBase.
        :param is_allocated_as_revenue: The is_allocated_as_revenue of this ClioPaymentsLinkBase.
        :param redirect_url: The redirect_url of this ClioPaymentsLinkBase.
        :param url: The url of this ClioPaymentsLinkBase.
        """
        self.openapi_types = {
            'active': bool,
            'amount': float,
            'created_at': datetime,
            'currency': str,
            'description': str,
            'email_address': str,
            'etag': str,
            'expires_at': datetime,
            'id': int,
            'is_allocated_as_revenue': bool,
            'redirect_url': str,
            'url': str
        }

        self.attribute_map = {
            'active': 'active',
            'amount': 'amount',
            'created_at': 'created_at',
            'currency': 'currency',
            'description': 'description',
            'email_address': 'email_address',
            'etag': 'etag',
            'expires_at': 'expires_at',
            'id': 'id',
            'is_allocated_as_revenue': 'is_allocated_as_revenue',
            'redirect_url': 'redirect_url',
            'url': 'url'
        }

        self._active = active
        self._amount = amount
        self._created_at = created_at
        self._currency = currency
        self._description = description
        self._email_address = email_address
        self._etag = etag
        self._expires_at = expires_at
        self._id = id
        self._is_allocated_as_revenue = is_allocated_as_revenue
        self._redirect_url = redirect_url
        self._url = url

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ClioPaymentsLinkBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ClioPaymentsLink_base of this ClioPaymentsLinkBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def active(self):
        """Gets the active of this ClioPaymentsLinkBase.

        Whether or not the payment link is active.

        :return: The active of this ClioPaymentsLinkBase.
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this ClioPaymentsLinkBase.

        Whether or not the payment link is active.

        :param active: The active of this ClioPaymentsLinkBase.
        :type active: bool
        """

        self._active = active

    @property
    def amount(self):
        """Gets the amount of this ClioPaymentsLinkBase.

        The defined amount of the payment link, if set.

        :return: The amount of this ClioPaymentsLinkBase.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this ClioPaymentsLinkBase.

        The defined amount of the payment link, if set.

        :param amount: The amount of this ClioPaymentsLinkBase.
        :type amount: float
        """

        self._amount = amount

    @property
    def created_at(self):
        """Gets the created_at of this ClioPaymentsLinkBase.

        The time the *ClioPaymentsLink* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ClioPaymentsLinkBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ClioPaymentsLinkBase.

        The time the *ClioPaymentsLink* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ClioPaymentsLinkBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def currency(self):
        """Gets the currency of this ClioPaymentsLinkBase.

        The currency the payment link will collect.

        :return: The currency of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this ClioPaymentsLinkBase.

        The currency the payment link will collect.

        :param currency: The currency of this ClioPaymentsLinkBase.
        :type currency: str
        """

        self._currency = currency

    @property
    def description(self):
        """Gets the description of this ClioPaymentsLinkBase.

        The defined description of the payment link, if set.

        :return: The description of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ClioPaymentsLinkBase.

        The defined description of the payment link, if set.

        :param description: The description of this ClioPaymentsLinkBase.
        :type description: str
        """

        self._description = description

    @property
    def email_address(self):
        """Gets the email_address of this ClioPaymentsLinkBase.

        The email address to pre-fill the field on the the payment link, if set.

        :return: The email_address of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """Sets the email_address of this ClioPaymentsLinkBase.

        The email address to pre-fill the field on the the payment link, if set.

        :param email_address: The email_address of this ClioPaymentsLinkBase.
        :type email_address: str
        """

        self._email_address = email_address

    @property
    def etag(self):
        """Gets the etag of this ClioPaymentsLinkBase.

        ETag for the *ClioPaymentsLink*

        :return: The etag of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ClioPaymentsLinkBase.

        ETag for the *ClioPaymentsLink*

        :param etag: The etag of this ClioPaymentsLinkBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def expires_at(self):
        """Gets the expires_at of this ClioPaymentsLinkBase.

        The ISO 8601 date and time the payment link will expire.

        :return: The expires_at of this ClioPaymentsLinkBase.
        :rtype: datetime
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this ClioPaymentsLinkBase.

        The ISO 8601 date and time the payment link will expire.

        :param expires_at: The expires_at of this ClioPaymentsLinkBase.
        :type expires_at: datetime
        """

        self._expires_at = expires_at

    @property
    def id(self):
        """Gets the id of this ClioPaymentsLinkBase.

        Unique identifier for the *ClioPaymentsLink*

        :return: The id of this ClioPaymentsLinkBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ClioPaymentsLinkBase.

        Unique identifier for the *ClioPaymentsLink*

        :param id: The id of this ClioPaymentsLinkBase.
        :type id: int
        """

        self._id = id

    @property
    def is_allocated_as_revenue(self):
        """Gets the is_allocated_as_revenue of this ClioPaymentsLinkBase.

        Whether the payment link is allocated as revenue.

        :return: The is_allocated_as_revenue of this ClioPaymentsLinkBase.
        :rtype: bool
        """
        return self._is_allocated_as_revenue

    @is_allocated_as_revenue.setter
    def is_allocated_as_revenue(self, is_allocated_as_revenue):
        """Sets the is_allocated_as_revenue of this ClioPaymentsLinkBase.

        Whether the payment link is allocated as revenue.

        :param is_allocated_as_revenue: The is_allocated_as_revenue of this ClioPaymentsLinkBase.
        :type is_allocated_as_revenue: bool
        """

        self._is_allocated_as_revenue = is_allocated_as_revenue

    @property
    def redirect_url(self):
        """Gets the redirect_url of this ClioPaymentsLinkBase.

        The URL to redirect the client to after the payment has been made.

        :return: The redirect_url of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._redirect_url

    @redirect_url.setter
    def redirect_url(self, redirect_url):
        """Sets the redirect_url of this ClioPaymentsLinkBase.

        The URL to redirect the client to after the payment has been made.

        :param redirect_url: The redirect_url of this ClioPaymentsLinkBase.
        :type redirect_url: str
        """

        self._redirect_url = redirect_url

    @property
    def url(self):
        """Gets the url of this ClioPaymentsLinkBase.

        The URL of the payment link.

        :return: The url of this ClioPaymentsLinkBase.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this ClioPaymentsLinkBase.

        The URL of the payment link.

        :param url: The url of this ClioPaymentsLinkBase.
        :type url: str
        """

        self._url = url
