# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.activity_base import ActivityBase
from openapi_server.models.communication_eml_file_base import CommunicationEmlFileBase
from openapi_server.models.document_base import DocumentBase
from openapi_server.models.external_property_base import ExternalPropertyBase
from openapi_server.models.matter_base import MatterBase
from openapi_server.models.notification_event_subscriber_base import NotificationEventSubscriberBase
from openapi_server.models.participant import Participant
from openapi_server.models.user_base import UserBase
from openapi_server import util


class Communication(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, subject: str=None, body: str=None, type: str=None, _date: date=None, time_entries_count: int=None, created_at: datetime=None, updated_at: datetime=None, received_at: datetime=None, user: UserBase=None, matter: MatterBase=None, communication_eml_file: CommunicationEmlFileBase=None, senders: List[Participant]=None, receivers: List[Participant]=None, external_properties: List[ExternalPropertyBase]=None, time_entries: List[ActivityBase]=None, documents: List[DocumentBase]=None, notification_event_subscribers: List[NotificationEventSubscriberBase]=None):
        """Communication - a model defined in OpenAPI

        :param id: The id of this Communication.
        :param etag: The etag of this Communication.
        :param subject: The subject of this Communication.
        :param body: The body of this Communication.
        :param type: The type of this Communication.
        :param _date: The _date of this Communication.
        :param time_entries_count: The time_entries_count of this Communication.
        :param created_at: The created_at of this Communication.
        :param updated_at: The updated_at of this Communication.
        :param received_at: The received_at of this Communication.
        :param user: The user of this Communication.
        :param matter: The matter of this Communication.
        :param communication_eml_file: The communication_eml_file of this Communication.
        :param senders: The senders of this Communication.
        :param receivers: The receivers of this Communication.
        :param external_properties: The external_properties of this Communication.
        :param time_entries: The time_entries of this Communication.
        :param documents: The documents of this Communication.
        :param notification_event_subscribers: The notification_event_subscribers of this Communication.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'subject': str,
            'body': str,
            'type': str,
            '_date': date,
            'time_entries_count': int,
            'created_at': datetime,
            'updated_at': datetime,
            'received_at': datetime,
            'user': UserBase,
            'matter': MatterBase,
            'communication_eml_file': CommunicationEmlFileBase,
            'senders': List[Participant],
            'receivers': List[Participant],
            'external_properties': List[ExternalPropertyBase],
            'time_entries': List[ActivityBase],
            'documents': List[DocumentBase],
            'notification_event_subscribers': List[NotificationEventSubscriberBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'subject': 'subject',
            'body': 'body',
            'type': 'type',
            '_date': 'date',
            'time_entries_count': 'time_entries_count',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'received_at': 'received_at',
            'user': 'user',
            'matter': 'matter',
            'communication_eml_file': 'communication_eml_file',
            'senders': 'senders',
            'receivers': 'receivers',
            'external_properties': 'external_properties',
            'time_entries': 'time_entries',
            'documents': 'documents',
            'notification_event_subscribers': 'notification_event_subscribers'
        }

        self._id = id
        self._etag = etag
        self._subject = subject
        self._body = body
        self._type = type
        self.__date = _date
        self._time_entries_count = time_entries_count
        self._created_at = created_at
        self._updated_at = updated_at
        self._received_at = received_at
        self._user = user
        self._matter = matter
        self._communication_eml_file = communication_eml_file
        self._senders = senders
        self._receivers = receivers
        self._external_properties = external_properties
        self._time_entries = time_entries
        self._documents = documents
        self._notification_event_subscribers = notification_event_subscribers

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Communication':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Communication of this Communication.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Communication.

        Unique identifier for the *Communication*

        :return: The id of this Communication.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Communication.

        Unique identifier for the *Communication*

        :param id: The id of this Communication.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Communication.

        ETag for the *Communication*

        :return: The etag of this Communication.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Communication.

        ETag for the *Communication*

        :param etag: The etag of this Communication.
        :type etag: str
        """

        self._etag = etag

    @property
    def subject(self):
        """Gets the subject of this Communication.

        The subject line of the *Communication*

        :return: The subject of this Communication.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this Communication.

        The subject line of the *Communication*

        :param subject: The subject of this Communication.
        :type subject: str
        """

        self._subject = subject

    @property
    def body(self):
        """Gets the body of this Communication.

        The main content of the *Communication*

        :return: The body of this Communication.
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this Communication.

        The main content of the *Communication*

        :param body: The body of this Communication.
        :type body: str
        """

        self._body = body

    @property
    def type(self):
        """Gets the type of this Communication.

        The type of the *Communication*

        :return: The type of this Communication.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Communication.

        The type of the *Communication*

        :param type: The type of this Communication.
        :type type: str
        """
        allowed_values = ["EmailCommunication", "PhoneCommunication"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def _date(self):
        """Gets the _date of this Communication.

        The date of the *Communication* (as a ISO-8601 datestamp)

        :return: The _date of this Communication.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this Communication.

        The date of the *Communication* (as a ISO-8601 datestamp)

        :param _date: The _date of this Communication.
        :type _date: date
        """

        self.__date = _date

    @property
    def time_entries_count(self):
        """Gets the time_entries_count of this Communication.

        The number of time_entries associated with the *Communication*

        :return: The time_entries_count of this Communication.
        :rtype: int
        """
        return self._time_entries_count

    @time_entries_count.setter
    def time_entries_count(self, time_entries_count):
        """Sets the time_entries_count of this Communication.

        The number of time_entries associated with the *Communication*

        :param time_entries_count: The time_entries_count of this Communication.
        :type time_entries_count: int
        """

        self._time_entries_count = time_entries_count

    @property
    def created_at(self):
        """Gets the created_at of this Communication.

        The time the *Communication* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Communication.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Communication.

        The time the *Communication* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Communication.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Communication.

        The time the *Communication* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Communication.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Communication.

        The time the *Communication* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Communication.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def received_at(self):
        """Gets the received_at of this Communication.

        The date-time of the *Communication* (in ISO-8601 format)

        :return: The received_at of this Communication.
        :rtype: datetime
        """
        return self._received_at

    @received_at.setter
    def received_at(self, received_at):
        """Sets the received_at of this Communication.

        The date-time of the *Communication* (in ISO-8601 format)

        :param received_at: The received_at of this Communication.
        :type received_at: datetime
        """

        self._received_at = received_at

    @property
    def user(self):
        """Gets the user of this Communication.


        :return: The user of this Communication.
        :rtype: UserBase
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this Communication.


        :param user: The user of this Communication.
        :type user: UserBase
        """

        self._user = user

    @property
    def matter(self):
        """Gets the matter of this Communication.


        :return: The matter of this Communication.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this Communication.


        :param matter: The matter of this Communication.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def communication_eml_file(self):
        """Gets the communication_eml_file of this Communication.


        :return: The communication_eml_file of this Communication.
        :rtype: CommunicationEmlFileBase
        """
        return self._communication_eml_file

    @communication_eml_file.setter
    def communication_eml_file(self, communication_eml_file):
        """Sets the communication_eml_file of this Communication.


        :param communication_eml_file: The communication_eml_file of this Communication.
        :type communication_eml_file: CommunicationEmlFileBase
        """

        self._communication_eml_file = communication_eml_file

    @property
    def senders(self):
        """Gets the senders of this Communication.

        Participant

        :return: The senders of this Communication.
        :rtype: List[Participant]
        """
        return self._senders

    @senders.setter
    def senders(self, senders):
        """Sets the senders of this Communication.

        Participant

        :param senders: The senders of this Communication.
        :type senders: List[Participant]
        """

        self._senders = senders

    @property
    def receivers(self):
        """Gets the receivers of this Communication.

        Participant

        :return: The receivers of this Communication.
        :rtype: List[Participant]
        """
        return self._receivers

    @receivers.setter
    def receivers(self, receivers):
        """Sets the receivers of this Communication.

        Participant

        :param receivers: The receivers of this Communication.
        :type receivers: List[Participant]
        """

        self._receivers = receivers

    @property
    def external_properties(self):
        """Gets the external_properties of this Communication.

        ExternalProperty

        :return: The external_properties of this Communication.
        :rtype: List[ExternalPropertyBase]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this Communication.

        ExternalProperty

        :param external_properties: The external_properties of this Communication.
        :type external_properties: List[ExternalPropertyBase]
        """

        self._external_properties = external_properties

    @property
    def time_entries(self):
        """Gets the time_entries of this Communication.

        Activity

        :return: The time_entries of this Communication.
        :rtype: List[ActivityBase]
        """
        return self._time_entries

    @time_entries.setter
    def time_entries(self, time_entries):
        """Sets the time_entries of this Communication.

        Activity

        :param time_entries: The time_entries of this Communication.
        :type time_entries: List[ActivityBase]
        """

        self._time_entries = time_entries

    @property
    def documents(self):
        """Gets the documents of this Communication.

        Document

        :return: The documents of this Communication.
        :rtype: List[DocumentBase]
        """
        return self._documents

    @documents.setter
    def documents(self, documents):
        """Sets the documents of this Communication.

        Document

        :param documents: The documents of this Communication.
        :type documents: List[DocumentBase]
        """

        self._documents = documents

    @property
    def notification_event_subscribers(self):
        """Gets the notification_event_subscribers of this Communication.

        NotificationEventSubscriber

        :return: The notification_event_subscribers of this Communication.
        :rtype: List[NotificationEventSubscriberBase]
        """
        return self._notification_event_subscribers

    @notification_event_subscribers.setter
    def notification_event_subscribers(self, notification_event_subscribers):
        """Sets the notification_event_subscribers of this Communication.

        NotificationEventSubscriber

        :param notification_event_subscribers: The notification_event_subscribers of this Communication.
        :type notification_event_subscribers: List[NotificationEventSubscriberBase]
        """

        self._notification_event_subscribers = notification_event_subscribers
