# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class CommunicationUpdateRequestDataNotificationEventSubscribersInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, user_id: str=None, id: int=None, destroy: bool=None):
        """CommunicationUpdateRequestDataNotificationEventSubscribersInner - a model defined in OpenAPI

        :param user_id: The user_id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :param id: The id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :param destroy: The destroy of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        """
        self.openapi_types = {
            'user_id': str,
            'id': int,
            'destroy': bool
        }

        self.attribute_map = {
            'user_id': 'user_id',
            'id': 'id',
            'destroy': '_destroy'
        }

        self._user_id = user_id
        self._id = id
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CommunicationUpdateRequestDataNotificationEventSubscribersInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Communication_update_request_data_notification_event_subscribers_inner of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def user_id(self):
        """Gets the user_id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        The unique identifier for a User to be added as a notification event subscriber to the Phone Log Communication. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :return: The user_id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        The unique identifier for a User to be added as a notification event subscriber to the Phone Log Communication. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :param user_id: The user_id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :type user_id: str
        """

        self._user_id = user_id

    @property
    def id(self):
        """Gets the id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        Unique id of this Communication. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :return: The id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        Unique id of this Communication. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :param id: The id of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :type id: int
        """

        self._id = id

    @property
    def destroy(self):
        """Gets the destroy of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        Whether or not the notification event subscriber should be deleted. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :return: The destroy of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.

        Whether or not the notification event subscriber should be deleted. Note: Only applicable to Phone Log Communications, invalid for other communication types.

        :param destroy: The destroy of this CommunicationUpdateRequestDataNotificationEventSubscribersInner.
        :type destroy: bool
        """

        self._destroy = destroy
