# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ContactCreateRequestDataAddressesInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, name: str='Other', street: str=None, city: str=None, province: str=None, postal_code: str=None, country: str=None):
        """ContactCreateRequestDataAddressesInner - a model defined in OpenAPI

        :param name: The name of this ContactCreateRequestDataAddressesInner.
        :param street: The street of this ContactCreateRequestDataAddressesInner.
        :param city: The city of this ContactCreateRequestDataAddressesInner.
        :param province: The province of this ContactCreateRequestDataAddressesInner.
        :param postal_code: The postal_code of this ContactCreateRequestDataAddressesInner.
        :param country: The country of this ContactCreateRequestDataAddressesInner.
        """
        self.openapi_types = {
            'name': str,
            'street': str,
            'city': str,
            'province': str,
            'postal_code': str,
            'country': str
        }

        self.attribute_map = {
            'name': 'name',
            'street': 'street',
            'city': 'city',
            'province': 'province',
            'postal_code': 'postal_code',
            'country': 'country'
        }

        self._name = name
        self._street = street
        self._city = city
        self._province = province
        self._postal_code = postal_code
        self._country = country

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ContactCreateRequestDataAddressesInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Contact_create_request_data_addresses_inner of this ContactCreateRequestDataAddressesInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def name(self):
        """Gets the name of this ContactCreateRequestDataAddressesInner.

        Name of the Address.

        :return: The name of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContactCreateRequestDataAddressesInner.

        Name of the Address.

        :param name: The name of this ContactCreateRequestDataAddressesInner.
        :type name: str
        """
        allowed_values = ["Work", "Home", "Billing", "Other"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def street(self):
        """Gets the street of this ContactCreateRequestDataAddressesInner.

        Street.

        :return: The street of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._street

    @street.setter
    def street(self, street):
        """Sets the street of this ContactCreateRequestDataAddressesInner.

        Street.

        :param street: The street of this ContactCreateRequestDataAddressesInner.
        :type street: str
        """

        self._street = street

    @property
    def city(self):
        """Gets the city of this ContactCreateRequestDataAddressesInner.

        City.

        :return: The city of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this ContactCreateRequestDataAddressesInner.

        City.

        :param city: The city of this ContactCreateRequestDataAddressesInner.
        :type city: str
        """

        self._city = city

    @property
    def province(self):
        """Gets the province of this ContactCreateRequestDataAddressesInner.

        Province or state.

        :return: The province of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._province

    @province.setter
    def province(self, province):
        """Sets the province of this ContactCreateRequestDataAddressesInner.

        Province or state.

        :param province: The province of this ContactCreateRequestDataAddressesInner.
        :type province: str
        """

        self._province = province

    @property
    def postal_code(self):
        """Gets the postal_code of this ContactCreateRequestDataAddressesInner.

        Postal code or zip code.

        :return: The postal_code of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this ContactCreateRequestDataAddressesInner.

        Postal code or zip code.

        :param postal_code: The postal_code of this ContactCreateRequestDataAddressesInner.
        :type postal_code: str
        """

        self._postal_code = postal_code

    @property
    def country(self):
        """Gets the country of this ContactCreateRequestDataAddressesInner.

        Country

        :return: The country of this ContactCreateRequestDataAddressesInner.
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this ContactCreateRequestDataAddressesInner.

        Country

        :param country: The country of this ContactCreateRequestDataAddressesInner.
        :type country: str
        """

        self._country = country
