# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ContactUpdateRequestDataInstantMessengersInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, name: str='Other', address: str=None, id: int=None, destroy: bool=None):
        """ContactUpdateRequestDataInstantMessengersInner - a model defined in OpenAPI

        :param name: The name of this ContactUpdateRequestDataInstantMessengersInner.
        :param address: The address of this ContactUpdateRequestDataInstantMessengersInner.
        :param id: The id of this ContactUpdateRequestDataInstantMessengersInner.
        :param destroy: The destroy of this ContactUpdateRequestDataInstantMessengersInner.
        """
        self.openapi_types = {
            'name': str,
            'address': str,
            'id': int,
            'destroy': bool
        }

        self.attribute_map = {
            'name': 'name',
            'address': 'address',
            'id': 'id',
            'destroy': '_destroy'
        }

        self._name = name
        self._address = address
        self._id = id
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ContactUpdateRequestDataInstantMessengersInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Contact_update_request_data_instant_messengers_inner of this ContactUpdateRequestDataInstantMessengersInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def name(self):
        """Gets the name of this ContactUpdateRequestDataInstantMessengersInner.

        Name of the InstantMessenger.

        :return: The name of this ContactUpdateRequestDataInstantMessengersInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContactUpdateRequestDataInstantMessengersInner.

        Name of the InstantMessenger.

        :param name: The name of this ContactUpdateRequestDataInstantMessengersInner.
        :type name: str
        """
        allowed_values = ["Work", "Personal", "Other"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def address(self):
        """Gets the address of this ContactUpdateRequestDataInstantMessengersInner.

        Address of the InstantMessenger.

        :return: The address of this ContactUpdateRequestDataInstantMessengersInner.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this ContactUpdateRequestDataInstantMessengersInner.

        Address of the InstantMessenger.

        :param address: The address of this ContactUpdateRequestDataInstantMessengersInner.
        :type address: str
        """

        self._address = address

    @property
    def id(self):
        """Gets the id of this ContactUpdateRequestDataInstantMessengersInner.

        The unique identifier for a single InstantMessenger associated with the Contact. The keyword `null` is not valid for this field.

        :return: The id of this ContactUpdateRequestDataInstantMessengersInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ContactUpdateRequestDataInstantMessengersInner.

        The unique identifier for a single InstantMessenger associated with the Contact. The keyword `null` is not valid for this field.

        :param id: The id of this ContactUpdateRequestDataInstantMessengersInner.
        :type id: int
        """

        self._id = id

    @property
    def destroy(self):
        """Gets the destroy of this ContactUpdateRequestDataInstantMessengersInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated InstantMessenger is present, the InstantMessenger is deleted from the Contact.

        :return: The destroy of this ContactUpdateRequestDataInstantMessengersInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this ContactUpdateRequestDataInstantMessengersInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated InstantMessenger is present, the InstantMessenger is deleted from the Contact.

        :param destroy: The destroy of this ContactUpdateRequestDataInstantMessengersInner.
        :type destroy: bool
        """

        self._destroy = destroy
