# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ContactUpdateRequestDataWebSitesInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, name: str='Other', address: str=None, id: int=None, default_web_site: bool=None, destroy: bool=None):
        """ContactUpdateRequestDataWebSitesInner - a model defined in OpenAPI

        :param name: The name of this ContactUpdateRequestDataWebSitesInner.
        :param address: The address of this ContactUpdateRequestDataWebSitesInner.
        :param id: The id of this ContactUpdateRequestDataWebSitesInner.
        :param default_web_site: The default_web_site of this ContactUpdateRequestDataWebSitesInner.
        :param destroy: The destroy of this ContactUpdateRequestDataWebSitesInner.
        """
        self.openapi_types = {
            'name': str,
            'address': str,
            'id': int,
            'default_web_site': bool,
            'destroy': bool
        }

        self.attribute_map = {
            'name': 'name',
            'address': 'address',
            'id': 'id',
            'default_web_site': 'default_web_site',
            'destroy': '_destroy'
        }

        self._name = name
        self._address = address
        self._id = id
        self._default_web_site = default_web_site
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ContactUpdateRequestDataWebSitesInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Contact_update_request_data_web_sites_inner of this ContactUpdateRequestDataWebSitesInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def name(self):
        """Gets the name of this ContactUpdateRequestDataWebSitesInner.

        Name of the WebSite.

        :return: The name of this ContactUpdateRequestDataWebSitesInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContactUpdateRequestDataWebSitesInner.

        Name of the WebSite.

        :param name: The name of this ContactUpdateRequestDataWebSitesInner.
        :type name: str
        """
        allowed_values = ["Work", "Personal", "Twitter", "Facebook", "LinkedIn", "Instant Messenger", "Other"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def address(self):
        """Gets the address of this ContactUpdateRequestDataWebSitesInner.

        URL of the WebSite.

        :return: The address of this ContactUpdateRequestDataWebSitesInner.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this ContactUpdateRequestDataWebSitesInner.

        URL of the WebSite.

        :param address: The address of this ContactUpdateRequestDataWebSitesInner.
        :type address: str
        """

        self._address = address

    @property
    def id(self):
        """Gets the id of this ContactUpdateRequestDataWebSitesInner.

        The unique identifier for a single WebSite associated with the Contact. The keyword `null` is not valid for this field.

        :return: The id of this ContactUpdateRequestDataWebSitesInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ContactUpdateRequestDataWebSitesInner.

        The unique identifier for a single WebSite associated with the Contact. The keyword `null` is not valid for this field.

        :param id: The id of this ContactUpdateRequestDataWebSitesInner.
        :type id: int
        """

        self._id = id

    @property
    def default_web_site(self):
        """Gets the default_web_site of this ContactUpdateRequestDataWebSitesInner.

        Whether or not the Contact should be the default website for the Contact.

        :return: The default_web_site of this ContactUpdateRequestDataWebSitesInner.
        :rtype: bool
        """
        return self._default_web_site

    @default_web_site.setter
    def default_web_site(self, default_web_site):
        """Sets the default_web_site of this ContactUpdateRequestDataWebSitesInner.

        Whether or not the Contact should be the default website for the Contact.

        :param default_web_site: The default_web_site of this ContactUpdateRequestDataWebSitesInner.
        :type default_web_site: bool
        """

        self._default_web_site = default_web_site

    @property
    def destroy(self):
        """Gets the destroy of this ContactUpdateRequestDataWebSitesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated WebSite is present, the WebSite is deleted from the Contact.

        :return: The destroy of this ContactUpdateRequestDataWebSitesInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this ContactUpdateRequestDataWebSitesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated WebSite is present, the WebSite is deleted from the Contact.

        :param destroy: The destroy of this ContactUpdateRequestDataWebSitesInner.
        :type destroy: bool
        """

        self._destroy = destroy
