# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ContingencyFeeBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, show_contingency_award: bool=None):
        """ContingencyFeeBase - a model defined in OpenAPI

        :param id: The id of this ContingencyFeeBase.
        :param etag: The etag of this ContingencyFeeBase.
        :param created_at: The created_at of this ContingencyFeeBase.
        :param updated_at: The updated_at of this ContingencyFeeBase.
        :param show_contingency_award: The show_contingency_award of this ContingencyFeeBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'show_contingency_award': bool
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'show_contingency_award': 'show_contingency_award'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._show_contingency_award = show_contingency_award

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ContingencyFeeBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ContingencyFee_base of this ContingencyFeeBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ContingencyFeeBase.

        Unique identifier for the *ContingencyFee*

        :return: The id of this ContingencyFeeBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ContingencyFeeBase.

        Unique identifier for the *ContingencyFee*

        :param id: The id of this ContingencyFeeBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ContingencyFeeBase.

        ETag for the *ContingencyFee*

        :return: The etag of this ContingencyFeeBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ContingencyFeeBase.

        ETag for the *ContingencyFee*

        :param etag: The etag of this ContingencyFeeBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this ContingencyFeeBase.

        The time the *ContingencyFee* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ContingencyFeeBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ContingencyFeeBase.

        The time the *ContingencyFee* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ContingencyFeeBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ContingencyFeeBase.

        The time the *ContingencyFee* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ContingencyFeeBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ContingencyFeeBase.

        The time the *ContingencyFee* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ContingencyFeeBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def show_contingency_award(self):
        """Gets the show_contingency_award of this ContingencyFeeBase.

        Whether the *ContingencyFee* is posted or on a bill

        :return: The show_contingency_award of this ContingencyFeeBase.
        :rtype: bool
        """
        return self._show_contingency_award

    @show_contingency_award.setter
    def show_contingency_award(self, show_contingency_award):
        """Sets the show_contingency_award of this ContingencyFeeBase.

        Whether the *ContingencyFee* is posted or on a bill

        :param show_contingency_award: The show_contingency_award of this ContingencyFeeBase.
        :type show_contingency_award: bool
        """

        self._show_contingency_award = show_contingency_award
