# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ConversationBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, archived: bool=None, read_only: bool=None, current_user_is_member: bool=None, subject: str=None, message_count: int=None, time_entries_count: int=None, read: bool=None, created_at: datetime=None, updated_at: datetime=None):
        """ConversationBase - a model defined in OpenAPI

        :param id: The id of this ConversationBase.
        :param etag: The etag of this ConversationBase.
        :param archived: The archived of this ConversationBase.
        :param read_only: The read_only of this ConversationBase.
        :param current_user_is_member: The current_user_is_member of this ConversationBase.
        :param subject: The subject of this ConversationBase.
        :param message_count: The message_count of this ConversationBase.
        :param time_entries_count: The time_entries_count of this ConversationBase.
        :param read: The read of this ConversationBase.
        :param created_at: The created_at of this ConversationBase.
        :param updated_at: The updated_at of this ConversationBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'archived': bool,
            'read_only': bool,
            'current_user_is_member': bool,
            'subject': str,
            'message_count': int,
            'time_entries_count': int,
            'read': bool,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'archived': 'archived',
            'read_only': 'read_only',
            'current_user_is_member': 'current_user_is_member',
            'subject': 'subject',
            'message_count': 'message_count',
            'time_entries_count': 'time_entries_count',
            'read': 'read',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._archived = archived
        self._read_only = read_only
        self._current_user_is_member = current_user_is_member
        self._subject = subject
        self._message_count = message_count
        self._time_entries_count = time_entries_count
        self._read = read
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ConversationBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Conversation_base of this ConversationBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ConversationBase.

        Unique identifier for the *Conversation*

        :return: The id of this ConversationBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConversationBase.

        Unique identifier for the *Conversation*

        :param id: The id of this ConversationBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ConversationBase.

        ETag for the *Conversation*

        :return: The etag of this ConversationBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ConversationBase.

        ETag for the *Conversation*

        :param etag: The etag of this ConversationBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def archived(self):
        """Gets the archived of this ConversationBase.

        Whether the conversation has been archived

        :return: The archived of this ConversationBase.
        :rtype: bool
        """
        return self._archived

    @archived.setter
    def archived(self, archived):
        """Sets the archived of this ConversationBase.

        Whether the conversation has been archived

        :param archived: The archived of this ConversationBase.
        :type archived: bool
        """

        self._archived = archived

    @property
    def read_only(self):
        """Gets the read_only of this ConversationBase.

        Whether the conversation is read only

        :return: The read_only of this ConversationBase.
        :rtype: bool
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """Sets the read_only of this ConversationBase.

        Whether the conversation is read only

        :param read_only: The read_only of this ConversationBase.
        :type read_only: bool
        """

        self._read_only = read_only

    @property
    def current_user_is_member(self):
        """Gets the current_user_is_member of this ConversationBase.

        Whether the current user is a member of this conversation

        :return: The current_user_is_member of this ConversationBase.
        :rtype: bool
        """
        return self._current_user_is_member

    @current_user_is_member.setter
    def current_user_is_member(self, current_user_is_member):
        """Sets the current_user_is_member of this ConversationBase.

        Whether the current user is a member of this conversation

        :param current_user_is_member: The current_user_is_member of this ConversationBase.
        :type current_user_is_member: bool
        """

        self._current_user_is_member = current_user_is_member

    @property
    def subject(self):
        """Gets the subject of this ConversationBase.

        The subject of the *Conversation*

        :return: The subject of this ConversationBase.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this ConversationBase.

        The subject of the *Conversation*

        :param subject: The subject of this ConversationBase.
        :type subject: str
        """

        self._subject = subject

    @property
    def message_count(self):
        """Gets the message_count of this ConversationBase.

        The number of messages in this conversation

        :return: The message_count of this ConversationBase.
        :rtype: int
        """
        return self._message_count

    @message_count.setter
    def message_count(self, message_count):
        """Sets the message_count of this ConversationBase.

        The number of messages in this conversation

        :param message_count: The message_count of this ConversationBase.
        :type message_count: int
        """

        self._message_count = message_count

    @property
    def time_entries_count(self):
        """Gets the time_entries_count of this ConversationBase.

        The number of time entries applied to this conversation

        :return: The time_entries_count of this ConversationBase.
        :rtype: int
        """
        return self._time_entries_count

    @time_entries_count.setter
    def time_entries_count(self, time_entries_count):
        """Sets the time_entries_count of this ConversationBase.

        The number of time entries applied to this conversation

        :param time_entries_count: The time_entries_count of this ConversationBase.
        :type time_entries_count: int
        """

        self._time_entries_count = time_entries_count

    @property
    def read(self):
        """Gets the read of this ConversationBase.

        Whether any messages in this conversation have been viewed

        :return: The read of this ConversationBase.
        :rtype: bool
        """
        return self._read

    @read.setter
    def read(self, read):
        """Sets the read of this ConversationBase.

        Whether any messages in this conversation have been viewed

        :param read: The read of this ConversationBase.
        :type read: bool
        """

        self._read = read

    @property
    def created_at(self):
        """Gets the created_at of this ConversationBase.

        The time the *Conversation* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ConversationBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ConversationBase.

        The time the *Conversation* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ConversationBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ConversationBase.

        The time the *Conversation* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ConversationBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ConversationBase.

        The time the *Conversation* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ConversationBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
