# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ConversationMembership(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, read: bool=None, archived: bool=None, created_at: datetime=None, updated_at: datetime=None, member: object=None):
        """ConversationMembership - a model defined in OpenAPI

        :param id: The id of this ConversationMembership.
        :param etag: The etag of this ConversationMembership.
        :param read: The read of this ConversationMembership.
        :param archived: The archived of this ConversationMembership.
        :param created_at: The created_at of this ConversationMembership.
        :param updated_at: The updated_at of this ConversationMembership.
        :param member: The member of this ConversationMembership.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'read': bool,
            'archived': bool,
            'created_at': datetime,
            'updated_at': datetime,
            'member': object
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'read': 'read',
            'archived': 'archived',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'member': 'member'
        }

        self._id = id
        self._etag = etag
        self._read = read
        self._archived = archived
        self._created_at = created_at
        self._updated_at = updated_at
        self._member = member

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ConversationMembership':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ConversationMembership of this ConversationMembership.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ConversationMembership.

        Unique identifier for the *ConversationMembership*

        :return: The id of this ConversationMembership.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConversationMembership.

        Unique identifier for the *ConversationMembership*

        :param id: The id of this ConversationMembership.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ConversationMembership.

        ETag for the *ConversationMembership*

        :return: The etag of this ConversationMembership.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ConversationMembership.

        ETag for the *ConversationMembership*

        :param etag: The etag of this ConversationMembership.
        :type etag: str
        """

        self._etag = etag

    @property
    def read(self):
        """Gets the read of this ConversationMembership.

        Whether or not the ConversationMembership has been read by the member

        :return: The read of this ConversationMembership.
        :rtype: bool
        """
        return self._read

    @read.setter
    def read(self, read):
        """Sets the read of this ConversationMembership.

        Whether or not the ConversationMembership has been read by the member

        :param read: The read of this ConversationMembership.
        :type read: bool
        """

        self._read = read

    @property
    def archived(self):
        """Gets the archived of this ConversationMembership.

        Whether or not the ConversationMembership has been archived by the member

        :return: The archived of this ConversationMembership.
        :rtype: bool
        """
        return self._archived

    @archived.setter
    def archived(self, archived):
        """Sets the archived of this ConversationMembership.

        Whether or not the ConversationMembership has been archived by the member

        :param archived: The archived of this ConversationMembership.
        :type archived: bool
        """

        self._archived = archived

    @property
    def created_at(self):
        """Gets the created_at of this ConversationMembership.

        The time the *ConversationMembership* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ConversationMembership.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ConversationMembership.

        The time the *ConversationMembership* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ConversationMembership.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ConversationMembership.

        The time the *ConversationMembership* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ConversationMembership.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ConversationMembership.

        The time the *ConversationMembership* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ConversationMembership.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def member(self):
        """Gets the member of this ConversationMembership.


        :return: The member of this ConversationMembership.
        :rtype: object
        """
        return self._member

    @member.setter
    def member(self, member):
        """Sets the member of this ConversationMembership.


        :param member: The member of this ConversationMembership.
        :type member: object
        """

        self._member = member
