# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ConversationMessageBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, _date: str=None, body: str=None, created_at: datetime=None, updated_at: datetime=None):
        """ConversationMessageBase - a model defined in OpenAPI

        :param id: The id of this ConversationMessageBase.
        :param etag: The etag of this ConversationMessageBase.
        :param _date: The _date of this ConversationMessageBase.
        :param body: The body of this ConversationMessageBase.
        :param created_at: The created_at of this ConversationMessageBase.
        :param updated_at: The updated_at of this ConversationMessageBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            '_date': str,
            'body': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            '_date': 'date',
            'body': 'body',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self.__date = _date
        self._body = body
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ConversationMessageBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ConversationMessage_base of this ConversationMessageBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ConversationMessageBase.

        Unique identifier for the *ConversationMessage*

        :return: The id of this ConversationMessageBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConversationMessageBase.

        Unique identifier for the *ConversationMessage*

        :param id: The id of this ConversationMessageBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ConversationMessageBase.

        ETag for the *ConversationMessage*

        :return: The etag of this ConversationMessageBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ConversationMessageBase.

        ETag for the *ConversationMessage*

        :param etag: The etag of this ConversationMessageBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def _date(self):
        """Gets the _date of this ConversationMessageBase.

        The creation date of the message in the current user's time zone

        :return: The _date of this ConversationMessageBase.
        :rtype: str
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this ConversationMessageBase.

        The creation date of the message in the current user's time zone

        :param _date: The _date of this ConversationMessageBase.
        :type _date: str
        """

        self.__date = _date

    @property
    def body(self):
        """Gets the body of this ConversationMessageBase.

        The main content of the *ConversationMessage*

        :return: The body of this ConversationMessageBase.
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this ConversationMessageBase.

        The main content of the *ConversationMessage*

        :param body: The body of this ConversationMessageBase.
        :type body: str
        """

        self._body = body

    @property
    def created_at(self):
        """Gets the created_at of this ConversationMessageBase.

        The time the *ConversationMessage* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ConversationMessageBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ConversationMessageBase.

        The time the *ConversationMessage* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ConversationMessageBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ConversationMessageBase.

        The time the *ConversationMessage* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ConversationMessageBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ConversationMessageBase.

        The time the *ConversationMessage* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ConversationMessageBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
