# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ConversationMessageCreateRequestDataAttachment(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, document_id: int=None, document_version_id: int=None):
        """ConversationMessageCreateRequestDataAttachment - a model defined in OpenAPI

        :param document_id: The document_id of this ConversationMessageCreateRequestDataAttachment.
        :param document_version_id: The document_version_id of this ConversationMessageCreateRequestDataAttachment.
        """
        self.openapi_types = {
            'document_id': int,
            'document_version_id': int
        }

        self.attribute_map = {
            'document_id': 'document_id',
            'document_version_id': 'document_version_id'
        }

        self._document_id = document_id
        self._document_version_id = document_version_id

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ConversationMessageCreateRequestDataAttachment':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ConversationMessage_create_request_data_attachment of this ConversationMessageCreateRequestDataAttachment.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def document_id(self):
        """Gets the document_id of this ConversationMessageCreateRequestDataAttachment.

        The document id of the attached document.

        :return: The document_id of this ConversationMessageCreateRequestDataAttachment.
        :rtype: int
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this ConversationMessageCreateRequestDataAttachment.

        The document id of the attached document.

        :param document_id: The document_id of this ConversationMessageCreateRequestDataAttachment.
        :type document_id: int
        """

        self._document_id = document_id

    @property
    def document_version_id(self):
        """Gets the document_version_id of this ConversationMessageCreateRequestDataAttachment.

        The document version id of the attached document.

        :return: The document_version_id of this ConversationMessageCreateRequestDataAttachment.
        :rtype: int
        """
        return self._document_version_id

    @document_version_id.setter
    def document_version_id(self, document_version_id):
        """Sets the document_version_id of this ConversationMessageCreateRequestDataAttachment.

        The document version id of the attached document.

        :param document_version_id: The document_version_id of this ConversationMessageCreateRequestDataAttachment.
        :type document_version_id: int
        """

        self._document_version_id = document_version_id
