# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class Currency(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, code: str=None, sign: str=None, created_at: datetime=None, updated_at: datetime=None):
        """Currency - a model defined in OpenAPI

        :param id: The id of this Currency.
        :param etag: The etag of this Currency.
        :param code: The code of this Currency.
        :param sign: The sign of this Currency.
        :param created_at: The created_at of this Currency.
        :param updated_at: The updated_at of this Currency.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'code': str,
            'sign': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'code': 'code',
            'sign': 'sign',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._code = code
        self._sign = sign
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Currency':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Currency of this Currency.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Currency.

        Unique identifier for the *Currency*

        :return: The id of this Currency.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Currency.

        Unique identifier for the *Currency*

        :param id: The id of this Currency.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Currency.

        ETag for the *Currency*

        :return: The etag of this Currency.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Currency.

        ETag for the *Currency*

        :param etag: The etag of this Currency.
        :type etag: str
        """

        self._etag = etag

    @property
    def code(self):
        """Gets the code of this Currency.

        ISO 4217 code for the *Currency*

        :return: The code of this Currency.
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this Currency.

        ISO 4217 code for the *Currency*

        :param code: The code of this Currency.
        :type code: str
        """

        self._code = code

    @property
    def sign(self):
        """Gets the sign of this Currency.

        Symbol used to denote monetary values using this *Currency*

        :return: The sign of this Currency.
        :rtype: str
        """
        return self._sign

    @sign.setter
    def sign(self, sign):
        """Sets the sign of this Currency.

        Symbol used to denote monetary values using this *Currency*

        :param sign: The sign of this Currency.
        :type sign: str
        """

        self._sign = sign

    @property
    def created_at(self):
        """Gets the created_at of this Currency.

        The time the *Currency* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Currency.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Currency.

        The time the *Currency* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Currency.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Currency.

        The time the *Currency* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Currency.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Currency.

        The time the *Currency* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Currency.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
