# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class CustomFieldCreateRequestDataPicklistOptionsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, option: str=None, deleted: bool=None):
        """CustomFieldCreateRequestDataPicklistOptionsInner - a model defined in OpenAPI

        :param id: The id of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :param option: The option of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :param deleted: The deleted of this CustomFieldCreateRequestDataPicklistOptionsInner.
        """
        self.openapi_types = {
            'id': int,
            'option': str,
            'deleted': bool
        }

        self.attribute_map = {
            'id': 'id',
            'option': 'option',
            'deleted': '_deleted'
        }

        self._id = id
        self._option = option
        self._deleted = deleted

    @classmethod
    def from_dict(cls, dikt: dict) -> 'CustomFieldCreateRequestDataPicklistOptionsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The CustomField_create_request_data_picklist_options_inner of this CustomFieldCreateRequestDataPicklistOptionsInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this CustomFieldCreateRequestDataPicklistOptionsInner.

        The unique identifier for a single PicklistOption associated with the CustomField. The keyword `null` is not valid for this field. Not required for creating new PicklistOptions, but required for updating or deleting existing ones.

        :return: The id of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomFieldCreateRequestDataPicklistOptionsInner.

        The unique identifier for a single PicklistOption associated with the CustomField. The keyword `null` is not valid for this field. Not required for creating new PicklistOptions, but required for updating or deleting existing ones.

        :param id: The id of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :type id: int
        """

        self._id = id

    @property
    def option(self):
        """Gets the option of this CustomFieldCreateRequestDataPicklistOptionsInner.

        The option value.

        :return: The option of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :rtype: str
        """
        return self._option

    @option.setter
    def option(self, option):
        """Sets the option of this CustomFieldCreateRequestDataPicklistOptionsInner.

        The option value.

        :param option: The option of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :type option: str
        """

        self._option = option

    @property
    def deleted(self):
        """Gets the deleted of this CustomFieldCreateRequestDataPicklistOptionsInner.

        Whether or not the PicklistOption should be deleted.

        :return: The deleted of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :rtype: bool
        """
        return self._deleted

    @deleted.setter
    def deleted(self, deleted):
        """Sets the deleted of this CustomFieldCreateRequestDataPicklistOptionsInner.

        Whether or not the PicklistOption should be deleted.

        :param deleted: The deleted of this CustomFieldCreateRequestDataPicklistOptionsInner.
        :type deleted: bool
        """

        self._deleted = deleted
