# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class DamageCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, amount: float=None, damage_type: str=None, description: str=None, matter_id: int=None):
        """DamageCreateRequestData - a model defined in OpenAPI

        :param amount: The amount of this DamageCreateRequestData.
        :param damage_type: The damage_type of this DamageCreateRequestData.
        :param description: The description of this DamageCreateRequestData.
        :param matter_id: The matter_id of this DamageCreateRequestData.
        """
        self.openapi_types = {
            'amount': float,
            'damage_type': str,
            'description': str,
            'matter_id': int
        }

        self.attribute_map = {
            'amount': 'amount',
            'damage_type': 'damage_type',
            'description': 'description',
            'matter_id': 'matter_id'
        }

        self._amount = amount
        self._damage_type = damage_type
        self._description = description
        self._matter_id = matter_id

    @classmethod
    def from_dict(cls, dikt: dict) -> 'DamageCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Damage_create_request_data of this DamageCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def amount(self):
        """Gets the amount of this DamageCreateRequestData.

        Amount

        :return: The amount of this DamageCreateRequestData.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this DamageCreateRequestData.

        Amount

        :param amount: The amount of this DamageCreateRequestData.
        :type amount: float
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")

        self._amount = amount

    @property
    def damage_type(self):
        """Gets the damage_type of this DamageCreateRequestData.

        Damage type

        :return: The damage_type of this DamageCreateRequestData.
        :rtype: str
        """
        return self._damage_type

    @damage_type.setter
    def damage_type(self, damage_type):
        """Sets the damage_type of this DamageCreateRequestData.

        Damage type

        :param damage_type: The damage_type of this DamageCreateRequestData.
        :type damage_type: str
        """
        allowed_values = ["special", "general", "other"]  # noqa: E501
        if damage_type not in allowed_values:
            raise ValueError(
                "Invalid value for `damage_type` ({0}), must be one of {1}"
                .format(damage_type, allowed_values)
            )

        self._damage_type = damage_type

    @property
    def description(self):
        """Gets the description of this DamageCreateRequestData.

        Description

        :return: The description of this DamageCreateRequestData.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DamageCreateRequestData.

        Description

        :param description: The description of this DamageCreateRequestData.
        :type description: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")

        self._description = description

    @property
    def matter_id(self):
        """Gets the matter_id of this DamageCreateRequestData.

        The unique identifier of the Matter to which the Damage is associated.

        :return: The matter_id of this DamageCreateRequestData.
        :rtype: int
        """
        return self._matter_id

    @matter_id.setter
    def matter_id(self, matter_id):
        """Sets the matter_id of this DamageCreateRequestData.

        The unique identifier of the Matter to which the Damage is associated.

        :param matter_id: The matter_id of this DamageCreateRequestData.
        :type matter_id: int
        """
        if matter_id is None:
            raise ValueError("Invalid value for `matter_id`, must not be `None`")

        self._matter_id = matter_id
