# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.clio_creator_base import ClioCreatorBase
from openapi_server.models.contact_base import ContactBase
from openapi_server.models.document_category_base import DocumentCategoryBase
from openapi_server.models.document_version import DocumentVersion
from openapi_server.models.document_version_base import DocumentVersionBase
from openapi_server.models.external_property_base import ExternalPropertyBase
from openapi_server.models.group_base import GroupBase
from openapi_server.models.linked_folder_base import LinkedFolderBase
from openapi_server.models.matter_base import MatterBase
from openapi_server import util


class Document(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, deleted_at: datetime=None, type: str=None, locked: bool=None, name: str=None, received_at: datetime=None, filename: str=None, size: int=None, content_type: str=None, parent: LinkedFolderBase=None, matter: MatterBase=None, contact: ContactBase=None, document_category: DocumentCategoryBase=None, creator: ClioCreatorBase=None, latest_document_version: DocumentVersion=None, group: GroupBase=None, external_properties: List[ExternalPropertyBase]=None, document_versions: List[DocumentVersionBase]=None):
        """Document - a model defined in OpenAPI

        :param id: The id of this Document.
        :param etag: The etag of this Document.
        :param created_at: The created_at of this Document.
        :param updated_at: The updated_at of this Document.
        :param deleted_at: The deleted_at of this Document.
        :param type: The type of this Document.
        :param locked: The locked of this Document.
        :param name: The name of this Document.
        :param received_at: The received_at of this Document.
        :param filename: The filename of this Document.
        :param size: The size of this Document.
        :param content_type: The content_type of this Document.
        :param parent: The parent of this Document.
        :param matter: The matter of this Document.
        :param contact: The contact of this Document.
        :param document_category: The document_category of this Document.
        :param creator: The creator of this Document.
        :param latest_document_version: The latest_document_version of this Document.
        :param group: The group of this Document.
        :param external_properties: The external_properties of this Document.
        :param document_versions: The document_versions of this Document.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'deleted_at': datetime,
            'type': str,
            'locked': bool,
            'name': str,
            'received_at': datetime,
            'filename': str,
            'size': int,
            'content_type': str,
            'parent': LinkedFolderBase,
            'matter': MatterBase,
            'contact': ContactBase,
            'document_category': DocumentCategoryBase,
            'creator': ClioCreatorBase,
            'latest_document_version': DocumentVersion,
            'group': GroupBase,
            'external_properties': List[ExternalPropertyBase],
            'document_versions': List[DocumentVersionBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'deleted_at': 'deleted_at',
            'type': 'type',
            'locked': 'locked',
            'name': 'name',
            'received_at': 'received_at',
            'filename': 'filename',
            'size': 'size',
            'content_type': 'content_type',
            'parent': 'parent',
            'matter': 'matter',
            'contact': 'contact',
            'document_category': 'document_category',
            'creator': 'creator',
            'latest_document_version': 'latest_document_version',
            'group': 'group',
            'external_properties': 'external_properties',
            'document_versions': 'document_versions'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._deleted_at = deleted_at
        self._type = type
        self._locked = locked
        self._name = name
        self._received_at = received_at
        self._filename = filename
        self._size = size
        self._content_type = content_type
        self._parent = parent
        self._matter = matter
        self._contact = contact
        self._document_category = document_category
        self._creator = creator
        self._latest_document_version = latest_document_version
        self._group = group
        self._external_properties = external_properties
        self._document_versions = document_versions

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Document':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Document of this Document.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Document.

        Unique identifier for the *Document*

        :return: The id of this Document.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Document.

        Unique identifier for the *Document*

        :param id: The id of this Document.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Document.

        ETag for the *Document*

        :return: The etag of this Document.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Document.

        ETag for the *Document*

        :param etag: The etag of this Document.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this Document.

        The time the *Document* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Document.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Document.

        The time the *Document* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Document.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Document.

        The time the *Document* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Document.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Document.

        The time the *Document* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Document.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def deleted_at(self):
        """Gets the deleted_at of this Document.

        The time the *Document* was deleted (as a ISO-8601 timestamp)

        :return: The deleted_at of this Document.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this Document.

        The time the *Document* was deleted (as a ISO-8601 timestamp)

        :param deleted_at: The deleted_at of this Document.
        :type deleted_at: datetime
        """

        self._deleted_at = deleted_at

    @property
    def type(self):
        """Gets the type of this Document.

        The type of the *Document*

        :return: The type of this Document.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Document.

        The type of the *Document*

        :param type: The type of this Document.
        :type type: str
        """
        allowed_values = ["Document"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def locked(self):
        """Gets the locked of this Document.

        Whether or not the Document is locked. Locked Document cannot be modified

        :return: The locked of this Document.
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this Document.

        Whether or not the Document is locked. Locked Document cannot be modified

        :param locked: The locked of this Document.
        :type locked: bool
        """

        self._locked = locked

    @property
    def name(self):
        """Gets the name of this Document.

        The name of the Document

        :return: The name of this Document.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Document.

        The name of the Document

        :param name: The name of this Document.
        :type name: str
        """

        self._name = name

    @property
    def received_at(self):
        """Gets the received_at of this Document.

        The time the last document version was received (as an ISO-8601 timestamp)

        :return: The received_at of this Document.
        :rtype: datetime
        """
        return self._received_at

    @received_at.setter
    def received_at(self, received_at):
        """Sets the received_at of this Document.

        The time the last document version was received (as an ISO-8601 timestamp)

        :param received_at: The received_at of this Document.
        :type received_at: datetime
        """

        self._received_at = received_at

    @property
    def filename(self):
        """Gets the filename of this Document.

        The uploaded file name of the latest document version.

        :return: The filename of this Document.
        :rtype: str
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """Sets the filename of this Document.

        The uploaded file name of the latest document version.

        :param filename: The filename of this Document.
        :type filename: str
        """

        self._filename = filename

    @property
    def size(self):
        """Gets the size of this Document.

        The file size

        :return: The size of this Document.
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this Document.

        The file size

        :param size: The size of this Document.
        :type size: int
        """

        self._size = size

    @property
    def content_type(self):
        """Gets the content_type of this Document.

        The uploaded file content type

        :return: The content_type of this Document.
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this Document.

        The uploaded file content type

        :param content_type: The content_type of this Document.
        :type content_type: str
        """

        self._content_type = content_type

    @property
    def parent(self):
        """Gets the parent of this Document.


        :return: The parent of this Document.
        :rtype: LinkedFolderBase
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this Document.


        :param parent: The parent of this Document.
        :type parent: LinkedFolderBase
        """

        self._parent = parent

    @property
    def matter(self):
        """Gets the matter of this Document.


        :return: The matter of this Document.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this Document.


        :param matter: The matter of this Document.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def contact(self):
        """Gets the contact of this Document.


        :return: The contact of this Document.
        :rtype: ContactBase
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this Document.


        :param contact: The contact of this Document.
        :type contact: ContactBase
        """

        self._contact = contact

    @property
    def document_category(self):
        """Gets the document_category of this Document.


        :return: The document_category of this Document.
        :rtype: DocumentCategoryBase
        """
        return self._document_category

    @document_category.setter
    def document_category(self, document_category):
        """Sets the document_category of this Document.


        :param document_category: The document_category of this Document.
        :type document_category: DocumentCategoryBase
        """

        self._document_category = document_category

    @property
    def creator(self):
        """Gets the creator of this Document.


        :return: The creator of this Document.
        :rtype: ClioCreatorBase
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this Document.


        :param creator: The creator of this Document.
        :type creator: ClioCreatorBase
        """

        self._creator = creator

    @property
    def latest_document_version(self):
        """Gets the latest_document_version of this Document.


        :return: The latest_document_version of this Document.
        :rtype: DocumentVersion
        """
        return self._latest_document_version

    @latest_document_version.setter
    def latest_document_version(self, latest_document_version):
        """Sets the latest_document_version of this Document.


        :param latest_document_version: The latest_document_version of this Document.
        :type latest_document_version: DocumentVersion
        """

        self._latest_document_version = latest_document_version

    @property
    def group(self):
        """Gets the group of this Document.


        :return: The group of this Document.
        :rtype: GroupBase
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this Document.


        :param group: The group of this Document.
        :type group: GroupBase
        """

        self._group = group

    @property
    def external_properties(self):
        """Gets the external_properties of this Document.

        ExternalProperty

        :return: The external_properties of this Document.
        :rtype: List[ExternalPropertyBase]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this Document.

        ExternalProperty

        :param external_properties: The external_properties of this Document.
        :type external_properties: List[ExternalPropertyBase]
        """

        self._external_properties = external_properties

    @property
    def document_versions(self):
        """Gets the document_versions of this Document.

        DocumentVersion

        :return: The document_versions of this Document.
        :rtype: List[DocumentVersionBase]
        """
        return self._document_versions

    @document_versions.setter
    def document_versions(self, document_versions):
        """Sets the document_versions of this Document.

        DocumentVersion

        :param document_versions: The document_versions of this Document.
        :type document_versions: List[DocumentVersionBase]
        """

        self._document_versions = document_versions
