# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class DocumentBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, deleted_at: datetime=None, type: str=None, locked: bool=None, name: str=None, received_at: datetime=None, filename: str=None, size: int=None, content_type: str=None):
        """DocumentBase - a model defined in OpenAPI

        :param id: The id of this DocumentBase.
        :param etag: The etag of this DocumentBase.
        :param created_at: The created_at of this DocumentBase.
        :param updated_at: The updated_at of this DocumentBase.
        :param deleted_at: The deleted_at of this DocumentBase.
        :param type: The type of this DocumentBase.
        :param locked: The locked of this DocumentBase.
        :param name: The name of this DocumentBase.
        :param received_at: The received_at of this DocumentBase.
        :param filename: The filename of this DocumentBase.
        :param size: The size of this DocumentBase.
        :param content_type: The content_type of this DocumentBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'deleted_at': datetime,
            'type': str,
            'locked': bool,
            'name': str,
            'received_at': datetime,
            'filename': str,
            'size': int,
            'content_type': str
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'deleted_at': 'deleted_at',
            'type': 'type',
            'locked': 'locked',
            'name': 'name',
            'received_at': 'received_at',
            'filename': 'filename',
            'size': 'size',
            'content_type': 'content_type'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._deleted_at = deleted_at
        self._type = type
        self._locked = locked
        self._name = name
        self._received_at = received_at
        self._filename = filename
        self._size = size
        self._content_type = content_type

    @classmethod
    def from_dict(cls, dikt: dict) -> 'DocumentBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Document_base of this DocumentBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this DocumentBase.

        Unique identifier for the *Document*

        :return: The id of this DocumentBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DocumentBase.

        Unique identifier for the *Document*

        :param id: The id of this DocumentBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this DocumentBase.

        ETag for the *Document*

        :return: The etag of this DocumentBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this DocumentBase.

        ETag for the *Document*

        :param etag: The etag of this DocumentBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this DocumentBase.

        The time the *Document* was created (as a ISO-8601 timestamp)

        :return: The created_at of this DocumentBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this DocumentBase.

        The time the *Document* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this DocumentBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this DocumentBase.

        The time the *Document* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this DocumentBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this DocumentBase.

        The time the *Document* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this DocumentBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def deleted_at(self):
        """Gets the deleted_at of this DocumentBase.

        The time the *Document* was deleted (as a ISO-8601 timestamp)

        :return: The deleted_at of this DocumentBase.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this DocumentBase.

        The time the *Document* was deleted (as a ISO-8601 timestamp)

        :param deleted_at: The deleted_at of this DocumentBase.
        :type deleted_at: datetime
        """

        self._deleted_at = deleted_at

    @property
    def type(self):
        """Gets the type of this DocumentBase.

        The type of the *Document*

        :return: The type of this DocumentBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DocumentBase.

        The type of the *Document*

        :param type: The type of this DocumentBase.
        :type type: str
        """
        allowed_values = ["Document"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def locked(self):
        """Gets the locked of this DocumentBase.

        Whether or not the Document is locked. Locked Document cannot be modified

        :return: The locked of this DocumentBase.
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this DocumentBase.

        Whether or not the Document is locked. Locked Document cannot be modified

        :param locked: The locked of this DocumentBase.
        :type locked: bool
        """

        self._locked = locked

    @property
    def name(self):
        """Gets the name of this DocumentBase.

        The name of the Document

        :return: The name of this DocumentBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DocumentBase.

        The name of the Document

        :param name: The name of this DocumentBase.
        :type name: str
        """

        self._name = name

    @property
    def received_at(self):
        """Gets the received_at of this DocumentBase.

        The time the last document version was received (as an ISO-8601 timestamp)

        :return: The received_at of this DocumentBase.
        :rtype: datetime
        """
        return self._received_at

    @received_at.setter
    def received_at(self, received_at):
        """Sets the received_at of this DocumentBase.

        The time the last document version was received (as an ISO-8601 timestamp)

        :param received_at: The received_at of this DocumentBase.
        :type received_at: datetime
        """

        self._received_at = received_at

    @property
    def filename(self):
        """Gets the filename of this DocumentBase.

        The uploaded file name of the latest document version.

        :return: The filename of this DocumentBase.
        :rtype: str
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """Sets the filename of this DocumentBase.

        The uploaded file name of the latest document version.

        :param filename: The filename of this DocumentBase.
        :type filename: str
        """

        self._filename = filename

    @property
    def size(self):
        """Gets the size of this DocumentBase.

        The file size

        :return: The size of this DocumentBase.
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this DocumentBase.

        The file size

        :param size: The size of this DocumentBase.
        :type size: int
        """

        self._size = size

    @property
    def content_type(self):
        """Gets the content_type of this DocumentBase.

        The uploaded file content type

        :return: The content_type of this DocumentBase.
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this DocumentBase.

        The uploaded file content type

        :param content_type: The content_type of this DocumentBase.
        :type content_type: str
        """

        self._content_type = content_type
