# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ErrorDetail(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type: str=None, message: str=None):
        """ErrorDetail - a model defined in OpenAPI

        :param type: The type of this ErrorDetail.
        :param message: The message of this ErrorDetail.
        """
        self.openapi_types = {
            'type': str,
            'message': str
        }

        self.attribute_map = {
            'type': 'type',
            'message': 'message'
        }

        self._type = type
        self._message = message

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ErrorDetail':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ErrorDetail of this ErrorDetail.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self):
        """Gets the type of this ErrorDetail.

        Unique name for this error

        :return: The type of this ErrorDetail.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ErrorDetail.

        Unique name for this error

        :param type: The type of this ErrorDetail.
        :type type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")

        self._type = type

    @property
    def message(self):
        """Gets the message of this ErrorDetail.

        Detailed message about the error

        :return: The message of this ErrorDetail.
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ErrorDetail.

        Detailed message about the error

        :param message: The message of this ErrorDetail.
        :type message: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")

        self._message = message
