# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class EvergreenRetainerBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, created_at: datetime=None, updated_at: datetime=None, etag: str=None, minimum_threshold: float=None):
        """EvergreenRetainerBase - a model defined in OpenAPI

        :param id: The id of this EvergreenRetainerBase.
        :param created_at: The created_at of this EvergreenRetainerBase.
        :param updated_at: The updated_at of this EvergreenRetainerBase.
        :param etag: The etag of this EvergreenRetainerBase.
        :param minimum_threshold: The minimum_threshold of this EvergreenRetainerBase.
        """
        self.openapi_types = {
            'id': int,
            'created_at': datetime,
            'updated_at': datetime,
            'etag': str,
            'minimum_threshold': float
        }

        self.attribute_map = {
            'id': 'id',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'etag': 'etag',
            'minimum_threshold': 'minimum_threshold'
        }

        self._id = id
        self._created_at = created_at
        self._updated_at = updated_at
        self._etag = etag
        self._minimum_threshold = minimum_threshold

    @classmethod
    def from_dict(cls, dikt: dict) -> 'EvergreenRetainerBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The EvergreenRetainer_base of this EvergreenRetainerBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this EvergreenRetainerBase.

        Unique identifier for the *EvergreenRetainer*

        :return: The id of this EvergreenRetainerBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EvergreenRetainerBase.

        Unique identifier for the *EvergreenRetainer*

        :param id: The id of this EvergreenRetainerBase.
        :type id: int
        """

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this EvergreenRetainerBase.

        The time the *EvergreenRetainer* was created (as a ISO-8601 timestamp)

        :return: The created_at of this EvergreenRetainerBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this EvergreenRetainerBase.

        The time the *EvergreenRetainer* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this EvergreenRetainerBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this EvergreenRetainerBase.

        The time the *EvergreenRetainer* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this EvergreenRetainerBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this EvergreenRetainerBase.

        The time the *EvergreenRetainer* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this EvergreenRetainerBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def etag(self):
        """Gets the etag of this EvergreenRetainerBase.

        ETag for the *EvergreenRetainer*

        :return: The etag of this EvergreenRetainerBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this EvergreenRetainerBase.

        ETag for the *EvergreenRetainer*

        :param etag: The etag of this EvergreenRetainerBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def minimum_threshold(self):
        """Gets the minimum_threshold of this EvergreenRetainerBase.

        The trust balance threshold for the associated Matter. When the balance falls below the threshold, the retainer's associated recipients (firm users) will receive a notification.

        :return: The minimum_threshold of this EvergreenRetainerBase.
        :rtype: float
        """
        return self._minimum_threshold

    @minimum_threshold.setter
    def minimum_threshold(self, minimum_threshold):
        """Sets the minimum_threshold of this EvergreenRetainerBase.

        The trust balance threshold for the associated Matter. When the balance falls below the threshold, the retainer's associated recipients (firm users) will receive a notification.

        :param minimum_threshold: The minimum_threshold of this EvergreenRetainerBase.
        :type minimum_threshold: float
        """

        self._minimum_threshold = minimum_threshold
