# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ExternalPropertyBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, value: str=None, created_at: datetime=None, updated_at: datetime=None):
        """ExternalPropertyBase - a model defined in OpenAPI

        :param id: The id of this ExternalPropertyBase.
        :param etag: The etag of this ExternalPropertyBase.
        :param name: The name of this ExternalPropertyBase.
        :param value: The value of this ExternalPropertyBase.
        :param created_at: The created_at of this ExternalPropertyBase.
        :param updated_at: The updated_at of this ExternalPropertyBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'value': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'value': 'value',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._value = value
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ExternalPropertyBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ExternalProperty_base of this ExternalPropertyBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ExternalPropertyBase.

        Unique identifier for the *ExternalProperty*

        :return: The id of this ExternalPropertyBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExternalPropertyBase.

        Unique identifier for the *ExternalProperty*

        :param id: The id of this ExternalPropertyBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ExternalPropertyBase.

        ETag for the *ExternalProperty*

        :return: The etag of this ExternalPropertyBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ExternalPropertyBase.

        ETag for the *ExternalProperty*

        :param etag: The etag of this ExternalPropertyBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this ExternalPropertyBase.

        The name of the *ExternalProperty*

        :return: The name of this ExternalPropertyBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ExternalPropertyBase.

        The name of the *ExternalProperty*

        :param name: The name of this ExternalPropertyBase.
        :type name: str
        """

        self._name = name

    @property
    def value(self):
        """Gets the value of this ExternalPropertyBase.

        The value of the *ExternalProperty*

        :return: The value of this ExternalPropertyBase.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this ExternalPropertyBase.

        The value of the *ExternalProperty*

        :param value: The value of this ExternalPropertyBase.
        :type value: str
        """

        self._value = value

    @property
    def created_at(self):
        """Gets the created_at of this ExternalPropertyBase.

        The time the *ExternalProperty* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ExternalPropertyBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ExternalPropertyBase.

        The time the *ExternalProperty* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ExternalPropertyBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ExternalPropertyBase.

        The time the *ExternalProperty* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ExternalPropertyBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ExternalPropertyBase.

        The time the *ExternalProperty* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ExternalPropertyBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
