# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.clio_creator_base import ClioCreatorBase
from openapi_server.models.contact_base import ContactBase
from openapi_server.models.document_category_base import DocumentCategoryBase
from openapi_server.models.document_version_base import DocumentVersionBase
from openapi_server.models.external_property_base import ExternalPropertyBase
from openapi_server.models.group_base import GroupBase
from openapi_server.models.linked_folder_base import LinkedFolderBase
from openapi_server.models.matter_base import MatterBase
from openapi_server import util


class Folder(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, deleted_at: datetime=None, type: str=None, locked: bool=None, name: str=None, root: bool=None, parent: LinkedFolderBase=None, matter: MatterBase=None, contact: ContactBase=None, document_category: DocumentCategoryBase=None, creator: ClioCreatorBase=None, latest_document_version: DocumentVersionBase=None, group: GroupBase=None, external_properties: List[ExternalPropertyBase]=None):
        """Folder - a model defined in OpenAPI

        :param id: The id of this Folder.
        :param etag: The etag of this Folder.
        :param created_at: The created_at of this Folder.
        :param updated_at: The updated_at of this Folder.
        :param deleted_at: The deleted_at of this Folder.
        :param type: The type of this Folder.
        :param locked: The locked of this Folder.
        :param name: The name of this Folder.
        :param root: The root of this Folder.
        :param parent: The parent of this Folder.
        :param matter: The matter of this Folder.
        :param contact: The contact of this Folder.
        :param document_category: The document_category of this Folder.
        :param creator: The creator of this Folder.
        :param latest_document_version: The latest_document_version of this Folder.
        :param group: The group of this Folder.
        :param external_properties: The external_properties of this Folder.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'deleted_at': datetime,
            'type': str,
            'locked': bool,
            'name': str,
            'root': bool,
            'parent': LinkedFolderBase,
            'matter': MatterBase,
            'contact': ContactBase,
            'document_category': DocumentCategoryBase,
            'creator': ClioCreatorBase,
            'latest_document_version': DocumentVersionBase,
            'group': GroupBase,
            'external_properties': List[ExternalPropertyBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'deleted_at': 'deleted_at',
            'type': 'type',
            'locked': 'locked',
            'name': 'name',
            'root': 'root',
            'parent': 'parent',
            'matter': 'matter',
            'contact': 'contact',
            'document_category': 'document_category',
            'creator': 'creator',
            'latest_document_version': 'latest_document_version',
            'group': 'group',
            'external_properties': 'external_properties'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._deleted_at = deleted_at
        self._type = type
        self._locked = locked
        self._name = name
        self._root = root
        self._parent = parent
        self._matter = matter
        self._contact = contact
        self._document_category = document_category
        self._creator = creator
        self._latest_document_version = latest_document_version
        self._group = group
        self._external_properties = external_properties

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Folder':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Folder of this Folder.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Folder.

        Unique identifier for the *Folder*

        :return: The id of this Folder.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Folder.

        Unique identifier for the *Folder*

        :param id: The id of this Folder.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Folder.

        ETag for the *Folder*

        :return: The etag of this Folder.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Folder.

        ETag for the *Folder*

        :param etag: The etag of this Folder.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this Folder.

        The time the *Folder* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Folder.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Folder.

        The time the *Folder* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Folder.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Folder.

        The time the *Folder* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Folder.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Folder.

        The time the *Folder* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Folder.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def deleted_at(self):
        """Gets the deleted_at of this Folder.

        The time the *Folder* was deleted (as a ISO-8601 timestamp)

        :return: The deleted_at of this Folder.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this Folder.

        The time the *Folder* was deleted (as a ISO-8601 timestamp)

        :param deleted_at: The deleted_at of this Folder.
        :type deleted_at: datetime
        """

        self._deleted_at = deleted_at

    @property
    def type(self):
        """Gets the type of this Folder.

        The type of the *Folder*

        :return: The type of this Folder.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Folder.

        The type of the *Folder*

        :param type: The type of this Folder.
        :type type: str
        """
        allowed_values = ["Folder"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def locked(self):
        """Gets the locked of this Folder.

        Whether or not the Folder is locked. Locked Folder cannot be modified

        :return: The locked of this Folder.
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this Folder.

        Whether or not the Folder is locked. Locked Folder cannot be modified

        :param locked: The locked of this Folder.
        :type locked: bool
        """

        self._locked = locked

    @property
    def name(self):
        """Gets the name of this Folder.

        The name of the Folder

        :return: The name of this Folder.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Folder.

        The name of the Folder

        :param name: The name of this Folder.
        :type name: str
        """

        self._name = name

    @property
    def root(self):
        """Gets the root of this Folder.

        Whether or not the Folder is the root folder. There is only one root folder per account

        :return: The root of this Folder.
        :rtype: bool
        """
        return self._root

    @root.setter
    def root(self, root):
        """Sets the root of this Folder.

        Whether or not the Folder is the root folder. There is only one root folder per account

        :param root: The root of this Folder.
        :type root: bool
        """

        self._root = root

    @property
    def parent(self):
        """Gets the parent of this Folder.


        :return: The parent of this Folder.
        :rtype: LinkedFolderBase
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this Folder.


        :param parent: The parent of this Folder.
        :type parent: LinkedFolderBase
        """

        self._parent = parent

    @property
    def matter(self):
        """Gets the matter of this Folder.


        :return: The matter of this Folder.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this Folder.


        :param matter: The matter of this Folder.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def contact(self):
        """Gets the contact of this Folder.


        :return: The contact of this Folder.
        :rtype: ContactBase
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this Folder.


        :param contact: The contact of this Folder.
        :type contact: ContactBase
        """

        self._contact = contact

    @property
    def document_category(self):
        """Gets the document_category of this Folder.


        :return: The document_category of this Folder.
        :rtype: DocumentCategoryBase
        """
        return self._document_category

    @document_category.setter
    def document_category(self, document_category):
        """Sets the document_category of this Folder.


        :param document_category: The document_category of this Folder.
        :type document_category: DocumentCategoryBase
        """

        self._document_category = document_category

    @property
    def creator(self):
        """Gets the creator of this Folder.


        :return: The creator of this Folder.
        :rtype: ClioCreatorBase
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this Folder.


        :param creator: The creator of this Folder.
        :type creator: ClioCreatorBase
        """

        self._creator = creator

    @property
    def latest_document_version(self):
        """Gets the latest_document_version of this Folder.


        :return: The latest_document_version of this Folder.
        :rtype: DocumentVersionBase
        """
        return self._latest_document_version

    @latest_document_version.setter
    def latest_document_version(self, latest_document_version):
        """Sets the latest_document_version of this Folder.


        :param latest_document_version: The latest_document_version of this Folder.
        :type latest_document_version: DocumentVersionBase
        """

        self._latest_document_version = latest_document_version

    @property
    def group(self):
        """Gets the group of this Folder.


        :return: The group of this Folder.
        :rtype: GroupBase
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this Folder.


        :param group: The group of this Folder.
        :type group: GroupBase
        """

        self._group = group

    @property
    def external_properties(self):
        """Gets the external_properties of this Folder.

        ExternalProperty

        :return: The external_properties of this Folder.
        :rtype: List[ExternalPropertyBase]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this Folder.

        ExternalProperty

        :param external_properties: The external_properties of this Folder.
        :type external_properties: List[ExternalPropertyBase]
        """

        self._external_properties = external_properties
