# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class FolderCreateRequestDataParent(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, type: str=None):
        """FolderCreateRequestDataParent - a model defined in OpenAPI

        :param id: The id of this FolderCreateRequestDataParent.
        :param type: The type of this FolderCreateRequestDataParent.
        """
        self.openapi_types = {
            'id': int,
            'type': str
        }

        self.attribute_map = {
            'id': 'id',
            'type': 'type'
        }

        self._id = id
        self._type = type

    @classmethod
    def from_dict(cls, dikt: dict) -> 'FolderCreateRequestDataParent':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Folder_create_request_data_parent of this FolderCreateRequestDataParent.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this FolderCreateRequestDataParent.

        The unique identifier of the parent object.

        :return: The id of this FolderCreateRequestDataParent.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FolderCreateRequestDataParent.

        The unique identifier of the parent object.

        :param id: The id of this FolderCreateRequestDataParent.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def type(self):
        """Gets the type of this FolderCreateRequestDataParent.

        Type of parent object: * \"Folder\" represents a specified folder on Clio by folder id. It if specified when you add / move an item to a folder. * \"Contact\" represents a contact folder on Clio identified by contact id. It is specified when you add / move an item to a contact folder. A contact folder will be created for the specified contact if none exists already. * \"Matter\" represents a matter folder on Clio identified by matter id. It is specified when you add / move an item to a matter folder. 

        :return: The type of this FolderCreateRequestDataParent.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this FolderCreateRequestDataParent.

        Type of parent object: * \"Folder\" represents a specified folder on Clio by folder id. It if specified when you add / move an item to a folder. * \"Contact\" represents a contact folder on Clio identified by contact id. It is specified when you add / move an item to a contact folder. A contact folder will be created for the specified contact if none exists already. * \"Matter\" represents a matter folder on Clio identified by matter id. It is specified when you add / move an item to a matter folder. 

        :param type: The type of this FolderCreateRequestDataParent.
        :type type: str
        """
        allowed_values = ["Folder", "Contact", "Matter"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type
