# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.folder_create_request_data_document_category import FolderCreateRequestDataDocumentCategory
from openapi_server.models.folder_update_request_data_external_properties_inner import FolderUpdateRequestDataExternalPropertiesInner
from openapi_server.models.folder_update_request_data_parent import FolderUpdateRequestDataParent
from openapi_server import util


class FolderUpdateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, document_category: FolderCreateRequestDataDocumentCategory=None, external_properties: List[FolderUpdateRequestDataExternalPropertiesInner]=None, name: str=None, parent: FolderUpdateRequestDataParent=None, restore: bool=None):
        """FolderUpdateRequestData - a model defined in OpenAPI

        :param document_category: The document_category of this FolderUpdateRequestData.
        :param external_properties: The external_properties of this FolderUpdateRequestData.
        :param name: The name of this FolderUpdateRequestData.
        :param parent: The parent of this FolderUpdateRequestData.
        :param restore: The restore of this FolderUpdateRequestData.
        """
        self.openapi_types = {
            'document_category': FolderCreateRequestDataDocumentCategory,
            'external_properties': List[FolderUpdateRequestDataExternalPropertiesInner],
            'name': str,
            'parent': FolderUpdateRequestDataParent,
            'restore': bool
        }

        self.attribute_map = {
            'document_category': 'document_category',
            'external_properties': 'external_properties',
            'name': 'name',
            'parent': 'parent',
            'restore': 'restore'
        }

        self._document_category = document_category
        self._external_properties = external_properties
        self._name = name
        self._parent = parent
        self._restore = restore

    @classmethod
    def from_dict(cls, dikt: dict) -> 'FolderUpdateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Folder_update_request_data of this FolderUpdateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def document_category(self):
        """Gets the document_category of this FolderUpdateRequestData.


        :return: The document_category of this FolderUpdateRequestData.
        :rtype: FolderCreateRequestDataDocumentCategory
        """
        return self._document_category

    @document_category.setter
    def document_category(self, document_category):
        """Sets the document_category of this FolderUpdateRequestData.


        :param document_category: The document_category of this FolderUpdateRequestData.
        :type document_category: FolderCreateRequestDataDocumentCategory
        """

        self._document_category = document_category

    @property
    def external_properties(self):
        """Gets the external_properties of this FolderUpdateRequestData.


        :return: The external_properties of this FolderUpdateRequestData.
        :rtype: List[FolderUpdateRequestDataExternalPropertiesInner]
        """
        return self._external_properties

    @external_properties.setter
    def external_properties(self, external_properties):
        """Sets the external_properties of this FolderUpdateRequestData.


        :param external_properties: The external_properties of this FolderUpdateRequestData.
        :type external_properties: List[FolderUpdateRequestDataExternalPropertiesInner]
        """

        self._external_properties = external_properties

    @property
    def name(self):
        """Gets the name of this FolderUpdateRequestData.

        Name of the Folder

        :return: The name of this FolderUpdateRequestData.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FolderUpdateRequestData.

        Name of the Folder

        :param name: The name of this FolderUpdateRequestData.
        :type name: str
        """

        self._name = name

    @property
    def parent(self):
        """Gets the parent of this FolderUpdateRequestData.


        :return: The parent of this FolderUpdateRequestData.
        :rtype: FolderUpdateRequestDataParent
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this FolderUpdateRequestData.


        :param parent: The parent of this FolderUpdateRequestData.
        :type parent: FolderUpdateRequestDataParent
        """

        self._parent = parent

    @property
    def restore(self):
        """Gets the restore of this FolderUpdateRequestData.

        Whether or not a trashed Folder should be restored.

        :return: The restore of this FolderUpdateRequestData.
        :rtype: bool
        """
        return self._restore

    @restore.setter
    def restore(self, restore):
        """Sets the restore of this FolderUpdateRequestData.

        Whether or not a trashed Folder should be restored.

        :param restore: The restore of this FolderUpdateRequestData.
        :type restore: bool
        """

        self._restore = restore
