# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.grant_funding_source_base import GrantFundingSourceBase
from openapi_server import util


class Grant(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, funding_code: str=None, funding_code_and_name: str=None, funding_source_name: str=None, created_at: datetime=None, updated_at: datetime=None, balance: str=None, grant_funding_source: GrantFundingSourceBase=None):
        """Grant - a model defined in OpenAPI

        :param id: The id of this Grant.
        :param etag: The etag of this Grant.
        :param name: The name of this Grant.
        :param funding_code: The funding_code of this Grant.
        :param funding_code_and_name: The funding_code_and_name of this Grant.
        :param funding_source_name: The funding_source_name of this Grant.
        :param created_at: The created_at of this Grant.
        :param updated_at: The updated_at of this Grant.
        :param balance: The balance of this Grant.
        :param grant_funding_source: The grant_funding_source of this Grant.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'funding_code': str,
            'funding_code_and_name': str,
            'funding_source_name': str,
            'created_at': datetime,
            'updated_at': datetime,
            'balance': str,
            'grant_funding_source': GrantFundingSourceBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'funding_code': 'funding_code',
            'funding_code_and_name': 'funding_code_and_name',
            'funding_source_name': 'funding_source_name',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'balance': 'balance',
            'grant_funding_source': 'grant_funding_source'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._funding_code = funding_code
        self._funding_code_and_name = funding_code_and_name
        self._funding_source_name = funding_source_name
        self._created_at = created_at
        self._updated_at = updated_at
        self._balance = balance
        self._grant_funding_source = grant_funding_source

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Grant':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Grant of this Grant.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Grant.

        Unique identifier for the *Grant*

        :return: The id of this Grant.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Grant.

        Unique identifier for the *Grant*

        :param id: The id of this Grant.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Grant.

        ETag for the *Grant*

        :return: The etag of this Grant.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Grant.

        ETag for the *Grant*

        :param etag: The etag of this Grant.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this Grant.

        The name of the *Grant*

        :return: The name of this Grant.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Grant.

        The name of the *Grant*

        :param name: The name of this Grant.
        :type name: str
        """

        self._name = name

    @property
    def funding_code(self):
        """Gets the funding_code of this Grant.

        Funding code of the grant

        :return: The funding_code of this Grant.
        :rtype: str
        """
        return self._funding_code

    @funding_code.setter
    def funding_code(self, funding_code):
        """Sets the funding_code of this Grant.

        Funding code of the grant

        :param funding_code: The funding_code of this Grant.
        :type funding_code: str
        """

        self._funding_code = funding_code

    @property
    def funding_code_and_name(self):
        """Gets the funding_code_and_name of this Grant.

        Funding code and name of the grant

        :return: The funding_code_and_name of this Grant.
        :rtype: str
        """
        return self._funding_code_and_name

    @funding_code_and_name.setter
    def funding_code_and_name(self, funding_code_and_name):
        """Sets the funding_code_and_name of this Grant.

        Funding code and name of the grant

        :param funding_code_and_name: The funding_code_and_name of this Grant.
        :type funding_code_and_name: str
        """

        self._funding_code_and_name = funding_code_and_name

    @property
    def funding_source_name(self):
        """Gets the funding_source_name of this Grant.

        Name of the funding source of the grant

        :return: The funding_source_name of this Grant.
        :rtype: str
        """
        return self._funding_source_name

    @funding_source_name.setter
    def funding_source_name(self, funding_source_name):
        """Sets the funding_source_name of this Grant.

        Name of the funding source of the grant

        :param funding_source_name: The funding_source_name of this Grant.
        :type funding_source_name: str
        """

        self._funding_source_name = funding_source_name

    @property
    def created_at(self):
        """Gets the created_at of this Grant.

        The time the *Grant* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Grant.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Grant.

        The time the *Grant* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Grant.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Grant.

        The time the *Grant* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Grant.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Grant.

        The time the *Grant* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Grant.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def balance(self):
        """Gets the balance of this Grant.

        Balance of the grant

        :return: The balance of this Grant.
        :rtype: str
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this Grant.

        Balance of the grant

        :param balance: The balance of this Grant.
        :type balance: str
        """

        self._balance = balance

    @property
    def grant_funding_source(self):
        """Gets the grant_funding_source of this Grant.


        :return: The grant_funding_source of this Grant.
        :rtype: GrantFundingSourceBase
        """
        return self._grant_funding_source

    @grant_funding_source.setter
    def grant_funding_source(self, grant_funding_source):
        """Sets the grant_funding_source of this Grant.


        :param grant_funding_source: The grant_funding_source of this Grant.
        :type grant_funding_source: GrantFundingSourceBase
        """

        self._grant_funding_source = grant_funding_source
