# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.grant_base import GrantBase
from openapi_server import util


class GrantFundingSource(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, created_at: datetime=None, updated_at: datetime=None, grants: List[GrantBase]=None):
        """GrantFundingSource - a model defined in OpenAPI

        :param id: The id of this GrantFundingSource.
        :param etag: The etag of this GrantFundingSource.
        :param name: The name of this GrantFundingSource.
        :param created_at: The created_at of this GrantFundingSource.
        :param updated_at: The updated_at of this GrantFundingSource.
        :param grants: The grants of this GrantFundingSource.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'created_at': datetime,
            'updated_at': datetime,
            'grants': List[GrantBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'grants': 'grants'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._created_at = created_at
        self._updated_at = updated_at
        self._grants = grants

    @classmethod
    def from_dict(cls, dikt: dict) -> 'GrantFundingSource':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The GrantFundingSource of this GrantFundingSource.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this GrantFundingSource.

        Unique identifier for the *GrantFundingSource*

        :return: The id of this GrantFundingSource.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GrantFundingSource.

        Unique identifier for the *GrantFundingSource*

        :param id: The id of this GrantFundingSource.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this GrantFundingSource.

        ETag for the *GrantFundingSource*

        :return: The etag of this GrantFundingSource.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this GrantFundingSource.

        ETag for the *GrantFundingSource*

        :param etag: The etag of this GrantFundingSource.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this GrantFundingSource.

        The name of the *GrantFundingSource*

        :return: The name of this GrantFundingSource.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GrantFundingSource.

        The name of the *GrantFundingSource*

        :param name: The name of this GrantFundingSource.
        :type name: str
        """

        self._name = name

    @property
    def created_at(self):
        """Gets the created_at of this GrantFundingSource.

        The time the *GrantFundingSource* was created (as a ISO-8601 timestamp)

        :return: The created_at of this GrantFundingSource.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this GrantFundingSource.

        The time the *GrantFundingSource* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this GrantFundingSource.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this GrantFundingSource.

        The time the *GrantFundingSource* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this GrantFundingSource.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this GrantFundingSource.

        The time the *GrantFundingSource* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this GrantFundingSource.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def grants(self):
        """Gets the grants of this GrantFundingSource.

        Grant

        :return: The grants of this GrantFundingSource.
        :rtype: List[GrantBase]
        """
        return self._grants

    @grants.setter
    def grants(self, grants):
        """Sets the grants of this GrantFundingSource.

        Grant

        :param grants: The grants of this GrantFundingSource.
        :type grants: List[GrantBase]
        """

        self._grants = grants
