# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class InstantMessengerBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, address: str=None, name: str=None, created_at: datetime=None, updated_at: datetime=None):
        """InstantMessengerBase - a model defined in OpenAPI

        :param id: The id of this InstantMessengerBase.
        :param etag: The etag of this InstantMessengerBase.
        :param address: The address of this InstantMessengerBase.
        :param name: The name of this InstantMessengerBase.
        :param created_at: The created_at of this InstantMessengerBase.
        :param updated_at: The updated_at of this InstantMessengerBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'address': str,
            'name': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'address': 'address',
            'name': 'name',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._address = address
        self._name = name
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'InstantMessengerBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The InstantMessenger_base of this InstantMessengerBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this InstantMessengerBase.

        Unique identifier for the *InstantMessenger*

        :return: The id of this InstantMessengerBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InstantMessengerBase.

        Unique identifier for the *InstantMessenger*

        :param id: The id of this InstantMessengerBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this InstantMessengerBase.

        ETag for the *InstantMessenger*

        :return: The etag of this InstantMessengerBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this InstantMessengerBase.

        ETag for the *InstantMessenger*

        :param etag: The etag of this InstantMessengerBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def address(self):
        """Gets the address of this InstantMessengerBase.

        The address of the *InstantMessenger*

        :return: The address of this InstantMessengerBase.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this InstantMessengerBase.

        The address of the *InstantMessenger*

        :param address: The address of this InstantMessengerBase.
        :type address: str
        """

        self._address = address

    @property
    def name(self):
        """Gets the name of this InstantMessengerBase.

        The type of *InstantMessenger* it is

        :return: The name of this InstantMessengerBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InstantMessengerBase.

        The type of *InstantMessenger* it is

        :param name: The name of this InstantMessengerBase.
        :type name: str
        """
        allowed_values = ["Work", "Personal", "Other"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def created_at(self):
        """Gets the created_at of this InstantMessengerBase.

        The time the *InstantMessenger* was created (as a ISO-8601 timestamp)

        :return: The created_at of this InstantMessengerBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InstantMessengerBase.

        The time the *InstantMessenger* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this InstantMessengerBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this InstantMessengerBase.

        The time the *InstantMessenger* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this InstantMessengerBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InstantMessengerBase.

        The time the *InstantMessenger* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this InstantMessengerBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
