# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.balance_base import BalanceBase
from openapi_server.models.bill_base import BillBase
from openapi_server.models.matter_base import MatterBase
from openapi_server import util


class InterestCharge(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, _date: date=None, description: str=None, total: float=None, created_at: datetime=None, updated_at: datetime=None, bill: BillBase=None, balances: List[BalanceBase]=None, matters: List[MatterBase]=None):
        """InterestCharge - a model defined in OpenAPI

        :param id: The id of this InterestCharge.
        :param etag: The etag of this InterestCharge.
        :param _date: The _date of this InterestCharge.
        :param description: The description of this InterestCharge.
        :param total: The total of this InterestCharge.
        :param created_at: The created_at of this InterestCharge.
        :param updated_at: The updated_at of this InterestCharge.
        :param bill: The bill of this InterestCharge.
        :param balances: The balances of this InterestCharge.
        :param matters: The matters of this InterestCharge.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            '_date': date,
            'description': str,
            'total': float,
            'created_at': datetime,
            'updated_at': datetime,
            'bill': BillBase,
            'balances': List[BalanceBase],
            'matters': List[MatterBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            '_date': 'date',
            'description': 'description',
            'total': 'total',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'bill': 'bill',
            'balances': 'balances',
            'matters': 'matters'
        }

        self._id = id
        self._etag = etag
        self.__date = _date
        self._description = description
        self._total = total
        self._created_at = created_at
        self._updated_at = updated_at
        self._bill = bill
        self._balances = balances
        self._matters = matters

    @classmethod
    def from_dict(cls, dikt: dict) -> 'InterestCharge':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The InterestCharge of this InterestCharge.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this InterestCharge.

        Unique identifier for the *InterestCharge*

        :return: The id of this InterestCharge.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InterestCharge.

        Unique identifier for the *InterestCharge*

        :param id: The id of this InterestCharge.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this InterestCharge.

        ETag for the *InterestCharge*

        :return: The etag of this InterestCharge.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this InterestCharge.

        ETag for the *InterestCharge*

        :param etag: The etag of this InterestCharge.
        :type etag: str
        """

        self._etag = etag

    @property
    def _date(self):
        """Gets the _date of this InterestCharge.

        The *InterestCharge* date (as a ISO-8601 date)

        :return: The _date of this InterestCharge.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this InterestCharge.

        The *InterestCharge* date (as a ISO-8601 date)

        :param _date: The _date of this InterestCharge.
        :type _date: date
        """

        self.__date = _date

    @property
    def description(self):
        """Gets the description of this InterestCharge.

        The description for the *InterestCharge*

        :return: The description of this InterestCharge.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InterestCharge.

        The description for the *InterestCharge*

        :param description: The description of this InterestCharge.
        :type description: str
        """

        self._description = description

    @property
    def total(self):
        """Gets the total of this InterestCharge.

        The total amount for the *InterestCharge*

        :return: The total of this InterestCharge.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this InterestCharge.

        The total amount for the *InterestCharge*

        :param total: The total of this InterestCharge.
        :type total: float
        """

        self._total = total

    @property
    def created_at(self):
        """Gets the created_at of this InterestCharge.

        The time the *InterestCharge* was created (as a ISO-8601 timestamp)

        :return: The created_at of this InterestCharge.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InterestCharge.

        The time the *InterestCharge* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this InterestCharge.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this InterestCharge.

        The time the *InterestCharge* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this InterestCharge.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InterestCharge.

        The time the *InterestCharge* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this InterestCharge.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def bill(self):
        """Gets the bill of this InterestCharge.


        :return: The bill of this InterestCharge.
        :rtype: BillBase
        """
        return self._bill

    @bill.setter
    def bill(self, bill):
        """Sets the bill of this InterestCharge.


        :param bill: The bill of this InterestCharge.
        :type bill: BillBase
        """

        self._bill = bill

    @property
    def balances(self):
        """Gets the balances of this InterestCharge.

        Balance

        :return: The balances of this InterestCharge.
        :rtype: List[BalanceBase]
        """
        return self._balances

    @balances.setter
    def balances(self, balances):
        """Sets the balances of this InterestCharge.

        Balance

        :param balances: The balances of this InterestCharge.
        :type balances: List[BalanceBase]
        """

        self._balances = balances

    @property
    def matters(self):
        """Gets the matters of this InterestCharge.

        Matter

        :return: The matters of this InterestCharge.
        :rtype: List[MatterBase]
        """
        return self._matters

    @matters.setter
    def matters(self, matters):
        """Sets the matters of this InterestCharge.

        Matter

        :param matters: The matters of this InterestCharge.
        :type matters: List[MatterBase]
        """

        self._matters = matters
