# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class InterestChargeBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, _date: date=None, description: str=None, total: float=None, created_at: datetime=None, updated_at: datetime=None):
        """InterestChargeBase - a model defined in OpenAPI

        :param id: The id of this InterestChargeBase.
        :param etag: The etag of this InterestChargeBase.
        :param _date: The _date of this InterestChargeBase.
        :param description: The description of this InterestChargeBase.
        :param total: The total of this InterestChargeBase.
        :param created_at: The created_at of this InterestChargeBase.
        :param updated_at: The updated_at of this InterestChargeBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            '_date': date,
            'description': str,
            'total': float,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            '_date': 'date',
            'description': 'description',
            'total': 'total',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self.__date = _date
        self._description = description
        self._total = total
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'InterestChargeBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The InterestCharge_base of this InterestChargeBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this InterestChargeBase.

        Unique identifier for the *InterestCharge*

        :return: The id of this InterestChargeBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InterestChargeBase.

        Unique identifier for the *InterestCharge*

        :param id: The id of this InterestChargeBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this InterestChargeBase.

        ETag for the *InterestCharge*

        :return: The etag of this InterestChargeBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this InterestChargeBase.

        ETag for the *InterestCharge*

        :param etag: The etag of this InterestChargeBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def _date(self):
        """Gets the _date of this InterestChargeBase.

        The *InterestCharge* date (as a ISO-8601 date)

        :return: The _date of this InterestChargeBase.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this InterestChargeBase.

        The *InterestCharge* date (as a ISO-8601 date)

        :param _date: The _date of this InterestChargeBase.
        :type _date: date
        """

        self.__date = _date

    @property
    def description(self):
        """Gets the description of this InterestChargeBase.

        The description for the *InterestCharge*

        :return: The description of this InterestChargeBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InterestChargeBase.

        The description for the *InterestCharge*

        :param description: The description of this InterestChargeBase.
        :type description: str
        """

        self._description = description

    @property
    def total(self):
        """Gets the total of this InterestChargeBase.

        The total amount for the *InterestCharge*

        :return: The total of this InterestChargeBase.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this InterestChargeBase.

        The total amount for the *InterestCharge*

        :param total: The total of this InterestChargeBase.
        :type total: float
        """

        self._total = total

    @property
    def created_at(self):
        """Gets the created_at of this InterestChargeBase.

        The time the *InterestCharge* was created (as a ISO-8601 timestamp)

        :return: The created_at of this InterestChargeBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InterestChargeBase.

        The time the *InterestCharge* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this InterestChargeBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this InterestChargeBase.

        The time the *InterestCharge* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this InterestChargeBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InterestChargeBase.

        The time the *InterestCharge* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this InterestChargeBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
