# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ItemBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, deleted_at: datetime=None, type: str=None, locked: bool=None, name: str=None):
        """ItemBase - a model defined in OpenAPI

        :param id: The id of this ItemBase.
        :param etag: The etag of this ItemBase.
        :param created_at: The created_at of this ItemBase.
        :param updated_at: The updated_at of this ItemBase.
        :param deleted_at: The deleted_at of this ItemBase.
        :param type: The type of this ItemBase.
        :param locked: The locked of this ItemBase.
        :param name: The name of this ItemBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'deleted_at': datetime,
            'type': str,
            'locked': bool,
            'name': str
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'deleted_at': 'deleted_at',
            'type': 'type',
            'locked': 'locked',
            'name': 'name'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._deleted_at = deleted_at
        self._type = type
        self._locked = locked
        self._name = name

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ItemBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Item_base of this ItemBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ItemBase.

        Unique identifier for the *Item*

        :return: The id of this ItemBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ItemBase.

        Unique identifier for the *Item*

        :param id: The id of this ItemBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ItemBase.

        ETag for the *Item*

        :return: The etag of this ItemBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ItemBase.

        ETag for the *Item*

        :param etag: The etag of this ItemBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this ItemBase.

        The time the *Item* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ItemBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ItemBase.

        The time the *Item* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ItemBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ItemBase.

        The time the *Item* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ItemBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ItemBase.

        The time the *Item* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ItemBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def deleted_at(self):
        """Gets the deleted_at of this ItemBase.

        The time the *Item* was deleted (as a ISO-8601 timestamp)

        :return: The deleted_at of this ItemBase.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this ItemBase.

        The time the *Item* was deleted (as a ISO-8601 timestamp)

        :param deleted_at: The deleted_at of this ItemBase.
        :type deleted_at: datetime
        """

        self._deleted_at = deleted_at

    @property
    def type(self):
        """Gets the type of this ItemBase.

        The type of the *Item*

        :return: The type of this ItemBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ItemBase.

        The type of the *Item*

        :param type: The type of this ItemBase.
        :type type: str
        """
        allowed_values = ["Document", "Folder"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def locked(self):
        """Gets the locked of this ItemBase.

        Whether or not the Item is locked. Locked Item cannot be modified

        :return: The locked of this ItemBase.
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this ItemBase.

        Whether or not the Item is locked. Locked Item cannot be modified

        :param locked: The locked of this ItemBase.
        :type locked: bool
        """

        self._locked = locked

    @property
    def name(self):
        """Gets the name of this ItemBase.

        The name of the Item

        :return: The name of this ItemBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ItemBase.

        The name of the Item

        :param name: The name of this ItemBase.
        :type name: str
        """

        self._name = name
