# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class LaukCriminalControlledRateBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, activity: str=None, activity_type: str=None, category_of_law: str=None, counsel: str=None, court: str=None, created_at: datetime=None, etag: str=None, exceptional: float=None, fee: float=None, fee_scheme: str=None, post_sept_22_exceptional: float=None, post_sept_22_fee: float=None, key: str=None, rate_type: str=None, region: str=None, solicitor_type: str=None, updated_at: datetime=None):
        """LaukCriminalControlledRateBase - a model defined in OpenAPI

        :param id: The id of this LaukCriminalControlledRateBase.
        :param activity: The activity of this LaukCriminalControlledRateBase.
        :param activity_type: The activity_type of this LaukCriminalControlledRateBase.
        :param category_of_law: The category_of_law of this LaukCriminalControlledRateBase.
        :param counsel: The counsel of this LaukCriminalControlledRateBase.
        :param court: The court of this LaukCriminalControlledRateBase.
        :param created_at: The created_at of this LaukCriminalControlledRateBase.
        :param etag: The etag of this LaukCriminalControlledRateBase.
        :param exceptional: The exceptional of this LaukCriminalControlledRateBase.
        :param fee: The fee of this LaukCriminalControlledRateBase.
        :param fee_scheme: The fee_scheme of this LaukCriminalControlledRateBase.
        :param post_sept_22_exceptional: The post_sept_22_exceptional of this LaukCriminalControlledRateBase.
        :param post_sept_22_fee: The post_sept_22_fee of this LaukCriminalControlledRateBase.
        :param key: The key of this LaukCriminalControlledRateBase.
        :param rate_type: The rate_type of this LaukCriminalControlledRateBase.
        :param region: The region of this LaukCriminalControlledRateBase.
        :param solicitor_type: The solicitor_type of this LaukCriminalControlledRateBase.
        :param updated_at: The updated_at of this LaukCriminalControlledRateBase.
        """
        self.openapi_types = {
            'id': int,
            'activity': str,
            'activity_type': str,
            'category_of_law': str,
            'counsel': str,
            'court': str,
            'created_at': datetime,
            'etag': str,
            'exceptional': float,
            'fee': float,
            'fee_scheme': str,
            'post_sept_22_exceptional': float,
            'post_sept_22_fee': float,
            'key': str,
            'rate_type': str,
            'region': str,
            'solicitor_type': str,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'activity': 'activity',
            'activity_type': 'activity_type',
            'category_of_law': 'category_of_law',
            'counsel': 'counsel',
            'court': 'court',
            'created_at': 'created_at',
            'etag': 'etag',
            'exceptional': 'exceptional',
            'fee': 'fee',
            'fee_scheme': 'fee_scheme',
            'post_sept_22_exceptional': 'post_sept_22_exceptional',
            'post_sept_22_fee': 'post_sept_22_fee',
            'key': 'key',
            'rate_type': 'rate_type',
            'region': 'region',
            'solicitor_type': 'solicitor_type',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._activity = activity
        self._activity_type = activity_type
        self._category_of_law = category_of_law
        self._counsel = counsel
        self._court = court
        self._created_at = created_at
        self._etag = etag
        self._exceptional = exceptional
        self._fee = fee
        self._fee_scheme = fee_scheme
        self._post_sept_22_exceptional = post_sept_22_exceptional
        self._post_sept_22_fee = post_sept_22_fee
        self._key = key
        self._rate_type = rate_type
        self._region = region
        self._solicitor_type = solicitor_type
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'LaukCriminalControlledRateBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The LaukCriminalControlledRate_base of this LaukCriminalControlledRateBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this LaukCriminalControlledRateBase.

        Unique identifier for the *LaukCriminalControlledRate*

        :return: The id of this LaukCriminalControlledRateBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LaukCriminalControlledRateBase.

        Unique identifier for the *LaukCriminalControlledRate*

        :param id: The id of this LaukCriminalControlledRateBase.
        :type id: int
        """

        self._id = id

    @property
    def activity(self):
        """Gets the activity of this LaukCriminalControlledRateBase.

        Activity of the *LaukCriminalControlledRate*

        :return: The activity of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._activity

    @activity.setter
    def activity(self, activity):
        """Sets the activity of this LaukCriminalControlledRateBase.

        Activity of the *LaukCriminalControlledRate*

        :param activity: The activity of this LaukCriminalControlledRateBase.
        :type activity: str
        """

        self._activity = activity

    @property
    def activity_type(self):
        """Gets the activity_type of this LaukCriminalControlledRateBase.

        Activity type

        :return: The activity_type of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._activity_type

    @activity_type.setter
    def activity_type(self, activity_type):
        """Sets the activity_type of this LaukCriminalControlledRateBase.

        Activity type

        :param activity_type: The activity_type of this LaukCriminalControlledRateBase.
        :type activity_type: str
        """

        self._activity_type = activity_type

    @property
    def category_of_law(self):
        """Gets the category_of_law of this LaukCriminalControlledRateBase.

        Category of law

        :return: The category_of_law of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._category_of_law

    @category_of_law.setter
    def category_of_law(self, category_of_law):
        """Sets the category_of_law of this LaukCriminalControlledRateBase.

        Category of law

        :param category_of_law: The category_of_law of this LaukCriminalControlledRateBase.
        :type category_of_law: str
        """

        self._category_of_law = category_of_law

    @property
    def counsel(self):
        """Gets the counsel of this LaukCriminalControlledRateBase.

        Associated counsel

        :return: The counsel of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._counsel

    @counsel.setter
    def counsel(self, counsel):
        """Sets the counsel of this LaukCriminalControlledRateBase.

        Associated counsel

        :param counsel: The counsel of this LaukCriminalControlledRateBase.
        :type counsel: str
        """

        self._counsel = counsel

    @property
    def court(self):
        """Gets the court of this LaukCriminalControlledRateBase.

        Court associated

        :return: The court of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._court

    @court.setter
    def court(self, court):
        """Sets the court of this LaukCriminalControlledRateBase.

        Court associated

        :param court: The court of this LaukCriminalControlledRateBase.
        :type court: str
        """

        self._court = court

    @property
    def created_at(self):
        """Gets the created_at of this LaukCriminalControlledRateBase.

        The time the *LaukCriminalControlledRate* was created (as a ISO-8601 timestamp)

        :return: The created_at of this LaukCriminalControlledRateBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this LaukCriminalControlledRateBase.

        The time the *LaukCriminalControlledRate* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this LaukCriminalControlledRateBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def etag(self):
        """Gets the etag of this LaukCriminalControlledRateBase.

        ETag for the *LaukCriminalControlledRate*

        :return: The etag of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this LaukCriminalControlledRateBase.

        ETag for the *LaukCriminalControlledRate*

        :param etag: The etag of this LaukCriminalControlledRateBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def exceptional(self):
        """Gets the exceptional of this LaukCriminalControlledRateBase.

        Fee applied for high activity count

        :return: The exceptional of this LaukCriminalControlledRateBase.
        :rtype: float
        """
        return self._exceptional

    @exceptional.setter
    def exceptional(self, exceptional):
        """Sets the exceptional of this LaukCriminalControlledRateBase.

        Fee applied for high activity count

        :param exceptional: The exceptional of this LaukCriminalControlledRateBase.
        :type exceptional: float
        """

        self._exceptional = exceptional

    @property
    def fee(self):
        """Gets the fee of this LaukCriminalControlledRateBase.

        Fee amount

        :return: The fee of this LaukCriminalControlledRateBase.
        :rtype: float
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this LaukCriminalControlledRateBase.

        Fee amount

        :param fee: The fee of this LaukCriminalControlledRateBase.
        :type fee: float
        """

        self._fee = fee

    @property
    def fee_scheme(self):
        """Gets the fee_scheme of this LaukCriminalControlledRateBase.

        Fee scheme

        :return: The fee_scheme of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._fee_scheme

    @fee_scheme.setter
    def fee_scheme(self, fee_scheme):
        """Sets the fee_scheme of this LaukCriminalControlledRateBase.

        Fee scheme

        :param fee_scheme: The fee_scheme of this LaukCriminalControlledRateBase.
        :type fee_scheme: str
        """

        self._fee_scheme = fee_scheme

    @property
    def post_sept_22_exceptional(self):
        """Gets the post_sept_22_exceptional of this LaukCriminalControlledRateBase.

        Post-Sept 22 exceptional fee

        :return: The post_sept_22_exceptional of this LaukCriminalControlledRateBase.
        :rtype: float
        """
        return self._post_sept_22_exceptional

    @post_sept_22_exceptional.setter
    def post_sept_22_exceptional(self, post_sept_22_exceptional):
        """Sets the post_sept_22_exceptional of this LaukCriminalControlledRateBase.

        Post-Sept 22 exceptional fee

        :param post_sept_22_exceptional: The post_sept_22_exceptional of this LaukCriminalControlledRateBase.
        :type post_sept_22_exceptional: float
        """

        self._post_sept_22_exceptional = post_sept_22_exceptional

    @property
    def post_sept_22_fee(self):
        """Gets the post_sept_22_fee of this LaukCriminalControlledRateBase.

        Post-Sept 22 fee amount

        :return: The post_sept_22_fee of this LaukCriminalControlledRateBase.
        :rtype: float
        """
        return self._post_sept_22_fee

    @post_sept_22_fee.setter
    def post_sept_22_fee(self, post_sept_22_fee):
        """Sets the post_sept_22_fee of this LaukCriminalControlledRateBase.

        Post-Sept 22 fee amount

        :param post_sept_22_fee: The post_sept_22_fee of this LaukCriminalControlledRateBase.
        :type post_sept_22_fee: float
        """

        self._post_sept_22_fee = post_sept_22_fee

    @property
    def key(self):
        """Gets the key of this LaukCriminalControlledRateBase.

        Unique key

        :return: The key of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this LaukCriminalControlledRateBase.

        Unique key

        :param key: The key of this LaukCriminalControlledRateBase.
        :type key: str
        """

        self._key = key

    @property
    def rate_type(self):
        """Gets the rate_type of this LaukCriminalControlledRateBase.

        Rate type

        :return: The rate_type of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._rate_type

    @rate_type.setter
    def rate_type(self, rate_type):
        """Sets the rate_type of this LaukCriminalControlledRateBase.

        Rate type

        :param rate_type: The rate_type of this LaukCriminalControlledRateBase.
        :type rate_type: str
        """

        self._rate_type = rate_type

    @property
    def region(self):
        """Gets the region of this LaukCriminalControlledRateBase.

        Region

        :return: The region of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this LaukCriminalControlledRateBase.

        Region

        :param region: The region of this LaukCriminalControlledRateBase.
        :type region: str
        """

        self._region = region

    @property
    def solicitor_type(self):
        """Gets the solicitor_type of this LaukCriminalControlledRateBase.

        Solicitor type

        :return: The solicitor_type of this LaukCriminalControlledRateBase.
        :rtype: str
        """
        return self._solicitor_type

    @solicitor_type.setter
    def solicitor_type(self, solicitor_type):
        """Sets the solicitor_type of this LaukCriminalControlledRateBase.

        Solicitor type

        :param solicitor_type: The solicitor_type of this LaukCriminalControlledRateBase.
        :type solicitor_type: str
        """

        self._solicitor_type = solicitor_type

    @property
    def updated_at(self):
        """Gets the updated_at of this LaukCriminalControlledRateBase.

        The time the *LaukCriminalControlledRate* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this LaukCriminalControlledRateBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this LaukCriminalControlledRateBase.

        The time the *LaukCriminalControlledRate* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this LaukCriminalControlledRateBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
