# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class LineItemBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, type: str=None, description: str=None, _date: date=None, price: float=None, taxable: bool=None, kind: str=None, note: str=None, secondary_taxable: bool=None, total: float=None, tax: float=None, secondary_tax: float=None, sub_total: float=None, quantity: float=None, group_ordering: int=None, created_at: datetime=None, updated_at: datetime=None):
        """LineItemBase - a model defined in OpenAPI

        :param id: The id of this LineItemBase.
        :param etag: The etag of this LineItemBase.
        :param type: The type of this LineItemBase.
        :param description: The description of this LineItemBase.
        :param _date: The _date of this LineItemBase.
        :param price: The price of this LineItemBase.
        :param taxable: The taxable of this LineItemBase.
        :param kind: The kind of this LineItemBase.
        :param note: The note of this LineItemBase.
        :param secondary_taxable: The secondary_taxable of this LineItemBase.
        :param total: The total of this LineItemBase.
        :param tax: The tax of this LineItemBase.
        :param secondary_tax: The secondary_tax of this LineItemBase.
        :param sub_total: The sub_total of this LineItemBase.
        :param quantity: The quantity of this LineItemBase.
        :param group_ordering: The group_ordering of this LineItemBase.
        :param created_at: The created_at of this LineItemBase.
        :param updated_at: The updated_at of this LineItemBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'type': str,
            'description': str,
            '_date': date,
            'price': float,
            'taxable': bool,
            'kind': str,
            'note': str,
            'secondary_taxable': bool,
            'total': float,
            'tax': float,
            'secondary_tax': float,
            'sub_total': float,
            'quantity': float,
            'group_ordering': int,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'type': 'type',
            'description': 'description',
            '_date': 'date',
            'price': 'price',
            'taxable': 'taxable',
            'kind': 'kind',
            'note': 'note',
            'secondary_taxable': 'secondary_taxable',
            'total': 'total',
            'tax': 'tax',
            'secondary_tax': 'secondary_tax',
            'sub_total': 'sub_total',
            'quantity': 'quantity',
            'group_ordering': 'group_ordering',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._type = type
        self._description = description
        self.__date = _date
        self._price = price
        self._taxable = taxable
        self._kind = kind
        self._note = note
        self._secondary_taxable = secondary_taxable
        self._total = total
        self._tax = tax
        self._secondary_tax = secondary_tax
        self._sub_total = sub_total
        self._quantity = quantity
        self._group_ordering = group_ordering
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'LineItemBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The LineItem_base of this LineItemBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this LineItemBase.

        Unique identifier for the *LineItem*

        :return: The id of this LineItemBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LineItemBase.

        Unique identifier for the *LineItem*

        :param id: The id of this LineItemBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this LineItemBase.

        ETag for the *LineItem*

        :return: The etag of this LineItemBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this LineItemBase.

        ETag for the *LineItem*

        :param etag: The etag of this LineItemBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def type(self):
        """Gets the type of this LineItemBase.

        The type of the *LineItem*

        :return: The type of this LineItemBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LineItemBase.

        The type of the *LineItem*

        :param type: The type of this LineItemBase.
        :type type: str
        """
        allowed_values = ["ActivityLineItem", "LineItem", "NoChargeLineItem", "SummaryLineItem"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def description(self):
        """Gets the description of this LineItemBase.

        The description for the *LineItem*

        :return: The description of this LineItemBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this LineItemBase.

        The description for the *LineItem*

        :param description: The description of this LineItemBase.
        :type description: str
        """

        self._description = description

    @property
    def _date(self):
        """Gets the _date of this LineItemBase.

        The *LineItem* date (as a ISO-8601 date)

        :return: The _date of this LineItemBase.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this LineItemBase.

        The *LineItem* date (as a ISO-8601 date)

        :param _date: The _date of this LineItemBase.
        :type _date: date
        """

        self.__date = _date

    @property
    def price(self):
        """Gets the price of this LineItemBase.

        The price of the *LineItem*

        :return: The price of this LineItemBase.
        :rtype: float
        """
        return self._price

    @price.setter
    def price(self, price):
        """Sets the price of this LineItemBase.

        The price of the *LineItem*

        :param price: The price of this LineItemBase.
        :type price: float
        """

        self._price = price

    @property
    def taxable(self):
        """Gets the taxable of this LineItemBase.

        Whether the *LineItem* is taxable

        :return: The taxable of this LineItemBase.
        :rtype: bool
        """
        return self._taxable

    @taxable.setter
    def taxable(self, taxable):
        """Sets the taxable of this LineItemBase.

        Whether the *LineItem* is taxable

        :param taxable: The taxable of this LineItemBase.
        :type taxable: bool
        """

        self._taxable = taxable

    @property
    def kind(self):
        """Gets the kind of this LineItemBase.

        The kind of *LineItem*

        :return: The kind of this LineItemBase.
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this LineItemBase.

        The kind of *LineItem*

        :param kind: The kind of this LineItemBase.
        :type kind: str
        """
        allowed_values = ["Service", "Expense"]  # noqa: E501
        if kind not in allowed_values:
            raise ValueError(
                "Invalid value for `kind` ({0}), must be one of {1}"
                .format(kind, allowed_values)
            )

        self._kind = kind

    @property
    def note(self):
        """Gets the note of this LineItemBase.

        The note attached to the *LineItem*

        :return: The note of this LineItemBase.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this LineItemBase.

        The note attached to the *LineItem*

        :param note: The note of this LineItemBase.
        :type note: str
        """

        self._note = note

    @property
    def secondary_taxable(self):
        """Gets the secondary_taxable of this LineItemBase.

        Whether the *LineItem* is secondary taxable

        :return: The secondary_taxable of this LineItemBase.
        :rtype: bool
        """
        return self._secondary_taxable

    @secondary_taxable.setter
    def secondary_taxable(self, secondary_taxable):
        """Sets the secondary_taxable of this LineItemBase.

        Whether the *LineItem* is secondary taxable

        :param secondary_taxable: The secondary_taxable of this LineItemBase.
        :type secondary_taxable: bool
        """

        self._secondary_taxable = secondary_taxable

    @property
    def total(self):
        """Gets the total of this LineItemBase.

        The total amount for the *LineItem*

        :return: The total of this LineItemBase.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this LineItemBase.

        The total amount for the *LineItem*

        :param total: The total of this LineItemBase.
        :type total: float
        """

        self._total = total

    @property
    def tax(self):
        """Gets the tax of this LineItemBase.

        The tax amount for the *LineItem*

        :return: The tax of this LineItemBase.
        :rtype: float
        """
        return self._tax

    @tax.setter
    def tax(self, tax):
        """Sets the tax of this LineItemBase.

        The tax amount for the *LineItem*

        :param tax: The tax of this LineItemBase.
        :type tax: float
        """

        self._tax = tax

    @property
    def secondary_tax(self):
        """Gets the secondary_tax of this LineItemBase.

        The secondary tax amount for the *LineItem*

        :return: The secondary_tax of this LineItemBase.
        :rtype: float
        """
        return self._secondary_tax

    @secondary_tax.setter
    def secondary_tax(self, secondary_tax):
        """Sets the secondary_tax of this LineItemBase.

        The secondary tax amount for the *LineItem*

        :param secondary_tax: The secondary_tax of this LineItemBase.
        :type secondary_tax: float
        """

        self._secondary_tax = secondary_tax

    @property
    def sub_total(self):
        """Gets the sub_total of this LineItemBase.

        The subtotal amount for the *LineItem*

        :return: The sub_total of this LineItemBase.
        :rtype: float
        """
        return self._sub_total

    @sub_total.setter
    def sub_total(self, sub_total):
        """Sets the sub_total of this LineItemBase.

        The subtotal amount for the *LineItem*

        :param sub_total: The sub_total of this LineItemBase.
        :type sub_total: float
        """

        self._sub_total = sub_total

    @property
    def quantity(self):
        """Gets the quantity of this LineItemBase.

        The amount of hours for the *LineItem*

        :return: The quantity of this LineItemBase.
        :rtype: float
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this LineItemBase.

        The amount of hours for the *LineItem*

        :param quantity: The quantity of this LineItemBase.
        :type quantity: float
        """

        self._quantity = quantity

    @property
    def group_ordering(self):
        """Gets the group_ordering of this LineItemBase.

        The value to specify the ordering of the *LineItem* on a bill

        :return: The group_ordering of this LineItemBase.
        :rtype: int
        """
        return self._group_ordering

    @group_ordering.setter
    def group_ordering(self, group_ordering):
        """Sets the group_ordering of this LineItemBase.

        The value to specify the ordering of the *LineItem* on a bill

        :param group_ordering: The group_ordering of this LineItemBase.
        :type group_ordering: int
        """

        self._group_ordering = group_ordering

    @property
    def created_at(self):
        """Gets the created_at of this LineItemBase.

        The time the *LineItem* was created (as a ISO-8601 timestamp)

        :return: The created_at of this LineItemBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this LineItemBase.

        The time the *LineItem* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this LineItemBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this LineItemBase.

        The time the *LineItem* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this LineItemBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this LineItemBase.

        The time the *LineItem* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this LineItemBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
