# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.polymorphic_object_base import PolymorphicObjectBase
from openapi_server.models.user_base import UserBase
from openapi_server import util


class LogEntry(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, type: str=None, accessed_at: datetime=None, created_at: datetime=None, updated_at: datetime=None, item: PolymorphicObjectBase=None, user: UserBase=None):
        """LogEntry - a model defined in OpenAPI

        :param id: The id of this LogEntry.
        :param etag: The etag of this LogEntry.
        :param type: The type of this LogEntry.
        :param accessed_at: The accessed_at of this LogEntry.
        :param created_at: The created_at of this LogEntry.
        :param updated_at: The updated_at of this LogEntry.
        :param item: The item of this LogEntry.
        :param user: The user of this LogEntry.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'type': str,
            'accessed_at': datetime,
            'created_at': datetime,
            'updated_at': datetime,
            'item': PolymorphicObjectBase,
            'user': UserBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'type': 'type',
            'accessed_at': 'accessed_at',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'item': 'item',
            'user': 'user'
        }

        self._id = id
        self._etag = etag
        self._type = type
        self._accessed_at = accessed_at
        self._created_at = created_at
        self._updated_at = updated_at
        self._item = item
        self._user = user

    @classmethod
    def from_dict(cls, dikt: dict) -> 'LogEntry':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The LogEntry of this LogEntry.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this LogEntry.

        Unique identifier for the *LogEntry*

        :return: The id of this LogEntry.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LogEntry.

        Unique identifier for the *LogEntry*

        :param id: The id of this LogEntry.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this LogEntry.

        ETag for the *LogEntry*

        :return: The etag of this LogEntry.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this LogEntry.

        ETag for the *LogEntry*

        :param etag: The etag of this LogEntry.
        :type etag: str
        """

        self._etag = etag

    @property
    def type(self):
        """Gets the type of this LogEntry.

        The type of the *LogEntry*

        :return: The type of this LogEntry.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LogEntry.

        The type of the *LogEntry*

        :param type: The type of this LogEntry.
        :type type: str
        """
        allowed_values = ["MatterLogEntry", "ContactLogEntry"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def accessed_at(self):
        """Gets the accessed_at of this LogEntry.

        The time the item was last accessed (as a ISO-8601 timestamp)

        :return: The accessed_at of this LogEntry.
        :rtype: datetime
        """
        return self._accessed_at

    @accessed_at.setter
    def accessed_at(self, accessed_at):
        """Sets the accessed_at of this LogEntry.

        The time the item was last accessed (as a ISO-8601 timestamp)

        :param accessed_at: The accessed_at of this LogEntry.
        :type accessed_at: datetime
        """

        self._accessed_at = accessed_at

    @property
    def created_at(self):
        """Gets the created_at of this LogEntry.

        The time the *LogEntry* was created (as a ISO-8601 timestamp)

        :return: The created_at of this LogEntry.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this LogEntry.

        The time the *LogEntry* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this LogEntry.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this LogEntry.

        The time the *LogEntry* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this LogEntry.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this LogEntry.

        The time the *LogEntry* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this LogEntry.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def item(self):
        """Gets the item of this LogEntry.


        :return: The item of this LogEntry.
        :rtype: PolymorphicObjectBase
        """
        return self._item

    @item.setter
    def item(self, item):
        """Sets the item of this LogEntry.


        :param item: The item of this LogEntry.
        :type item: PolymorphicObjectBase
        """

        self._item = item

    @property
    def user(self):
        """Gets the user of this LogEntry.


        :return: The user of this LogEntry.
        :rtype: UserBase
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this LogEntry.


        :param user: The user of this LogEntry.
        :type user: UserBase
        """

        self._user = user
