# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.contact_base import ContactBase
from openapi_server import util


class MatterBillRecipient(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, created_at: datetime=None, etag: str=None, id: int=None, updated_at: datetime=None, recipient: ContactBase=None):
        """MatterBillRecipient - a model defined in OpenAPI

        :param created_at: The created_at of this MatterBillRecipient.
        :param etag: The etag of this MatterBillRecipient.
        :param id: The id of this MatterBillRecipient.
        :param updated_at: The updated_at of this MatterBillRecipient.
        :param recipient: The recipient of this MatterBillRecipient.
        """
        self.openapi_types = {
            'created_at': datetime,
            'etag': str,
            'id': int,
            'updated_at': datetime,
            'recipient': ContactBase
        }

        self.attribute_map = {
            'created_at': 'created_at',
            'etag': 'etag',
            'id': 'id',
            'updated_at': 'updated_at',
            'recipient': 'recipient'
        }

        self._created_at = created_at
        self._etag = etag
        self._id = id
        self._updated_at = updated_at
        self._recipient = recipient

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterBillRecipient':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MatterBillRecipient of this MatterBillRecipient.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def created_at(self):
        """Gets the created_at of this MatterBillRecipient.

        The time the *MatterBillRecipient* was created (as a ISO-8601 timestamp)

        :return: The created_at of this MatterBillRecipient.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MatterBillRecipient.

        The time the *MatterBillRecipient* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this MatterBillRecipient.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def etag(self):
        """Gets the etag of this MatterBillRecipient.

        ETag for the *MatterBillRecipient*

        :return: The etag of this MatterBillRecipient.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this MatterBillRecipient.

        ETag for the *MatterBillRecipient*

        :param etag: The etag of this MatterBillRecipient.
        :type etag: str
        """

        self._etag = etag

    @property
    def id(self):
        """Gets the id of this MatterBillRecipient.

        Unique identifier for the *MatterBillRecipient*

        :return: The id of this MatterBillRecipient.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatterBillRecipient.

        Unique identifier for the *MatterBillRecipient*

        :param id: The id of this MatterBillRecipient.
        :type id: int
        """

        self._id = id

    @property
    def updated_at(self):
        """Gets the updated_at of this MatterBillRecipient.

        The time the *MatterBillRecipient* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this MatterBillRecipient.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this MatterBillRecipient.

        The time the *MatterBillRecipient* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this MatterBillRecipient.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def recipient(self):
        """Gets the recipient of this MatterBillRecipient.


        :return: The recipient of this MatterBillRecipient.
        :rtype: ContactBase
        """
        return self._recipient

    @recipient.setter
    def recipient(self, recipient):
        """Sets the recipient of this MatterBillRecipient.


        :param recipient: The recipient of this MatterBillRecipient.
        :type recipient: ContactBase
        """

        self._recipient = recipient
