# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class MatterContactsBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, contact_created_at: datetime=None, contact_updated_at: datetime=None, created_at: datetime=None, description: str=None, etag: str=None, first_name: str=None, id: int=None, initials: str=None, is_client: bool=None, last_name: str=None, matter_id: int=None, matter_number: str=None, middle_name: str=None, name: str=None, prefix: str=None, primary_email_address: str=None, primary_phone_number: str=None, relationship_name: str=None, secondary_email_address: str=None, secondary_phone_number: str=None, title: str=None, type: str=None, updated_at: datetime=None, client_connect_user_id: int=None):
        """MatterContactsBase - a model defined in OpenAPI

        :param contact_created_at: The contact_created_at of this MatterContactsBase.
        :param contact_updated_at: The contact_updated_at of this MatterContactsBase.
        :param created_at: The created_at of this MatterContactsBase.
        :param description: The description of this MatterContactsBase.
        :param etag: The etag of this MatterContactsBase.
        :param first_name: The first_name of this MatterContactsBase.
        :param id: The id of this MatterContactsBase.
        :param initials: The initials of this MatterContactsBase.
        :param is_client: The is_client of this MatterContactsBase.
        :param last_name: The last_name of this MatterContactsBase.
        :param matter_id: The matter_id of this MatterContactsBase.
        :param matter_number: The matter_number of this MatterContactsBase.
        :param middle_name: The middle_name of this MatterContactsBase.
        :param name: The name of this MatterContactsBase.
        :param prefix: The prefix of this MatterContactsBase.
        :param primary_email_address: The primary_email_address of this MatterContactsBase.
        :param primary_phone_number: The primary_phone_number of this MatterContactsBase.
        :param relationship_name: The relationship_name of this MatterContactsBase.
        :param secondary_email_address: The secondary_email_address of this MatterContactsBase.
        :param secondary_phone_number: The secondary_phone_number of this MatterContactsBase.
        :param title: The title of this MatterContactsBase.
        :param type: The type of this MatterContactsBase.
        :param updated_at: The updated_at of this MatterContactsBase.
        :param client_connect_user_id: The client_connect_user_id of this MatterContactsBase.
        """
        self.openapi_types = {
            'contact_created_at': datetime,
            'contact_updated_at': datetime,
            'created_at': datetime,
            'description': str,
            'etag': str,
            'first_name': str,
            'id': int,
            'initials': str,
            'is_client': bool,
            'last_name': str,
            'matter_id': int,
            'matter_number': str,
            'middle_name': str,
            'name': str,
            'prefix': str,
            'primary_email_address': str,
            'primary_phone_number': str,
            'relationship_name': str,
            'secondary_email_address': str,
            'secondary_phone_number': str,
            'title': str,
            'type': str,
            'updated_at': datetime,
            'client_connect_user_id': int
        }

        self.attribute_map = {
            'contact_created_at': 'contact_created_at',
            'contact_updated_at': 'contact_updated_at',
            'created_at': 'created_at',
            'description': 'description',
            'etag': 'etag',
            'first_name': 'first_name',
            'id': 'id',
            'initials': 'initials',
            'is_client': 'is_client',
            'last_name': 'last_name',
            'matter_id': 'matter_id',
            'matter_number': 'matter_number',
            'middle_name': 'middle_name',
            'name': 'name',
            'prefix': 'prefix',
            'primary_email_address': 'primary_email_address',
            'primary_phone_number': 'primary_phone_number',
            'relationship_name': 'relationship_name',
            'secondary_email_address': 'secondary_email_address',
            'secondary_phone_number': 'secondary_phone_number',
            'title': 'title',
            'type': 'type',
            'updated_at': 'updated_at',
            'client_connect_user_id': 'client_connect_user_id'
        }

        self._contact_created_at = contact_created_at
        self._contact_updated_at = contact_updated_at
        self._created_at = created_at
        self._description = description
        self._etag = etag
        self._first_name = first_name
        self._id = id
        self._initials = initials
        self._is_client = is_client
        self._last_name = last_name
        self._matter_id = matter_id
        self._matter_number = matter_number
        self._middle_name = middle_name
        self._name = name
        self._prefix = prefix
        self._primary_email_address = primary_email_address
        self._primary_phone_number = primary_phone_number
        self._relationship_name = relationship_name
        self._secondary_email_address = secondary_email_address
        self._secondary_phone_number = secondary_phone_number
        self._title = title
        self._type = type
        self._updated_at = updated_at
        self._client_connect_user_id = client_connect_user_id

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterContactsBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MatterContacts_base of this MatterContactsBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def contact_created_at(self):
        """Gets the contact_created_at of this MatterContactsBase.

        Timestamp of the time the contact was created

        :return: The contact_created_at of this MatterContactsBase.
        :rtype: datetime
        """
        return self._contact_created_at

    @contact_created_at.setter
    def contact_created_at(self, contact_created_at):
        """Sets the contact_created_at of this MatterContactsBase.

        Timestamp of the time the contact was created

        :param contact_created_at: The contact_created_at of this MatterContactsBase.
        :type contact_created_at: datetime
        """

        self._contact_created_at = contact_created_at

    @property
    def contact_updated_at(self):
        """Gets the contact_updated_at of this MatterContactsBase.

        Timestamp of the time the contact was created

        :return: The contact_updated_at of this MatterContactsBase.
        :rtype: datetime
        """
        return self._contact_updated_at

    @contact_updated_at.setter
    def contact_updated_at(self, contact_updated_at):
        """Sets the contact_updated_at of this MatterContactsBase.

        Timestamp of the time the contact was created

        :param contact_updated_at: The contact_updated_at of this MatterContactsBase.
        :type contact_updated_at: datetime
        """

        self._contact_updated_at = contact_updated_at

    @property
    def created_at(self):
        """Gets the created_at of this MatterContactsBase.

        The time the *MatterContacts* was created (as a ISO-8601 timestamp)

        :return: The created_at of this MatterContactsBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MatterContactsBase.

        The time the *MatterContacts* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this MatterContactsBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def description(self):
        """Gets the description of this MatterContactsBase.

        Description of the matter

        :return: The description of this MatterContactsBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this MatterContactsBase.

        Description of the matter

        :param description: The description of this MatterContactsBase.
        :type description: str
        """

        self._description = description

    @property
    def etag(self):
        """Gets the etag of this MatterContactsBase.

        ETag for the *MatterContacts*

        :return: The etag of this MatterContactsBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this MatterContactsBase.

        ETag for the *MatterContacts*

        :param etag: The etag of this MatterContactsBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def first_name(self):
        """Gets the first_name of this MatterContactsBase.

        First name of the Person

        :return: The first_name of this MatterContactsBase.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this MatterContactsBase.

        First name of the Person

        :param first_name: The first_name of this MatterContactsBase.
        :type first_name: str
        """

        self._first_name = first_name

    @property
    def id(self):
        """Gets the id of this MatterContactsBase.

        Unique identifier for the *MatterContacts*

        :return: The id of this MatterContactsBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatterContactsBase.

        Unique identifier for the *MatterContacts*

        :param id: The id of this MatterContactsBase.
        :type id: int
        """

        self._id = id

    @property
    def initials(self):
        """Gets the initials of this MatterContactsBase.

        The initials of the *MatterContacts*

        :return: The initials of this MatterContactsBase.
        :rtype: str
        """
        return self._initials

    @initials.setter
    def initials(self, initials):
        """Sets the initials of this MatterContactsBase.

        The initials of the *MatterContacts*

        :param initials: The initials of this MatterContactsBase.
        :type initials: str
        """

        self._initials = initials

    @property
    def is_client(self):
        """Gets the is_client of this MatterContactsBase.

        Whether or not the MatterContacts is a client

        :return: The is_client of this MatterContactsBase.
        :rtype: bool
        """
        return self._is_client

    @is_client.setter
    def is_client(self, is_client):
        """Sets the is_client of this MatterContactsBase.

        Whether or not the MatterContacts is a client

        :param is_client: The is_client of this MatterContactsBase.
        :type is_client: bool
        """

        self._is_client = is_client

    @property
    def last_name(self):
        """Gets the last_name of this MatterContactsBase.

        Last name of the Person

        :return: The last_name of this MatterContactsBase.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this MatterContactsBase.

        Last name of the Person

        :param last_name: The last_name of this MatterContactsBase.
        :type last_name: str
        """

        self._last_name = last_name

    @property
    def matter_id(self):
        """Gets the matter_id of this MatterContactsBase.

        ID of the matter

        :return: The matter_id of this MatterContactsBase.
        :rtype: int
        """
        return self._matter_id

    @matter_id.setter
    def matter_id(self, matter_id):
        """Sets the matter_id of this MatterContactsBase.

        ID of the matter

        :param matter_id: The matter_id of this MatterContactsBase.
        :type matter_id: int
        """

        self._matter_id = matter_id

    @property
    def matter_number(self):
        """Gets the matter_number of this MatterContactsBase.

        Number of the matter

        :return: The matter_number of this MatterContactsBase.
        :rtype: str
        """
        return self._matter_number

    @matter_number.setter
    def matter_number(self, matter_number):
        """Sets the matter_number of this MatterContactsBase.

        Number of the matter

        :param matter_number: The matter_number of this MatterContactsBase.
        :type matter_number: str
        """

        self._matter_number = matter_number

    @property
    def middle_name(self):
        """Gets the middle_name of this MatterContactsBase.

        Middle name of the Person

        :return: The middle_name of this MatterContactsBase.
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this MatterContactsBase.

        Middle name of the Person

        :param middle_name: The middle_name of this MatterContactsBase.
        :type middle_name: str
        """

        self._middle_name = middle_name

    @property
    def name(self):
        """Gets the name of this MatterContactsBase.

        The full name of the *MatterContacts*

        :return: The name of this MatterContactsBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MatterContactsBase.

        The full name of the *MatterContacts*

        :param name: The name of this MatterContactsBase.
        :type name: str
        """

        self._name = name

    @property
    def prefix(self):
        """Gets the prefix of this MatterContactsBase.

        The prefix of the *MatterContacts* (Mr, Mrs, etc)

        :return: The prefix of this MatterContactsBase.
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this MatterContactsBase.

        The prefix of the *MatterContacts* (Mr, Mrs, etc)

        :param prefix: The prefix of this MatterContactsBase.
        :type prefix: str
        """

        self._prefix = prefix

    @property
    def primary_email_address(self):
        """Gets the primary_email_address of this MatterContactsBase.

        The primary email address associated with this *MatterContacts*.

        :return: The primary_email_address of this MatterContactsBase.
        :rtype: str
        """
        return self._primary_email_address

    @primary_email_address.setter
    def primary_email_address(self, primary_email_address):
        """Sets the primary_email_address of this MatterContactsBase.

        The primary email address associated with this *MatterContacts*.

        :param primary_email_address: The primary_email_address of this MatterContactsBase.
        :type primary_email_address: str
        """

        self._primary_email_address = primary_email_address

    @property
    def primary_phone_number(self):
        """Gets the primary_phone_number of this MatterContactsBase.

        The primary phone number associated with this *MatterContacts*.

        :return: The primary_phone_number of this MatterContactsBase.
        :rtype: str
        """
        return self._primary_phone_number

    @primary_phone_number.setter
    def primary_phone_number(self, primary_phone_number):
        """Sets the primary_phone_number of this MatterContactsBase.

        The primary phone number associated with this *MatterContacts*.

        :param primary_phone_number: The primary_phone_number of this MatterContactsBase.
        :type primary_phone_number: str
        """

        self._primary_phone_number = primary_phone_number

    @property
    def relationship_name(self):
        """Gets the relationship_name of this MatterContactsBase.

        The description of the relation between the contact and the matter, or \"Client\" if the user is the client.

        :return: The relationship_name of this MatterContactsBase.
        :rtype: str
        """
        return self._relationship_name

    @relationship_name.setter
    def relationship_name(self, relationship_name):
        """Sets the relationship_name of this MatterContactsBase.

        The description of the relation between the contact and the matter, or \"Client\" if the user is the client.

        :param relationship_name: The relationship_name of this MatterContactsBase.
        :type relationship_name: str
        """

        self._relationship_name = relationship_name

    @property
    def secondary_email_address(self):
        """Gets the secondary_email_address of this MatterContactsBase.

        The secondary email address of the contact

        :return: The secondary_email_address of this MatterContactsBase.
        :rtype: str
        """
        return self._secondary_email_address

    @secondary_email_address.setter
    def secondary_email_address(self, secondary_email_address):
        """Sets the secondary_email_address of this MatterContactsBase.

        The secondary email address of the contact

        :param secondary_email_address: The secondary_email_address of this MatterContactsBase.
        :type secondary_email_address: str
        """

        self._secondary_email_address = secondary_email_address

    @property
    def secondary_phone_number(self):
        """Gets the secondary_phone_number of this MatterContactsBase.

        The secondary phone number of the contact

        :return: The secondary_phone_number of this MatterContactsBase.
        :rtype: str
        """
        return self._secondary_phone_number

    @secondary_phone_number.setter
    def secondary_phone_number(self, secondary_phone_number):
        """Sets the secondary_phone_number of this MatterContactsBase.

        The secondary phone number of the contact

        :param secondary_phone_number: The secondary_phone_number of this MatterContactsBase.
        :type secondary_phone_number: str
        """

        self._secondary_phone_number = secondary_phone_number

    @property
    def title(self):
        """Gets the title of this MatterContactsBase.

        The designated title of the *MatterContacts*

        :return: The title of this MatterContactsBase.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this MatterContactsBase.

        The designated title of the *MatterContacts*

        :param title: The title of this MatterContactsBase.
        :type title: str
        """

        self._title = title

    @property
    def type(self):
        """Gets the type of this MatterContactsBase.

        The type of the *MatterContacts*

        :return: The type of this MatterContactsBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this MatterContactsBase.

        The type of the *MatterContacts*

        :param type: The type of this MatterContactsBase.
        :type type: str
        """
        allowed_values = ["Company", "Person"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def updated_at(self):
        """Gets the updated_at of this MatterContactsBase.

        The time the *MatterContacts* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this MatterContactsBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this MatterContactsBase.

        The time the *MatterContacts* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this MatterContactsBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def client_connect_user_id(self):
        """Gets the client_connect_user_id of this MatterContactsBase.

        The client connect ID of the contacts associated user

        :return: The client_connect_user_id of this MatterContactsBase.
        :rtype: int
        """
        return self._client_connect_user_id

    @client_connect_user_id.setter
    def client_connect_user_id(self, client_connect_user_id):
        """Sets the client_connect_user_id of this MatterContactsBase.

        The client connect ID of the contacts associated user

        :param client_connect_user_id: The client_connect_user_id of this MatterContactsBase.
        :type client_connect_user_id: int
        """

        self._client_connect_user_id = client_connect_user_id
