# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.polymorphic_custom_rate import PolymorphicCustomRate
from openapi_server import util


class MatterCustomRate(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type: str=None, on_invoice: bool=None, rates: List[PolymorphicCustomRate]=None):
        """MatterCustomRate - a model defined in OpenAPI

        :param type: The type of this MatterCustomRate.
        :param on_invoice: The on_invoice of this MatterCustomRate.
        :param rates: The rates of this MatterCustomRate.
        """
        self.openapi_types = {
            'type': str,
            'on_invoice': bool,
            'rates': List[PolymorphicCustomRate]
        }

        self.attribute_map = {
            'type': 'type',
            'on_invoice': 'on_invoice',
            'rates': 'rates'
        }

        self._type = type
        self._on_invoice = on_invoice
        self._rates = rates

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterCustomRate':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MatterCustomRate of this MatterCustomRate.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self):
        """Gets the type of this MatterCustomRate.

        The type of the *MatterCustomRate*

        :return: The type of this MatterCustomRate.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this MatterCustomRate.

        The type of the *MatterCustomRate*

        :param type: The type of this MatterCustomRate.
        :type type: str
        """
        allowed_values = ["FlatRate", "HourlyRate", "ContingencyFee"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def on_invoice(self):
        """Gets the on_invoice of this MatterCustomRate.

        Specifies if the matter's associated activity is posted or on a bill.

        :return: The on_invoice of this MatterCustomRate.
        :rtype: bool
        """
        return self._on_invoice

    @on_invoice.setter
    def on_invoice(self, on_invoice):
        """Sets the on_invoice of this MatterCustomRate.

        Specifies if the matter's associated activity is posted or on a bill.

        :param on_invoice: The on_invoice of this MatterCustomRate.
        :type on_invoice: bool
        """

        self._on_invoice = on_invoice

    @property
    def rates(self):
        """Gets the rates of this MatterCustomRate.

        PolymorphicCustomRate

        :return: The rates of this MatterCustomRate.
        :rtype: List[PolymorphicCustomRate]
        """
        return self._rates

    @rates.setter
    def rates(self, rates):
        """Sets the rates of this MatterCustomRate.

        PolymorphicCustomRate

        :param rates: The rates of this MatterCustomRate.
        :type rates: List[PolymorphicCustomRate]
        """

        self._rates = rates
