# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.contact_update_request_data_custom_field_set_associations_inner_custom_field_set import ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet
from openapi_server import util


class MatterUpdateRequestDataCustomFieldSetAssociationsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, display_order: int=None, custom_field_set: ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet=None, destroy: bool=None):
        """MatterUpdateRequestDataCustomFieldSetAssociationsInner - a model defined in OpenAPI

        :param id: The id of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :param display_order: The display_order of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :param custom_field_set: The custom_field_set of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :param destroy: The destroy of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        """
        self.openapi_types = {
            'id': int,
            'display_order': int,
            'custom_field_set': ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet,
            'destroy': bool
        }

        self.attribute_map = {
            'id': 'id',
            'display_order': 'display_order',
            'custom_field_set': 'custom_field_set',
            'destroy': '_destroy'
        }

        self._id = id
        self._display_order = display_order
        self._custom_field_set = custom_field_set
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterUpdateRequestDataCustomFieldSetAssociationsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Matter_update_request_data_custom_field_set_associations_inner of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The unique identifier for a single CustomFieldSetAssociation associated with the Matter. The keyword `null` is not valid for this field.

        :return: The id of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The unique identifier for a single CustomFieldSetAssociation associated with the Matter. The keyword `null` is not valid for this field.

        :param id: The id of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :type id: int
        """

        self._id = id

    @property
    def display_order(self):
        """Gets the display_order of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The order to display the CustomFieldSet in a Matter. If not specified, it is added as the last CustomFieldSet of the Matter.

        :return: The display_order of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :rtype: int
        """
        return self._display_order

    @display_order.setter
    def display_order(self, display_order):
        """Sets the display_order of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The order to display the CustomFieldSet in a Matter. If not specified, it is added as the last CustomFieldSet of the Matter.

        :param display_order: The display_order of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :type display_order: int
        """

        self._display_order = display_order

    @property
    def custom_field_set(self):
        """Gets the custom_field_set of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.


        :return: The custom_field_set of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :rtype: ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet
        """
        return self._custom_field_set

    @custom_field_set.setter
    def custom_field_set(self, custom_field_set):
        """Sets the custom_field_set of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.


        :param custom_field_set: The custom_field_set of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :type custom_field_set: ContactUpdateRequestDataCustomFieldSetAssociationsInnerCustomFieldSet
        """

        self._custom_field_set = custom_field_set

    @property
    def destroy(self):
        """Gets the destroy of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated CustomFieldSetAssociation is present, the CustomFieldSetAssociation is deleted from the Matter.

        :return: The destroy of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated CustomFieldSetAssociation is present, the CustomFieldSetAssociation is deleted from the Matter.

        :param destroy: The destroy of this MatterUpdateRequestDataCustomFieldSetAssociationsInner.
        :type destroy: bool
        """

        self._destroy = destroy
