# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.contact_update_request_data_custom_field_values_inner_custom_field import ContactUpdateRequestDataCustomFieldValuesInnerCustomField
from openapi_server import util


class MatterUpdateRequestDataCustomFieldValuesInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, value: str=None, custom_field: ContactUpdateRequestDataCustomFieldValuesInnerCustomField=None, id: int=None, destroy: bool=None):
        """MatterUpdateRequestDataCustomFieldValuesInner - a model defined in OpenAPI

        :param value: The value of this MatterUpdateRequestDataCustomFieldValuesInner.
        :param custom_field: The custom_field of this MatterUpdateRequestDataCustomFieldValuesInner.
        :param id: The id of this MatterUpdateRequestDataCustomFieldValuesInner.
        :param destroy: The destroy of this MatterUpdateRequestDataCustomFieldValuesInner.
        """
        self.openapi_types = {
            'value': str,
            'custom_field': ContactUpdateRequestDataCustomFieldValuesInnerCustomField,
            'id': int,
            'destroy': bool
        }

        self.attribute_map = {
            'value': 'value',
            'custom_field': 'custom_field',
            'id': 'id',
            'destroy': '_destroy'
        }

        self._value = value
        self._custom_field = custom_field
        self._id = id
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterUpdateRequestDataCustomFieldValuesInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Matter_update_request_data_custom_field_values_inner of this MatterUpdateRequestDataCustomFieldValuesInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def value(self):
        """Gets the value of this MatterUpdateRequestDataCustomFieldValuesInner.

        The value of the CustomFieldValue.

        :return: The value of this MatterUpdateRequestDataCustomFieldValuesInner.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this MatterUpdateRequestDataCustomFieldValuesInner.

        The value of the CustomFieldValue.

        :param value: The value of this MatterUpdateRequestDataCustomFieldValuesInner.
        :type value: str
        """

        self._value = value

    @property
    def custom_field(self):
        """Gets the custom_field of this MatterUpdateRequestDataCustomFieldValuesInner.


        :return: The custom_field of this MatterUpdateRequestDataCustomFieldValuesInner.
        :rtype: ContactUpdateRequestDataCustomFieldValuesInnerCustomField
        """
        return self._custom_field

    @custom_field.setter
    def custom_field(self, custom_field):
        """Sets the custom_field of this MatterUpdateRequestDataCustomFieldValuesInner.


        :param custom_field: The custom_field of this MatterUpdateRequestDataCustomFieldValuesInner.
        :type custom_field: ContactUpdateRequestDataCustomFieldValuesInnerCustomField
        """

        self._custom_field = custom_field

    @property
    def id(self):
        """Gets the id of this MatterUpdateRequestDataCustomFieldValuesInner.

        The unique identifier for a single CustomFieldValue associated with the Matter. The keyword `null` is not valid for this field.

        :return: The id of this MatterUpdateRequestDataCustomFieldValuesInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatterUpdateRequestDataCustomFieldValuesInner.

        The unique identifier for a single CustomFieldValue associated with the Matter. The keyword `null` is not valid for this field.

        :param id: The id of this MatterUpdateRequestDataCustomFieldValuesInner.
        :type id: int
        """

        self._id = id

    @property
    def destroy(self):
        """Gets the destroy of this MatterUpdateRequestDataCustomFieldValuesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated CustomFieldValue is present, the CustomFieldValue is deleted from the Matter.

        :return: The destroy of this MatterUpdateRequestDataCustomFieldValuesInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this MatterUpdateRequestDataCustomFieldValuesInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated CustomFieldValue is present, the CustomFieldValue is deleted from the Matter.

        :param destroy: The destroy of this MatterUpdateRequestDataCustomFieldValuesInner.
        :type destroy: bool
        """

        self._destroy = destroy
