# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.matter_create_request_data_evergreen_retainer_recipients_inner import MatterCreateRequestDataEvergreenRetainerRecipientsInner
from openapi_server import util


class MatterUpdateRequestDataEvergreenRetainer(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, minimum_threshold: float=None, destroy: bool=None, recipients: List[MatterCreateRequestDataEvergreenRetainerRecipientsInner]=None):
        """MatterUpdateRequestDataEvergreenRetainer - a model defined in OpenAPI

        :param minimum_threshold: The minimum_threshold of this MatterUpdateRequestDataEvergreenRetainer.
        :param destroy: The destroy of this MatterUpdateRequestDataEvergreenRetainer.
        :param recipients: The recipients of this MatterUpdateRequestDataEvergreenRetainer.
        """
        self.openapi_types = {
            'minimum_threshold': float,
            'destroy': bool,
            'recipients': List[MatterCreateRequestDataEvergreenRetainerRecipientsInner]
        }

        self.attribute_map = {
            'minimum_threshold': 'minimum_threshold',
            'destroy': '_destroy',
            'recipients': 'recipients'
        }

        self._minimum_threshold = minimum_threshold
        self._destroy = destroy
        self._recipients = recipients

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterUpdateRequestDataEvergreenRetainer':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Matter_update_request_data_evergreen_retainer of this MatterUpdateRequestDataEvergreenRetainer.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def minimum_threshold(self):
        """Gets the minimum_threshold of this MatterUpdateRequestDataEvergreenRetainer.

        The trust balance threshold for the Matter. When the balance falls below the threshold, the retainer's associated recipients (firm users) will receive a notification.

        :return: The minimum_threshold of this MatterUpdateRequestDataEvergreenRetainer.
        :rtype: float
        """
        return self._minimum_threshold

    @minimum_threshold.setter
    def minimum_threshold(self, minimum_threshold):
        """Sets the minimum_threshold of this MatterUpdateRequestDataEvergreenRetainer.

        The trust balance threshold for the Matter. When the balance falls below the threshold, the retainer's associated recipients (firm users) will receive a notification.

        :param minimum_threshold: The minimum_threshold of this MatterUpdateRequestDataEvergreenRetainer.
        :type minimum_threshold: float
        """

        self._minimum_threshold = minimum_threshold

    @property
    def destroy(self):
        """Gets the destroy of this MatterUpdateRequestDataEvergreenRetainer.

        If this flag is set to `true`, the trust balance notification will be deleted from the Matter.

        :return: The destroy of this MatterUpdateRequestDataEvergreenRetainer.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this MatterUpdateRequestDataEvergreenRetainer.

        If this flag is set to `true`, the trust balance notification will be deleted from the Matter.

        :param destroy: The destroy of this MatterUpdateRequestDataEvergreenRetainer.
        :type destroy: bool
        """

        self._destroy = destroy

    @property
    def recipients(self):
        """Gets the recipients of this MatterUpdateRequestDataEvergreenRetainer.


        :return: The recipients of this MatterUpdateRequestDataEvergreenRetainer.
        :rtype: List[MatterCreateRequestDataEvergreenRetainerRecipientsInner]
        """
        return self._recipients

    @recipients.setter
    def recipients(self, recipients):
        """Sets the recipients of this MatterUpdateRequestDataEvergreenRetainer.


        :param recipients: The recipients of this MatterUpdateRequestDataEvergreenRetainer.
        :type recipients: List[MatterCreateRequestDataEvergreenRetainerRecipientsInner]
        """

        self._recipients = recipients
