# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.matter_update_request_data_statute_of_limitations_reminders_inner_notification_method import MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
from openapi_server import util


class MatterUpdateRequestDataStatuteOfLimitationsRemindersInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, duration_value: int=None, duration_unit: str=None, notification_method: MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod=None, id: int=None, destroy: bool=None):
        """MatterUpdateRequestDataStatuteOfLimitationsRemindersInner - a model defined in OpenAPI

        :param duration_value: The duration_value of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :param duration_unit: The duration_unit of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :param notification_method: The notification_method of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :param id: The id of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :param destroy: The destroy of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        """
        self.openapi_types = {
            'duration_value': int,
            'duration_unit': str,
            'notification_method': MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod,
            'id': int,
            'destroy': bool
        }

        self.attribute_map = {
            'duration_value': 'duration_value',
            'duration_unit': 'duration_unit',
            'notification_method': 'notification_method',
            'id': 'id',
            'destroy': '_destroy'
        }

        self._duration_value = duration_value
        self._duration_unit = duration_unit
        self._notification_method = notification_method
        self._id = id
        self._destroy = destroy

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MatterUpdateRequestDataStatuteOfLimitationsRemindersInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Matter_update_request_data_statute_of_limitations_reminders_inner of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def duration_value(self):
        """Gets the duration_value of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        Time measured in `duration_unit` to remind user before the subject.

        :return: The duration_value of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :rtype: int
        """
        return self._duration_value

    @duration_value.setter
    def duration_value(self, duration_value):
        """Sets the duration_value of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        Time measured in `duration_unit` to remind user before the subject.

        :param duration_value: The duration_value of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :type duration_value: int
        """

        self._duration_value = duration_value

    @property
    def duration_unit(self):
        """Gets the duration_unit of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        Unit to measure the duration value in.

        :return: The duration_unit of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :rtype: str
        """
        return self._duration_unit

    @duration_unit.setter
    def duration_unit(self, duration_unit):
        """Sets the duration_unit of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        Unit to measure the duration value in.

        :param duration_unit: The duration_unit of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :type duration_unit: str
        """

        self._duration_unit = duration_unit

    @property
    def notification_method(self):
        """Gets the notification_method of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.


        :return: The notification_method of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :rtype: MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
        """
        return self._notification_method

    @notification_method.setter
    def notification_method(self, notification_method):
        """Sets the notification_method of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.


        :param notification_method: The notification_method of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :type notification_method: MatterUpdateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
        """

        self._notification_method = notification_method

    @property
    def id(self):
        """Gets the id of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        The unique identifier for a single Reminder associated with the Matter. The keyword `null` is not valid for this field.

        :return: The id of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        The unique identifier for a single Reminder associated with the Matter. The keyword `null` is not valid for this field.

        :param id: The id of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :type id: int
        """

        self._id = id

    @property
    def destroy(self):
        """Gets the destroy of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated Reminder is present, the Reminder is deleted from the Matter.

        :return: The destroy of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :rtype: bool
        """
        return self._destroy

    @destroy.setter
    def destroy(self, destroy):
        """Sets the destroy of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.

        The destroy flag. If the flag is set to `true` and the unique identifier of the associated Reminder is present, the Reminder is deleted from the Matter.

        :param destroy: The destroy of this MatterUpdateRequestDataStatuteOfLimitationsRemindersInner.
        :type destroy: bool
        """

        self._destroy = destroy
