# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class MedicalBillBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, adjustment: float=None, amount: float=None, bill_date: date=None, bill_received_date: date=None, damage_type: str=None, document_id: int=None, etag: str=None, name: str=None, created_at: datetime=None, updated_at: datetime=None):
        """MedicalBillBase - a model defined in OpenAPI

        :param id: The id of this MedicalBillBase.
        :param adjustment: The adjustment of this MedicalBillBase.
        :param amount: The amount of this MedicalBillBase.
        :param bill_date: The bill_date of this MedicalBillBase.
        :param bill_received_date: The bill_received_date of this MedicalBillBase.
        :param damage_type: The damage_type of this MedicalBillBase.
        :param document_id: The document_id of this MedicalBillBase.
        :param etag: The etag of this MedicalBillBase.
        :param name: The name of this MedicalBillBase.
        :param created_at: The created_at of this MedicalBillBase.
        :param updated_at: The updated_at of this MedicalBillBase.
        """
        self.openapi_types = {
            'id': int,
            'adjustment': float,
            'amount': float,
            'bill_date': date,
            'bill_received_date': date,
            'damage_type': str,
            'document_id': int,
            'etag': str,
            'name': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'adjustment': 'adjustment',
            'amount': 'amount',
            'bill_date': 'bill_date',
            'bill_received_date': 'bill_received_date',
            'damage_type': 'damage_type',
            'document_id': 'document_id',
            'etag': 'etag',
            'name': 'name',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._adjustment = adjustment
        self._amount = amount
        self._bill_date = bill_date
        self._bill_received_date = bill_received_date
        self._damage_type = damage_type
        self._document_id = document_id
        self._etag = etag
        self._name = name
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MedicalBillBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MedicalBill_base of this MedicalBillBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this MedicalBillBase.

        Unique identifier for the *MedicalBill*

        :return: The id of this MedicalBillBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MedicalBillBase.

        Unique identifier for the *MedicalBill*

        :param id: The id of this MedicalBillBase.
        :type id: int
        """

        self._id = id

    @property
    def adjustment(self):
        """Gets the adjustment of this MedicalBillBase.

        Adjustment for Medical Bill

        :return: The adjustment of this MedicalBillBase.
        :rtype: float
        """
        return self._adjustment

    @adjustment.setter
    def adjustment(self, adjustment):
        """Sets the adjustment of this MedicalBillBase.

        Adjustment for Medical Bill

        :param adjustment: The adjustment of this MedicalBillBase.
        :type adjustment: float
        """

        self._adjustment = adjustment

    @property
    def amount(self):
        """Gets the amount of this MedicalBillBase.

        Amount for Medical Bill

        :return: The amount of this MedicalBillBase.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this MedicalBillBase.

        Amount for Medical Bill

        :param amount: The amount of this MedicalBillBase.
        :type amount: float
        """

        self._amount = amount

    @property
    def bill_date(self):
        """Gets the bill_date of this MedicalBillBase.

        Bill date for Medical Bill (as a ISO-8601 date)

        :return: The bill_date of this MedicalBillBase.
        :rtype: date
        """
        return self._bill_date

    @bill_date.setter
    def bill_date(self, bill_date):
        """Sets the bill_date of this MedicalBillBase.

        Bill date for Medical Bill (as a ISO-8601 date)

        :param bill_date: The bill_date of this MedicalBillBase.
        :type bill_date: date
        """

        self._bill_date = bill_date

    @property
    def bill_received_date(self):
        """Gets the bill_received_date of this MedicalBillBase.

        Bill received date for Medical Bill (as a ISO-8601 date)

        :return: The bill_received_date of this MedicalBillBase.
        :rtype: date
        """
        return self._bill_received_date

    @bill_received_date.setter
    def bill_received_date(self, bill_received_date):
        """Sets the bill_received_date of this MedicalBillBase.

        Bill received date for Medical Bill (as a ISO-8601 date)

        :param bill_received_date: The bill_received_date of this MedicalBillBase.
        :type bill_received_date: date
        """

        self._bill_received_date = bill_received_date

    @property
    def damage_type(self):
        """Gets the damage_type of this MedicalBillBase.

        Damage Type

        :return: The damage_type of this MedicalBillBase.
        :rtype: str
        """
        return self._damage_type

    @damage_type.setter
    def damage_type(self, damage_type):
        """Sets the damage_type of this MedicalBillBase.

        Damage Type

        :param damage_type: The damage_type of this MedicalBillBase.
        :type damage_type: str
        """

        self._damage_type = damage_type

    @property
    def document_id(self):
        """Gets the document_id of this MedicalBillBase.

        The id of the document associated with the Medical Bill

        :return: The document_id of this MedicalBillBase.
        :rtype: int
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this MedicalBillBase.

        The id of the document associated with the Medical Bill

        :param document_id: The document_id of this MedicalBillBase.
        :type document_id: int
        """

        self._document_id = document_id

    @property
    def etag(self):
        """Gets the etag of this MedicalBillBase.

        ETag for the *MedicalBill*

        :return: The etag of this MedicalBillBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this MedicalBillBase.

        ETag for the *MedicalBill*

        :param etag: The etag of this MedicalBillBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this MedicalBillBase.

        Name of the Medical Bill

        :return: The name of this MedicalBillBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MedicalBillBase.

        Name of the Medical Bill

        :param name: The name of this MedicalBillBase.
        :type name: str
        """

        self._name = name

    @property
    def created_at(self):
        """Gets the created_at of this MedicalBillBase.

        The time the *MedicalBill* was created (as a ISO-8601 timestamp)

        :return: The created_at of this MedicalBillBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this MedicalBillBase.

        The time the *MedicalBill* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this MedicalBillBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this MedicalBillBase.

        The time the *MedicalBill* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this MedicalBillBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this MedicalBillBase.

        The time the *MedicalBill* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this MedicalBillBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
