# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.medical_bill_update_request_data_payers_inner import MedicalBillUpdateRequestDataPayersInner
from openapi_server import util


class MedicalBillUpdateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, adjustment: float=None, amount: float=None, balance: float=None, bill_date: date=None, bill_received_date: date=None, mark_balance_as_lien: bool=None, name: str=None, payers: List[MedicalBillUpdateRequestDataPayersInner]=None):
        """MedicalBillUpdateRequestData - a model defined in OpenAPI

        :param adjustment: The adjustment of this MedicalBillUpdateRequestData.
        :param amount: The amount of this MedicalBillUpdateRequestData.
        :param balance: The balance of this MedicalBillUpdateRequestData.
        :param bill_date: The bill_date of this MedicalBillUpdateRequestData.
        :param bill_received_date: The bill_received_date of this MedicalBillUpdateRequestData.
        :param mark_balance_as_lien: The mark_balance_as_lien of this MedicalBillUpdateRequestData.
        :param name: The name of this MedicalBillUpdateRequestData.
        :param payers: The payers of this MedicalBillUpdateRequestData.
        """
        self.openapi_types = {
            'adjustment': float,
            'amount': float,
            'balance': float,
            'bill_date': date,
            'bill_received_date': date,
            'mark_balance_as_lien': bool,
            'name': str,
            'payers': List[MedicalBillUpdateRequestDataPayersInner]
        }

        self.attribute_map = {
            'adjustment': 'adjustment',
            'amount': 'amount',
            'balance': 'balance',
            'bill_date': 'bill_date',
            'bill_received_date': 'bill_received_date',
            'mark_balance_as_lien': 'mark_balance_as_lien',
            'name': 'name',
            'payers': 'payers'
        }

        self._adjustment = adjustment
        self._amount = amount
        self._balance = balance
        self._bill_date = bill_date
        self._bill_received_date = bill_received_date
        self._mark_balance_as_lien = mark_balance_as_lien
        self._name = name
        self._payers = payers

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MedicalBillUpdateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MedicalBill_update_request_data of this MedicalBillUpdateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def adjustment(self):
        """Gets the adjustment of this MedicalBillUpdateRequestData.

        Adjustment

        :return: The adjustment of this MedicalBillUpdateRequestData.
        :rtype: float
        """
        return self._adjustment

    @adjustment.setter
    def adjustment(self, adjustment):
        """Sets the adjustment of this MedicalBillUpdateRequestData.

        Adjustment

        :param adjustment: The adjustment of this MedicalBillUpdateRequestData.
        :type adjustment: float
        """

        self._adjustment = adjustment

    @property
    def amount(self):
        """Gets the amount of this MedicalBillUpdateRequestData.

        Amount

        :return: The amount of this MedicalBillUpdateRequestData.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this MedicalBillUpdateRequestData.

        Amount

        :param amount: The amount of this MedicalBillUpdateRequestData.
        :type amount: float
        """

        self._amount = amount

    @property
    def balance(self):
        """Gets the balance of this MedicalBillUpdateRequestData.

        Balance

        :return: The balance of this MedicalBillUpdateRequestData.
        :rtype: float
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this MedicalBillUpdateRequestData.

        Balance

        :param balance: The balance of this MedicalBillUpdateRequestData.
        :type balance: float
        """

        self._balance = balance

    @property
    def bill_date(self):
        """Gets the bill_date of this MedicalBillUpdateRequestData.

        Bill Date (Expects an ISO-8601 date).

        :return: The bill_date of this MedicalBillUpdateRequestData.
        :rtype: date
        """
        return self._bill_date

    @bill_date.setter
    def bill_date(self, bill_date):
        """Sets the bill_date of this MedicalBillUpdateRequestData.

        Bill Date (Expects an ISO-8601 date).

        :param bill_date: The bill_date of this MedicalBillUpdateRequestData.
        :type bill_date: date
        """

        self._bill_date = bill_date

    @property
    def bill_received_date(self):
        """Gets the bill_received_date of this MedicalBillUpdateRequestData.

        Bill Received Date (Expects an ISO-8601 date).

        :return: The bill_received_date of this MedicalBillUpdateRequestData.
        :rtype: date
        """
        return self._bill_received_date

    @bill_received_date.setter
    def bill_received_date(self, bill_received_date):
        """Sets the bill_received_date of this MedicalBillUpdateRequestData.

        Bill Received Date (Expects an ISO-8601 date).

        :param bill_received_date: The bill_received_date of this MedicalBillUpdateRequestData.
        :type bill_received_date: date
        """

        self._bill_received_date = bill_received_date

    @property
    def mark_balance_as_lien(self):
        """Gets the mark_balance_as_lien of this MedicalBillUpdateRequestData.

        Mark balance as lien

        :return: The mark_balance_as_lien of this MedicalBillUpdateRequestData.
        :rtype: bool
        """
        return self._mark_balance_as_lien

    @mark_balance_as_lien.setter
    def mark_balance_as_lien(self, mark_balance_as_lien):
        """Sets the mark_balance_as_lien of this MedicalBillUpdateRequestData.

        Mark balance as lien

        :param mark_balance_as_lien: The mark_balance_as_lien of this MedicalBillUpdateRequestData.
        :type mark_balance_as_lien: bool
        """

        self._mark_balance_as_lien = mark_balance_as_lien

    @property
    def name(self):
        """Gets the name of this MedicalBillUpdateRequestData.

        Name

        :return: The name of this MedicalBillUpdateRequestData.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MedicalBillUpdateRequestData.

        Name

        :param name: The name of this MedicalBillUpdateRequestData.
        :type name: str
        """

        self._name = name

    @property
    def payers(self):
        """Gets the payers of this MedicalBillUpdateRequestData.


        :return: The payers of this MedicalBillUpdateRequestData.
        :rtype: List[MedicalBillUpdateRequestDataPayersInner]
        """
        return self._payers

    @payers.setter
    def payers(self, payers):
        """Sets the payers of this MedicalBillUpdateRequestData.


        :param payers: The payers of this MedicalBillUpdateRequestData.
        :type payers: List[MedicalBillUpdateRequestDataPayersInner]
        """

        self._payers = payers
