# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.medical_records_request_create_request_data_medical_bills_inner import MedicalRecordsRequestCreateRequestDataMedicalBillsInner
from openapi_server.models.medical_records_request_create_request_data_medical_records_inner import MedicalRecordsRequestCreateRequestDataMedicalRecordsInner
from openapi_server import util


class MedicalRecordsRequestCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, bills_follow_up_date: datetime=None, bills_request_date: datetime=None, bills_status: str=None, description: str=None, in_treatment: bool=None, matter_id: int=None, medical_bills: List[MedicalRecordsRequestCreateRequestDataMedicalBillsInner]=None, medical_provider_id: int=None, medical_records: List[MedicalRecordsRequestCreateRequestDataMedicalRecordsInner]=None, records_follow_up_date: datetime=None, records_request_date: datetime=None, records_status: str=None, treatment_end_date: datetime=None, treatment_start_date: datetime=None):
        """MedicalRecordsRequestCreateRequestData - a model defined in OpenAPI

        :param bills_follow_up_date: The bills_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :param bills_request_date: The bills_request_date of this MedicalRecordsRequestCreateRequestData.
        :param bills_status: The bills_status of this MedicalRecordsRequestCreateRequestData.
        :param description: The description of this MedicalRecordsRequestCreateRequestData.
        :param in_treatment: The in_treatment of this MedicalRecordsRequestCreateRequestData.
        :param matter_id: The matter_id of this MedicalRecordsRequestCreateRequestData.
        :param medical_bills: The medical_bills of this MedicalRecordsRequestCreateRequestData.
        :param medical_provider_id: The medical_provider_id of this MedicalRecordsRequestCreateRequestData.
        :param medical_records: The medical_records of this MedicalRecordsRequestCreateRequestData.
        :param records_follow_up_date: The records_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :param records_request_date: The records_request_date of this MedicalRecordsRequestCreateRequestData.
        :param records_status: The records_status of this MedicalRecordsRequestCreateRequestData.
        :param treatment_end_date: The treatment_end_date of this MedicalRecordsRequestCreateRequestData.
        :param treatment_start_date: The treatment_start_date of this MedicalRecordsRequestCreateRequestData.
        """
        self.openapi_types = {
            'bills_follow_up_date': datetime,
            'bills_request_date': datetime,
            'bills_status': str,
            'description': str,
            'in_treatment': bool,
            'matter_id': int,
            'medical_bills': List[MedicalRecordsRequestCreateRequestDataMedicalBillsInner],
            'medical_provider_id': int,
            'medical_records': List[MedicalRecordsRequestCreateRequestDataMedicalRecordsInner],
            'records_follow_up_date': datetime,
            'records_request_date': datetime,
            'records_status': str,
            'treatment_end_date': datetime,
            'treatment_start_date': datetime
        }

        self.attribute_map = {
            'bills_follow_up_date': 'bills_follow_up_date',
            'bills_request_date': 'bills_request_date',
            'bills_status': 'bills_status',
            'description': 'description',
            'in_treatment': 'in_treatment',
            'matter_id': 'matter_id',
            'medical_bills': 'medical_bills',
            'medical_provider_id': 'medical_provider_id',
            'medical_records': 'medical_records',
            'records_follow_up_date': 'records_follow_up_date',
            'records_request_date': 'records_request_date',
            'records_status': 'records_status',
            'treatment_end_date': 'treatment_end_date',
            'treatment_start_date': 'treatment_start_date'
        }

        self._bills_follow_up_date = bills_follow_up_date
        self._bills_request_date = bills_request_date
        self._bills_status = bills_status
        self._description = description
        self._in_treatment = in_treatment
        self._matter_id = matter_id
        self._medical_bills = medical_bills
        self._medical_provider_id = medical_provider_id
        self._medical_records = medical_records
        self._records_follow_up_date = records_follow_up_date
        self._records_request_date = records_request_date
        self._records_status = records_status
        self._treatment_end_date = treatment_end_date
        self._treatment_start_date = treatment_start_date

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MedicalRecordsRequestCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MedicalRecordsRequest_create_request_data of this MedicalRecordsRequestCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def bills_follow_up_date(self):
        """Gets the bills_follow_up_date of this MedicalRecordsRequestCreateRequestData.

        Follow up date for Medical Bills. (Expects an ISO-8601 date).

        :return: The bills_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._bills_follow_up_date

    @bills_follow_up_date.setter
    def bills_follow_up_date(self, bills_follow_up_date):
        """Sets the bills_follow_up_date of this MedicalRecordsRequestCreateRequestData.

        Follow up date for Medical Bills. (Expects an ISO-8601 date).

        :param bills_follow_up_date: The bills_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :type bills_follow_up_date: datetime
        """

        self._bills_follow_up_date = bills_follow_up_date

    @property
    def bills_request_date(self):
        """Gets the bills_request_date of this MedicalRecordsRequestCreateRequestData.

        Requested date for Medical Bills. (Expects an ISO-8601 date).

        :return: The bills_request_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._bills_request_date

    @bills_request_date.setter
    def bills_request_date(self, bills_request_date):
        """Sets the bills_request_date of this MedicalRecordsRequestCreateRequestData.

        Requested date for Medical Bills. (Expects an ISO-8601 date).

        :param bills_request_date: The bills_request_date of this MedicalRecordsRequestCreateRequestData.
        :type bills_request_date: datetime
        """

        self._bills_request_date = bills_request_date

    @property
    def bills_status(self):
        """Gets the bills_status of this MedicalRecordsRequestCreateRequestData.

        Current status for the Medical Bills.

        :return: The bills_status of this MedicalRecordsRequestCreateRequestData.
        :rtype: str
        """
        return self._bills_status

    @bills_status.setter
    def bills_status(self, bills_status):
        """Sets the bills_status of this MedicalRecordsRequestCreateRequestData.

        Current status for the Medical Bills.

        :param bills_status: The bills_status of this MedicalRecordsRequestCreateRequestData.
        :type bills_status: str
        """
        allowed_values = ["not_yet_requested", "requested", "received", "incomplete", "certified"]  # noqa: E501
        if bills_status not in allowed_values:
            raise ValueError(
                "Invalid value for `bills_status` ({0}), must be one of {1}"
                .format(bills_status, allowed_values)
            )

        self._bills_status = bills_status

    @property
    def description(self):
        """Gets the description of this MedicalRecordsRequestCreateRequestData.

        Detailed description of the Medical Records Detail.

        :return: The description of this MedicalRecordsRequestCreateRequestData.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this MedicalRecordsRequestCreateRequestData.

        Detailed description of the Medical Records Detail.

        :param description: The description of this MedicalRecordsRequestCreateRequestData.
        :type description: str
        """

        self._description = description

    @property
    def in_treatment(self):
        """Gets the in_treatment of this MedicalRecordsRequestCreateRequestData.

        True or false value to record if the treatment has been completed.

        :return: The in_treatment of this MedicalRecordsRequestCreateRequestData.
        :rtype: bool
        """
        return self._in_treatment

    @in_treatment.setter
    def in_treatment(self, in_treatment):
        """Sets the in_treatment of this MedicalRecordsRequestCreateRequestData.

        True or false value to record if the treatment has been completed.

        :param in_treatment: The in_treatment of this MedicalRecordsRequestCreateRequestData.
        :type in_treatment: bool
        """
        if in_treatment is None:
            raise ValueError("Invalid value for `in_treatment`, must not be `None`")

        self._in_treatment = in_treatment

    @property
    def matter_id(self):
        """Gets the matter_id of this MedicalRecordsRequestCreateRequestData.

        The ID of the matter that the Medical Records Detail belongs to.

        :return: The matter_id of this MedicalRecordsRequestCreateRequestData.
        :rtype: int
        """
        return self._matter_id

    @matter_id.setter
    def matter_id(self, matter_id):
        """Sets the matter_id of this MedicalRecordsRequestCreateRequestData.

        The ID of the matter that the Medical Records Detail belongs to.

        :param matter_id: The matter_id of this MedicalRecordsRequestCreateRequestData.
        :type matter_id: int
        """
        if matter_id is None:
            raise ValueError("Invalid value for `matter_id`, must not be `None`")

        self._matter_id = matter_id

    @property
    def medical_bills(self):
        """Gets the medical_bills of this MedicalRecordsRequestCreateRequestData.


        :return: The medical_bills of this MedicalRecordsRequestCreateRequestData.
        :rtype: List[MedicalRecordsRequestCreateRequestDataMedicalBillsInner]
        """
        return self._medical_bills

    @medical_bills.setter
    def medical_bills(self, medical_bills):
        """Sets the medical_bills of this MedicalRecordsRequestCreateRequestData.


        :param medical_bills: The medical_bills of this MedicalRecordsRequestCreateRequestData.
        :type medical_bills: List[MedicalRecordsRequestCreateRequestDataMedicalBillsInner]
        """

        self._medical_bills = medical_bills

    @property
    def medical_provider_id(self):
        """Gets the medical_provider_id of this MedicalRecordsRequestCreateRequestData.

        The unique identifier for a single Medical Provider associated with this Medical Records Detail.

        :return: The medical_provider_id of this MedicalRecordsRequestCreateRequestData.
        :rtype: int
        """
        return self._medical_provider_id

    @medical_provider_id.setter
    def medical_provider_id(self, medical_provider_id):
        """Sets the medical_provider_id of this MedicalRecordsRequestCreateRequestData.

        The unique identifier for a single Medical Provider associated with this Medical Records Detail.

        :param medical_provider_id: The medical_provider_id of this MedicalRecordsRequestCreateRequestData.
        :type medical_provider_id: int
        """
        if medical_provider_id is None:
            raise ValueError("Invalid value for `medical_provider_id`, must not be `None`")

        self._medical_provider_id = medical_provider_id

    @property
    def medical_records(self):
        """Gets the medical_records of this MedicalRecordsRequestCreateRequestData.


        :return: The medical_records of this MedicalRecordsRequestCreateRequestData.
        :rtype: List[MedicalRecordsRequestCreateRequestDataMedicalRecordsInner]
        """
        return self._medical_records

    @medical_records.setter
    def medical_records(self, medical_records):
        """Sets the medical_records of this MedicalRecordsRequestCreateRequestData.


        :param medical_records: The medical_records of this MedicalRecordsRequestCreateRequestData.
        :type medical_records: List[MedicalRecordsRequestCreateRequestDataMedicalRecordsInner]
        """

        self._medical_records = medical_records

    @property
    def records_follow_up_date(self):
        """Gets the records_follow_up_date of this MedicalRecordsRequestCreateRequestData.

        Follow up date for Medical Records. (Expects an ISO-8601 date).

        :return: The records_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._records_follow_up_date

    @records_follow_up_date.setter
    def records_follow_up_date(self, records_follow_up_date):
        """Sets the records_follow_up_date of this MedicalRecordsRequestCreateRequestData.

        Follow up date for Medical Records. (Expects an ISO-8601 date).

        :param records_follow_up_date: The records_follow_up_date of this MedicalRecordsRequestCreateRequestData.
        :type records_follow_up_date: datetime
        """

        self._records_follow_up_date = records_follow_up_date

    @property
    def records_request_date(self):
        """Gets the records_request_date of this MedicalRecordsRequestCreateRequestData.

        Requested date for Medical Records. (Expects an ISO-8601 date).

        :return: The records_request_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._records_request_date

    @records_request_date.setter
    def records_request_date(self, records_request_date):
        """Sets the records_request_date of this MedicalRecordsRequestCreateRequestData.

        Requested date for Medical Records. (Expects an ISO-8601 date).

        :param records_request_date: The records_request_date of this MedicalRecordsRequestCreateRequestData.
        :type records_request_date: datetime
        """

        self._records_request_date = records_request_date

    @property
    def records_status(self):
        """Gets the records_status of this MedicalRecordsRequestCreateRequestData.

        Current status for the Medical Records.

        :return: The records_status of this MedicalRecordsRequestCreateRequestData.
        :rtype: str
        """
        return self._records_status

    @records_status.setter
    def records_status(self, records_status):
        """Sets the records_status of this MedicalRecordsRequestCreateRequestData.

        Current status for the Medical Records.

        :param records_status: The records_status of this MedicalRecordsRequestCreateRequestData.
        :type records_status: str
        """
        allowed_values = ["not_yet_requested", "requested", "received", "incomplete", "certified"]  # noqa: E501
        if records_status not in allowed_values:
            raise ValueError(
                "Invalid value for `records_status` ({0}), must be one of {1}"
                .format(records_status, allowed_values)
            )

        self._records_status = records_status

    @property
    def treatment_end_date(self):
        """Gets the treatment_end_date of this MedicalRecordsRequestCreateRequestData.

        End date for the treatment. (Expects an ISO-8601 date).

        :return: The treatment_end_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._treatment_end_date

    @treatment_end_date.setter
    def treatment_end_date(self, treatment_end_date):
        """Sets the treatment_end_date of this MedicalRecordsRequestCreateRequestData.

        End date for the treatment. (Expects an ISO-8601 date).

        :param treatment_end_date: The treatment_end_date of this MedicalRecordsRequestCreateRequestData.
        :type treatment_end_date: datetime
        """

        self._treatment_end_date = treatment_end_date

    @property
    def treatment_start_date(self):
        """Gets the treatment_start_date of this MedicalRecordsRequestCreateRequestData.

        Start date for the treatment. (Expects an ISO-8601 date).

        :return: The treatment_start_date of this MedicalRecordsRequestCreateRequestData.
        :rtype: datetime
        """
        return self._treatment_start_date

    @treatment_start_date.setter
    def treatment_start_date(self, treatment_start_date):
        """Sets the treatment_start_date of this MedicalRecordsRequestCreateRequestData.

        Start date for the treatment. (Expects an ISO-8601 date).

        :param treatment_start_date: The treatment_start_date of this MedicalRecordsRequestCreateRequestData.
        :type treatment_start_date: datetime
        """

        self._treatment_start_date = treatment_start_date
