# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class MedicalRecordsRequestCreateRequestDataMedicalRecordsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, document_id: int=None, end_date: datetime=None, start_date: datetime=None):
        """MedicalRecordsRequestCreateRequestDataMedicalRecordsInner - a model defined in OpenAPI

        :param document_id: The document_id of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :param end_date: The end_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :param start_date: The start_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        """
        self.openapi_types = {
            'document_id': int,
            'end_date': datetime,
            'start_date': datetime
        }

        self.attribute_map = {
            'document_id': 'document_id',
            'end_date': 'end_date',
            'start_date': 'start_date'
        }

        self._document_id = document_id
        self._end_date = end_date
        self._start_date = start_date

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MedicalRecordsRequestCreateRequestDataMedicalRecordsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MedicalRecordsRequest_create_request_data_medical_records_inner of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def document_id(self):
        """Gets the document_id of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        The unique identifier for a single MedicalRecord associated with the MedicalRecordsRequest. The keyword `null` is not valid for this field.

        :return: The document_id of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :rtype: int
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        The unique identifier for a single MedicalRecord associated with the MedicalRecordsRequest. The keyword `null` is not valid for this field.

        :param document_id: The document_id of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :type document_id: int
        """
        if document_id is None:
            raise ValueError("Invalid value for `document_id`, must not be `None`")

        self._document_id = document_id

    @property
    def end_date(self):
        """Gets the end_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        End date for Medical Record.

        :return: The end_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        End date for Medical Record.

        :param end_date: The end_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :type end_date: datetime
        """

        self._end_date = end_date

    @property
    def start_date(self):
        """Gets the start_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        Start date for Medical Record.

        :return: The start_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.

        Start date for Medical Record.

        :param start_date: The start_date of this MedicalRecordsRequestCreateRequestDataMedicalRecordsInner.
        :type start_date: datetime
        """

        self._start_date = start_date
