# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.medical_records_request_update_request_data_medical_bills_inner_payers_inner import MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner
from openapi_server import util


class MedicalRecordsRequestUpdateRequestDataMedicalBillsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, adjustment: float=None, amount: float=None, balance: float=None, bill_date: date=None, bill_received_date: date=None, document_id: int=None, name: str=None, mark_balance_as_lien: bool=None, payers: List[MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner]=None):
        """MedicalRecordsRequestUpdateRequestDataMedicalBillsInner - a model defined in OpenAPI

        :param adjustment: The adjustment of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param amount: The amount of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param balance: The balance of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param bill_date: The bill_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param bill_received_date: The bill_received_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param document_id: The document_id of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param name: The name of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param mark_balance_as_lien: The mark_balance_as_lien of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :param payers: The payers of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        """
        self.openapi_types = {
            'adjustment': float,
            'amount': float,
            'balance': float,
            'bill_date': date,
            'bill_received_date': date,
            'document_id': int,
            'name': str,
            'mark_balance_as_lien': bool,
            'payers': List[MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner]
        }

        self.attribute_map = {
            'adjustment': 'adjustment',
            'amount': 'amount',
            'balance': 'balance',
            'bill_date': 'bill_date',
            'bill_received_date': 'bill_received_date',
            'document_id': 'document_id',
            'name': 'name',
            'mark_balance_as_lien': 'mark_balance_as_lien',
            'payers': 'payers'
        }

        self._adjustment = adjustment
        self._amount = amount
        self._balance = balance
        self._bill_date = bill_date
        self._bill_received_date = bill_received_date
        self._document_id = document_id
        self._name = name
        self._mark_balance_as_lien = mark_balance_as_lien
        self._payers = payers

    @classmethod
    def from_dict(cls, dikt: dict) -> 'MedicalRecordsRequestUpdateRequestDataMedicalBillsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The MedicalRecordsRequest_update_request_data_medical_bills_inner of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def adjustment(self):
        """Gets the adjustment of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Adjustment for Medical Bill.

        :return: The adjustment of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: float
        """
        return self._adjustment

    @adjustment.setter
    def adjustment(self, adjustment):
        """Sets the adjustment of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Adjustment for Medical Bill.

        :param adjustment: The adjustment of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type adjustment: float
        """

        self._adjustment = adjustment

    @property
    def amount(self):
        """Gets the amount of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Amount for Medical Bill.

        :return: The amount of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Amount for Medical Bill.

        :param amount: The amount of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type amount: float
        """

        self._amount = amount

    @property
    def balance(self):
        """Gets the balance of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Balance for Medical Bill.

        :return: The balance of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: float
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Balance for Medical Bill.

        :param balance: The balance of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type balance: float
        """

        self._balance = balance

    @property
    def bill_date(self):
        """Gets the bill_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Bill date for Medical Bill. (Expects an ISO-8601 date).

        :return: The bill_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: date
        """
        return self._bill_date

    @bill_date.setter
    def bill_date(self, bill_date):
        """Sets the bill_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Bill date for Medical Bill. (Expects an ISO-8601 date).

        :param bill_date: The bill_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type bill_date: date
        """

        self._bill_date = bill_date

    @property
    def bill_received_date(self):
        """Gets the bill_received_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Bill received date for Medical Bill. (Expects an ISO-8601 date).

        :return: The bill_received_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: date
        """
        return self._bill_received_date

    @bill_received_date.setter
    def bill_received_date(self, bill_received_date):
        """Sets the bill_received_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Bill received date for Medical Bill. (Expects an ISO-8601 date).

        :param bill_received_date: The bill_received_date of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type bill_received_date: date
        """

        self._bill_received_date = bill_received_date

    @property
    def document_id(self):
        """Gets the document_id of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        The unique identifier for a single Damage associated with the MedicalRecordsRequest. The keyword `null` is not valid for this field.

        :return: The document_id of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: int
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        The unique identifier for a single Damage associated with the MedicalRecordsRequest. The keyword `null` is not valid for this field.

        :param document_id: The document_id of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type document_id: int
        """

        self._document_id = document_id

    @property
    def name(self):
        """Gets the name of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Name for Medical Bill.

        :return: The name of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Name for Medical Bill.

        :param name: The name of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type name: str
        """

        self._name = name

    @property
    def mark_balance_as_lien(self):
        """Gets the mark_balance_as_lien of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Setting the balance of the Medical Bill as a lien.

        :return: The mark_balance_as_lien of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: bool
        """
        return self._mark_balance_as_lien

    @mark_balance_as_lien.setter
    def mark_balance_as_lien(self, mark_balance_as_lien):
        """Sets the mark_balance_as_lien of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.

        Setting the balance of the Medical Bill as a lien.

        :param mark_balance_as_lien: The mark_balance_as_lien of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type mark_balance_as_lien: bool
        """

        self._mark_balance_as_lien = mark_balance_as_lien

    @property
    def payers(self):
        """Gets the payers of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.


        :return: The payers of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :rtype: List[MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner]
        """
        return self._payers

    @payers.setter
    def payers(self, payers):
        """Sets the payers of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.


        :param payers: The payers of this MedicalRecordsRequestUpdateRequestDataMedicalBillsInner.
        :type payers: List[MedicalRecordsRequestUpdateRequestDataMedicalBillsInnerPayersInner]
        """

        self._payers = payers
