# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.multipart_header_base import MultipartHeaderBase
from openapi_server import util


class Multipart(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, part_number: int=None, put_url: str=None, put_headers: List[MultipartHeaderBase]=None):
        """Multipart - a model defined in OpenAPI

        :param part_number: The part_number of this Multipart.
        :param put_url: The put_url of this Multipart.
        :param put_headers: The put_headers of this Multipart.
        """
        self.openapi_types = {
            'part_number': int,
            'put_url': str,
            'put_headers': List[MultipartHeaderBase]
        }

        self.attribute_map = {
            'part_number': 'part_number',
            'put_url': 'put_url',
            'put_headers': 'put_headers'
        }

        self._part_number = part_number
        self._put_url = put_url
        self._put_headers = put_headers

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Multipart':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Multipart of this Multipart.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def part_number(self):
        """Gets the part_number of this Multipart.

        Unique identifier of a part which defines its position within the document being uploaded.

        :return: The part_number of this Multipart.
        :rtype: int
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this Multipart.

        Unique identifier of a part which defines its position within the document being uploaded.

        :param part_number: The part_number of this Multipart.
        :type part_number: int
        """

        self._part_number = part_number

    @property
    def put_url(self):
        """Gets the put_url of this Multipart.

        A signed URL for uploading the file part. It expires in 10 minutes.

        :return: The put_url of this Multipart.
        :rtype: str
        """
        return self._put_url

    @put_url.setter
    def put_url(self, put_url):
        """Sets the put_url of this Multipart.

        A signed URL for uploading the file part. It expires in 10 minutes.

        :param put_url: The put_url of this Multipart.
        :type put_url: str
        """

        self._put_url = put_url

    @property
    def put_headers(self):
        """Gets the put_headers of this Multipart.

        MultipartHeader

        :return: The put_headers of this Multipart.
        :rtype: List[MultipartHeaderBase]
        """
        return self._put_headers

    @put_headers.setter
    def put_headers(self, put_headers):
        """Sets the put_headers of this Multipart.

        MultipartHeader

        :param put_headers: The put_headers of this Multipart.
        :type put_headers: List[MultipartHeaderBase]
        """

        self._put_headers = put_headers
