# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.activity_base import ActivityBase
from openapi_server.models.contact_base import ContactBase
from openapi_server.models.matter_base import MatterBase
from openapi_server.models.notification_event_subscriber_base import NotificationEventSubscriberBase
from openapi_server.models.user_base import UserBase
from openapi_server import util


class Note(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, type: str=None, subject: str=None, detail: str=None, _date: date=None, created_at: datetime=None, updated_at: datetime=None, time_entries_count: int=None, matter: MatterBase=None, contact: ContactBase=None, author: UserBase=None, time_entries: List[ActivityBase]=None, notification_event_subscribers: List[NotificationEventSubscriberBase]=None):
        """Note - a model defined in OpenAPI

        :param id: The id of this Note.
        :param etag: The etag of this Note.
        :param type: The type of this Note.
        :param subject: The subject of this Note.
        :param detail: The detail of this Note.
        :param _date: The _date of this Note.
        :param created_at: The created_at of this Note.
        :param updated_at: The updated_at of this Note.
        :param time_entries_count: The time_entries_count of this Note.
        :param matter: The matter of this Note.
        :param contact: The contact of this Note.
        :param author: The author of this Note.
        :param time_entries: The time_entries of this Note.
        :param notification_event_subscribers: The notification_event_subscribers of this Note.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'type': str,
            'subject': str,
            'detail': str,
            '_date': date,
            'created_at': datetime,
            'updated_at': datetime,
            'time_entries_count': int,
            'matter': MatterBase,
            'contact': ContactBase,
            'author': UserBase,
            'time_entries': List[ActivityBase],
            'notification_event_subscribers': List[NotificationEventSubscriberBase]
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'type': 'type',
            'subject': 'subject',
            'detail': 'detail',
            '_date': 'date',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'time_entries_count': 'time_entries_count',
            'matter': 'matter',
            'contact': 'contact',
            'author': 'author',
            'time_entries': 'time_entries',
            'notification_event_subscribers': 'notification_event_subscribers'
        }

        self._id = id
        self._etag = etag
        self._type = type
        self._subject = subject
        self._detail = detail
        self.__date = _date
        self._created_at = created_at
        self._updated_at = updated_at
        self._time_entries_count = time_entries_count
        self._matter = matter
        self._contact = contact
        self._author = author
        self._time_entries = time_entries
        self._notification_event_subscribers = notification_event_subscribers

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Note':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Note of this Note.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Note.

        Unique identifier for the *Note*

        :return: The id of this Note.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Note.

        Unique identifier for the *Note*

        :param id: The id of this Note.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Note.

        ETag for the *Note*

        :return: The etag of this Note.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Note.

        ETag for the *Note*

        :param etag: The etag of this Note.
        :type etag: str
        """

        self._etag = etag

    @property
    def type(self):
        """Gets the type of this Note.

        The type of the *Note*

        :return: The type of this Note.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Note.

        The type of the *Note*

        :param type: The type of this Note.
        :type type: str
        """
        allowed_values = ["Matter", "Contact"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def subject(self):
        """Gets the subject of this Note.

        The subject of the *Note*

        :return: The subject of this Note.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this Note.

        The subject of the *Note*

        :param subject: The subject of this Note.
        :type subject: str
        """

        self._subject = subject

    @property
    def detail(self):
        """Gets the detail of this Note.

        The body of the *Note*

        :return: The detail of this Note.
        :rtype: str
        """
        return self._detail

    @detail.setter
    def detail(self, detail):
        """Sets the detail of this Note.

        The body of the *Note*

        :param detail: The detail of this Note.
        :type detail: str
        """

        self._detail = detail

    @property
    def _date(self):
        """Gets the _date of this Note.

        The date the *Note* is for (as a ISO-8601 date)

        :return: The _date of this Note.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this Note.

        The date the *Note* is for (as a ISO-8601 date)

        :param _date: The _date of this Note.
        :type _date: date
        """

        self.__date = _date

    @property
    def created_at(self):
        """Gets the created_at of this Note.

        The time the *Note* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Note.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Note.

        The time the *Note* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Note.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Note.

        The time the *Note* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Note.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Note.

        The time the *Note* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Note.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def time_entries_count(self):
        """Gets the time_entries_count of this Note.

        The number of time_entries associated with the *Note*

        :return: The time_entries_count of this Note.
        :rtype: int
        """
        return self._time_entries_count

    @time_entries_count.setter
    def time_entries_count(self, time_entries_count):
        """Sets the time_entries_count of this Note.

        The number of time_entries associated with the *Note*

        :param time_entries_count: The time_entries_count of this Note.
        :type time_entries_count: int
        """

        self._time_entries_count = time_entries_count

    @property
    def matter(self):
        """Gets the matter of this Note.


        :return: The matter of this Note.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this Note.


        :param matter: The matter of this Note.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def contact(self):
        """Gets the contact of this Note.


        :return: The contact of this Note.
        :rtype: ContactBase
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this Note.


        :param contact: The contact of this Note.
        :type contact: ContactBase
        """

        self._contact = contact

    @property
    def author(self):
        """Gets the author of this Note.


        :return: The author of this Note.
        :rtype: UserBase
        """
        return self._author

    @author.setter
    def author(self, author):
        """Sets the author of this Note.


        :param author: The author of this Note.
        :type author: UserBase
        """

        self._author = author

    @property
    def time_entries(self):
        """Gets the time_entries of this Note.

        Activity

        :return: The time_entries of this Note.
        :rtype: List[ActivityBase]
        """
        return self._time_entries

    @time_entries.setter
    def time_entries(self, time_entries):
        """Sets the time_entries of this Note.

        Activity

        :param time_entries: The time_entries of this Note.
        :type time_entries: List[ActivityBase]
        """

        self._time_entries = time_entries

    @property
    def notification_event_subscribers(self):
        """Gets the notification_event_subscribers of this Note.

        NotificationEventSubscriber

        :return: The notification_event_subscribers of this Note.
        :rtype: List[NotificationEventSubscriberBase]
        """
        return self._notification_event_subscribers

    @notification_event_subscribers.setter
    def notification_event_subscribers(self, notification_event_subscribers):
        """Sets the notification_event_subscribers of this Note.

        NotificationEventSubscriber

        :param notification_event_subscribers: The notification_event_subscribers of this Note.
        :type notification_event_subscribers: List[NotificationEventSubscriberBase]
        """

        self._notification_event_subscribers = notification_event_subscribers
