# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.note_create_request_data_contact import NoteCreateRequestDataContact
from openapi_server.models.note_create_request_data_matter import NoteCreateRequestDataMatter
from openapi_server.models.note_create_request_data_notification_event_subscribers_inner import NoteCreateRequestDataNotificationEventSubscribersInner
from openapi_server import util


class NoteCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, contact: NoteCreateRequestDataContact=None, _date: date=None, detail: str=None, matter: NoteCreateRequestDataMatter=None, notification_event_subscribers: List[NoteCreateRequestDataNotificationEventSubscribersInner]=None, subject: str=None, type: str=None):
        """NoteCreateRequestData - a model defined in OpenAPI

        :param contact: The contact of this NoteCreateRequestData.
        :param _date: The _date of this NoteCreateRequestData.
        :param detail: The detail of this NoteCreateRequestData.
        :param matter: The matter of this NoteCreateRequestData.
        :param notification_event_subscribers: The notification_event_subscribers of this NoteCreateRequestData.
        :param subject: The subject of this NoteCreateRequestData.
        :param type: The type of this NoteCreateRequestData.
        """
        self.openapi_types = {
            'contact': NoteCreateRequestDataContact,
            '_date': date,
            'detail': str,
            'matter': NoteCreateRequestDataMatter,
            'notification_event_subscribers': List[NoteCreateRequestDataNotificationEventSubscribersInner],
            'subject': str,
            'type': str
        }

        self.attribute_map = {
            'contact': 'contact',
            '_date': 'date',
            'detail': 'detail',
            'matter': 'matter',
            'notification_event_subscribers': 'notification_event_subscribers',
            'subject': 'subject',
            'type': 'type'
        }

        self._contact = contact
        self.__date = _date
        self._detail = detail
        self._matter = matter
        self._notification_event_subscribers = notification_event_subscribers
        self._subject = subject
        self._type = type

    @classmethod
    def from_dict(cls, dikt: dict) -> 'NoteCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Note_create_request_data of this NoteCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def contact(self):
        """Gets the contact of this NoteCreateRequestData.


        :return: The contact of this NoteCreateRequestData.
        :rtype: NoteCreateRequestDataContact
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this NoteCreateRequestData.


        :param contact: The contact of this NoteCreateRequestData.
        :type contact: NoteCreateRequestDataContact
        """
        if contact is None:
            raise ValueError("Invalid value for `contact`, must not be `None`")

        self._contact = contact

    @property
    def _date(self):
        """Gets the _date of this NoteCreateRequestData.

        Date for the Note. (Expects an ISO-8601 date).

        :return: The _date of this NoteCreateRequestData.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this NoteCreateRequestData.

        Date for the Note. (Expects an ISO-8601 date).

        :param _date: The _date of this NoteCreateRequestData.
        :type _date: date
        """

        self.__date = _date

    @property
    def detail(self):
        """Gets the detail of this NoteCreateRequestData.

        Note body.

        :return: The detail of this NoteCreateRequestData.
        :rtype: str
        """
        return self._detail

    @detail.setter
    def detail(self, detail):
        """Sets the detail of this NoteCreateRequestData.

        Note body.

        :param detail: The detail of this NoteCreateRequestData.
        :type detail: str
        """

        self._detail = detail

    @property
    def matter(self):
        """Gets the matter of this NoteCreateRequestData.


        :return: The matter of this NoteCreateRequestData.
        :rtype: NoteCreateRequestDataMatter
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this NoteCreateRequestData.


        :param matter: The matter of this NoteCreateRequestData.
        :type matter: NoteCreateRequestDataMatter
        """
        if matter is None:
            raise ValueError("Invalid value for `matter`, must not be `None`")

        self._matter = matter

    @property
    def notification_event_subscribers(self):
        """Gets the notification_event_subscribers of this NoteCreateRequestData.


        :return: The notification_event_subscribers of this NoteCreateRequestData.
        :rtype: List[NoteCreateRequestDataNotificationEventSubscribersInner]
        """
        return self._notification_event_subscribers

    @notification_event_subscribers.setter
    def notification_event_subscribers(self, notification_event_subscribers):
        """Sets the notification_event_subscribers of this NoteCreateRequestData.


        :param notification_event_subscribers: The notification_event_subscribers of this NoteCreateRequestData.
        :type notification_event_subscribers: List[NoteCreateRequestDataNotificationEventSubscribersInner]
        """

        self._notification_event_subscribers = notification_event_subscribers

    @property
    def subject(self):
        """Gets the subject of this NoteCreateRequestData.

        Note subject.

        :return: The subject of this NoteCreateRequestData.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this NoteCreateRequestData.

        Note subject.

        :param subject: The subject of this NoteCreateRequestData.
        :type subject: str
        """

        self._subject = subject

    @property
    def type(self):
        """Gets the type of this NoteCreateRequestData.

        Note type.

        :return: The type of this NoteCreateRequestData.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this NoteCreateRequestData.

        Note type.

        :param type: The type of this NoteCreateRequestData.
        :type type: str
        """
        allowed_values = ["Matter", "Contact"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type
