# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class NotificationEventSubscriberBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, user_id: int=None, name: str=None, created_at: datetime=None, updated_at: datetime=None):
        """NotificationEventSubscriberBase - a model defined in OpenAPI

        :param id: The id of this NotificationEventSubscriberBase.
        :param etag: The etag of this NotificationEventSubscriberBase.
        :param user_id: The user_id of this NotificationEventSubscriberBase.
        :param name: The name of this NotificationEventSubscriberBase.
        :param created_at: The created_at of this NotificationEventSubscriberBase.
        :param updated_at: The updated_at of this NotificationEventSubscriberBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'user_id': int,
            'name': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'user_id': 'user_id',
            'name': 'name',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._user_id = user_id
        self._name = name
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'NotificationEventSubscriberBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The NotificationEventSubscriber_base of this NotificationEventSubscriberBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this NotificationEventSubscriberBase.

        Unique identifier for the *NotificationEventSubscriber*

        :return: The id of this NotificationEventSubscriberBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NotificationEventSubscriberBase.

        Unique identifier for the *NotificationEventSubscriber*

        :param id: The id of this NotificationEventSubscriberBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this NotificationEventSubscriberBase.

        ETag for the *NotificationEventSubscriber*

        :return: The etag of this NotificationEventSubscriberBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this NotificationEventSubscriberBase.

        ETag for the *NotificationEventSubscriber*

        :param etag: The etag of this NotificationEventSubscriberBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def user_id(self):
        """Gets the user_id of this NotificationEventSubscriberBase.

        The unique identifier for a User added as a notification event subscriber to the NotificationEventSubscriber

        :return: The user_id of this NotificationEventSubscriberBase.
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this NotificationEventSubscriberBase.

        The unique identifier for a User added as a notification event subscriber to the NotificationEventSubscriber

        :param user_id: The user_id of this NotificationEventSubscriberBase.
        :type user_id: int
        """

        self._user_id = user_id

    @property
    def name(self):
        """Gets the name of this NotificationEventSubscriberBase.

        The User name added as a notification event subscriber to the NotificationEventSubscriber

        :return: The name of this NotificationEventSubscriberBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NotificationEventSubscriberBase.

        The User name added as a notification event subscriber to the NotificationEventSubscriber

        :param name: The name of this NotificationEventSubscriberBase.
        :type name: str
        """

        self._name = name

    @property
    def created_at(self):
        """Gets the created_at of this NotificationEventSubscriberBase.

        The time the *NotificationEventSubscriber* was created (as a ISO-8601 timestamp)

        :return: The created_at of this NotificationEventSubscriberBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this NotificationEventSubscriberBase.

        The time the *NotificationEventSubscriber* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this NotificationEventSubscriberBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this NotificationEventSubscriberBase.

        The time the *NotificationEventSubscriber* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this NotificationEventSubscriberBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this NotificationEventSubscriberBase.

        The time the *NotificationEventSubscriber* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this NotificationEventSubscriberBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
