# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class NotificationMethodBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, type: str=None, email_address: str=None, is_default_email_address: bool=None, created_at: datetime=None, updated_at: datetime=None):
        """NotificationMethodBase - a model defined in OpenAPI

        :param id: The id of this NotificationMethodBase.
        :param etag: The etag of this NotificationMethodBase.
        :param type: The type of this NotificationMethodBase.
        :param email_address: The email_address of this NotificationMethodBase.
        :param is_default_email_address: The is_default_email_address of this NotificationMethodBase.
        :param created_at: The created_at of this NotificationMethodBase.
        :param updated_at: The updated_at of this NotificationMethodBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'type': str,
            'email_address': str,
            'is_default_email_address': bool,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'type': 'type',
            'email_address': 'email_address',
            'is_default_email_address': 'is_default_email_address',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._type = type
        self._email_address = email_address
        self._is_default_email_address = is_default_email_address
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'NotificationMethodBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The NotificationMethod_base of this NotificationMethodBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this NotificationMethodBase.

        Unique identifier for the *NotificationMethod*

        :return: The id of this NotificationMethodBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NotificationMethodBase.

        Unique identifier for the *NotificationMethod*

        :param id: The id of this NotificationMethodBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this NotificationMethodBase.

        ETag for the *NotificationMethod*

        :return: The etag of this NotificationMethodBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this NotificationMethodBase.

        ETag for the *NotificationMethod*

        :param etag: The etag of this NotificationMethodBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def type(self):
        """Gets the type of this NotificationMethodBase.

        Human readable description of the type of notification

        :return: The type of this NotificationMethodBase.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this NotificationMethodBase.

        Human readable description of the type of notification

        :param type: The type of this NotificationMethodBase.
        :type type: str
        """
        allowed_values = ["Email", "Popup", "SMS"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def email_address(self):
        """Gets the email_address of this NotificationMethodBase.

        Email address to send the notification to (only for email type)

        :return: The email_address of this NotificationMethodBase.
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """Sets the email_address of this NotificationMethodBase.

        Email address to send the notification to (only for email type)

        :param email_address: The email_address of this NotificationMethodBase.
        :type email_address: str
        """

        self._email_address = email_address

    @property
    def is_default_email_address(self):
        """Gets the is_default_email_address of this NotificationMethodBase.

        A boolean that is returned only on notification method objects that are relevant e.g. Email notification or Alternative Email

        :return: The is_default_email_address of this NotificationMethodBase.
        :rtype: bool
        """
        return self._is_default_email_address

    @is_default_email_address.setter
    def is_default_email_address(self, is_default_email_address):
        """Sets the is_default_email_address of this NotificationMethodBase.

        A boolean that is returned only on notification method objects that are relevant e.g. Email notification or Alternative Email

        :param is_default_email_address: The is_default_email_address of this NotificationMethodBase.
        :type is_default_email_address: bool
        """

        self._is_default_email_address = is_default_email_address

    @property
    def created_at(self):
        """Gets the created_at of this NotificationMethodBase.

        The time the *NotificationMethod* was created (as a ISO-8601 timestamp)

        :return: The created_at of this NotificationMethodBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this NotificationMethodBase.

        The time the *NotificationMethod* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this NotificationMethodBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this NotificationMethodBase.

        The time the *NotificationMethod* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this NotificationMethodBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this NotificationMethodBase.

        The time the *NotificationMethod* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this NotificationMethodBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
