# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class OutstandingClientBalanceBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, associated_matter_ids: List[int]=None, etag: str=None, id: int=None, last_payment_date: date=None, last_shared_date: date=None, newest_issued_bill_due_date: date=None, pending_payments_total: float=None, reminders_enabled: bool=None, total_outstanding_balance: float=None, created_at: datetime=None, updated_at: datetime=None):
        """OutstandingClientBalanceBase - a model defined in OpenAPI

        :param associated_matter_ids: The associated_matter_ids of this OutstandingClientBalanceBase.
        :param etag: The etag of this OutstandingClientBalanceBase.
        :param id: The id of this OutstandingClientBalanceBase.
        :param last_payment_date: The last_payment_date of this OutstandingClientBalanceBase.
        :param last_shared_date: The last_shared_date of this OutstandingClientBalanceBase.
        :param newest_issued_bill_due_date: The newest_issued_bill_due_date of this OutstandingClientBalanceBase.
        :param pending_payments_total: The pending_payments_total of this OutstandingClientBalanceBase.
        :param reminders_enabled: The reminders_enabled of this OutstandingClientBalanceBase.
        :param total_outstanding_balance: The total_outstanding_balance of this OutstandingClientBalanceBase.
        :param created_at: The created_at of this OutstandingClientBalanceBase.
        :param updated_at: The updated_at of this OutstandingClientBalanceBase.
        """
        self.openapi_types = {
            'associated_matter_ids': List[int],
            'etag': str,
            'id': int,
            'last_payment_date': date,
            'last_shared_date': date,
            'newest_issued_bill_due_date': date,
            'pending_payments_total': float,
            'reminders_enabled': bool,
            'total_outstanding_balance': float,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'associated_matter_ids': 'associated_matter_ids',
            'etag': 'etag',
            'id': 'id',
            'last_payment_date': 'last_payment_date',
            'last_shared_date': 'last_shared_date',
            'newest_issued_bill_due_date': 'newest_issued_bill_due_date',
            'pending_payments_total': 'pending_payments_total',
            'reminders_enabled': 'reminders_enabled',
            'total_outstanding_balance': 'total_outstanding_balance',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._associated_matter_ids = associated_matter_ids
        self._etag = etag
        self._id = id
        self._last_payment_date = last_payment_date
        self._last_shared_date = last_shared_date
        self._newest_issued_bill_due_date = newest_issued_bill_due_date
        self._pending_payments_total = pending_payments_total
        self._reminders_enabled = reminders_enabled
        self._total_outstanding_balance = total_outstanding_balance
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'OutstandingClientBalanceBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The OutstandingClientBalance_base of this OutstandingClientBalanceBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def associated_matter_ids(self):
        """Gets the associated_matter_ids of this OutstandingClientBalanceBase.

        An array of Matter IDs associated with bills in the unpaid state

        :return: The associated_matter_ids of this OutstandingClientBalanceBase.
        :rtype: List[int]
        """
        return self._associated_matter_ids

    @associated_matter_ids.setter
    def associated_matter_ids(self, associated_matter_ids):
        """Sets the associated_matter_ids of this OutstandingClientBalanceBase.

        An array of Matter IDs associated with bills in the unpaid state

        :param associated_matter_ids: The associated_matter_ids of this OutstandingClientBalanceBase.
        :type associated_matter_ids: List[int]
        """

        self._associated_matter_ids = associated_matter_ids

    @property
    def etag(self):
        """Gets the etag of this OutstandingClientBalanceBase.

        ETag for the *OutstandingClientBalance*

        :return: The etag of this OutstandingClientBalanceBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this OutstandingClientBalanceBase.

        ETag for the *OutstandingClientBalance*

        :param etag: The etag of this OutstandingClientBalanceBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def id(self):
        """Gets the id of this OutstandingClientBalanceBase.

        Unique identifier for the *OutstandingClientBalance*

        :return: The id of this OutstandingClientBalanceBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OutstandingClientBalanceBase.

        Unique identifier for the *OutstandingClientBalance*

        :param id: The id of this OutstandingClientBalanceBase.
        :type id: int
        """

        self._id = id

    @property
    def last_payment_date(self):
        """Gets the last_payment_date of this OutstandingClientBalanceBase.

        The date the most recent payment from the contact was received

        :return: The last_payment_date of this OutstandingClientBalanceBase.
        :rtype: date
        """
        return self._last_payment_date

    @last_payment_date.setter
    def last_payment_date(self, last_payment_date):
        """Sets the last_payment_date of this OutstandingClientBalanceBase.

        The date the most recent payment from the contact was received

        :param last_payment_date: The last_payment_date of this OutstandingClientBalanceBase.
        :type last_payment_date: date
        """

        self._last_payment_date = last_payment_date

    @property
    def last_shared_date(self):
        """Gets the last_shared_date of this OutstandingClientBalanceBase.

        The date of the most recently shared bills through the outstanding balance table

        :return: The last_shared_date of this OutstandingClientBalanceBase.
        :rtype: date
        """
        return self._last_shared_date

    @last_shared_date.setter
    def last_shared_date(self, last_shared_date):
        """Sets the last_shared_date of this OutstandingClientBalanceBase.

        The date of the most recently shared bills through the outstanding balance table

        :param last_shared_date: The last_shared_date of this OutstandingClientBalanceBase.
        :type last_shared_date: date
        """

        self._last_shared_date = last_shared_date

    @property
    def newest_issued_bill_due_date(self):
        """Gets the newest_issued_bill_due_date of this OutstandingClientBalanceBase.

        The due date of the contact's newest bill

        :return: The newest_issued_bill_due_date of this OutstandingClientBalanceBase.
        :rtype: date
        """
        return self._newest_issued_bill_due_date

    @newest_issued_bill_due_date.setter
    def newest_issued_bill_due_date(self, newest_issued_bill_due_date):
        """Sets the newest_issued_bill_due_date of this OutstandingClientBalanceBase.

        The due date of the contact's newest bill

        :param newest_issued_bill_due_date: The newest_issued_bill_due_date of this OutstandingClientBalanceBase.
        :type newest_issued_bill_due_date: date
        """

        self._newest_issued_bill_due_date = newest_issued_bill_due_date

    @property
    def pending_payments_total(self):
        """Gets the pending_payments_total of this OutstandingClientBalanceBase.

        The sum of all online payments in a pending state on the outstanding bills

        :return: The pending_payments_total of this OutstandingClientBalanceBase.
        :rtype: float
        """
        return self._pending_payments_total

    @pending_payments_total.setter
    def pending_payments_total(self, pending_payments_total):
        """Sets the pending_payments_total of this OutstandingClientBalanceBase.

        The sum of all online payments in a pending state on the outstanding bills

        :param pending_payments_total: The pending_payments_total of this OutstandingClientBalanceBase.
        :type pending_payments_total: float
        """

        self._pending_payments_total = pending_payments_total

    @property
    def reminders_enabled(self):
        """Gets the reminders_enabled of this OutstandingClientBalanceBase.

        The status of automated reminders for this client

        :return: The reminders_enabled of this OutstandingClientBalanceBase.
        :rtype: bool
        """
        return self._reminders_enabled

    @reminders_enabled.setter
    def reminders_enabled(self, reminders_enabled):
        """Sets the reminders_enabled of this OutstandingClientBalanceBase.

        The status of automated reminders for this client

        :param reminders_enabled: The reminders_enabled of this OutstandingClientBalanceBase.
        :type reminders_enabled: bool
        """

        self._reminders_enabled = reminders_enabled

    @property
    def total_outstanding_balance(self):
        """Gets the total_outstanding_balance of this OutstandingClientBalanceBase.

        The sum of all bills in the unpaid state

        :return: The total_outstanding_balance of this OutstandingClientBalanceBase.
        :rtype: float
        """
        return self._total_outstanding_balance

    @total_outstanding_balance.setter
    def total_outstanding_balance(self, total_outstanding_balance):
        """Sets the total_outstanding_balance of this OutstandingClientBalanceBase.

        The sum of all bills in the unpaid state

        :param total_outstanding_balance: The total_outstanding_balance of this OutstandingClientBalanceBase.
        :type total_outstanding_balance: float
        """

        self._total_outstanding_balance = total_outstanding_balance

    @property
    def created_at(self):
        """Gets the created_at of this OutstandingClientBalanceBase.

        The time the *OutstandingClientBalance* was created (as a ISO-8601 timestamp)

        :return: The created_at of this OutstandingClientBalanceBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this OutstandingClientBalanceBase.

        The time the *OutstandingClientBalance* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this OutstandingClientBalanceBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this OutstandingClientBalanceBase.

        The time the *OutstandingClientBalance* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this OutstandingClientBalanceBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this OutstandingClientBalanceBase.

        The time the *OutstandingClientBalance* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this OutstandingClientBalanceBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
