# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class PaymentBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, description: str=None, reference: str=None, amount: float=None, _date: date=None, source_fund_type: str=None, voided_at: datetime=None, created_at: datetime=None, updated_at: datetime=None):
        """PaymentBase - a model defined in OpenAPI

        :param id: The id of this PaymentBase.
        :param etag: The etag of this PaymentBase.
        :param description: The description of this PaymentBase.
        :param reference: The reference of this PaymentBase.
        :param amount: The amount of this PaymentBase.
        :param _date: The _date of this PaymentBase.
        :param source_fund_type: The source_fund_type of this PaymentBase.
        :param voided_at: The voided_at of this PaymentBase.
        :param created_at: The created_at of this PaymentBase.
        :param updated_at: The updated_at of this PaymentBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'description': str,
            'reference': str,
            'amount': float,
            '_date': date,
            'source_fund_type': str,
            'voided_at': datetime,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'description': 'description',
            'reference': 'reference',
            'amount': 'amount',
            '_date': 'date',
            'source_fund_type': 'source_fund_type',
            'voided_at': 'voided_at',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._description = description
        self._reference = reference
        self._amount = amount
        self.__date = _date
        self._source_fund_type = source_fund_type
        self._voided_at = voided_at
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'PaymentBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Payment_base of this PaymentBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this PaymentBase.

        Unique identifier for the *Payment*

        :return: The id of this PaymentBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentBase.

        Unique identifier for the *Payment*

        :param id: The id of this PaymentBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this PaymentBase.

        ETag for the *Payment*

        :return: The etag of this PaymentBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this PaymentBase.

        ETag for the *Payment*

        :param etag: The etag of this PaymentBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def description(self):
        """Gets the description of this PaymentBase.

        A detailed description of the *Payment*

        :return: The description of this PaymentBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PaymentBase.

        A detailed description of the *Payment*

        :param description: The description of this PaymentBase.
        :type description: str
        """

        self._description = description

    @property
    def reference(self):
        """Gets the reference of this PaymentBase.

        A reference for the payment

        :return: The reference of this PaymentBase.
        :rtype: str
        """
        return self._reference

    @reference.setter
    def reference(self, reference):
        """Sets the reference of this PaymentBase.

        A reference for the payment

        :param reference: The reference of this PaymentBase.
        :type reference: str
        """

        self._reference = reference

    @property
    def amount(self):
        """Gets the amount of this PaymentBase.

        Total amount paid. The default is 0.00.

        :return: The amount of this PaymentBase.
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this PaymentBase.

        Total amount paid. The default is 0.00.

        :param amount: The amount of this PaymentBase.
        :type amount: float
        """

        self._amount = amount

    @property
    def _date(self):
        """Gets the _date of this PaymentBase.

        The date the *Payment* was recorded (as a ISO-8601 date)

        :return: The _date of this PaymentBase.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this PaymentBase.

        The date the *Payment* was recorded (as a ISO-8601 date)

        :param _date: The _date of this PaymentBase.
        :type _date: date
        """

        self.__date = _date

    @property
    def source_fund_type(self):
        """Gets the source_fund_type of this PaymentBase.

        The fund type for *Payment* source

        :return: The source_fund_type of this PaymentBase.
        :rtype: str
        """
        return self._source_fund_type

    @source_fund_type.setter
    def source_fund_type(self, source_fund_type):
        """Sets the source_fund_type of this PaymentBase.

        The fund type for *Payment* source

        :param source_fund_type: The source_fund_type of this PaymentBase.
        :type source_fund_type: str
        """
        allowed_values = ["Client", "Matter"]  # noqa: E501
        if source_fund_type not in allowed_values:
            raise ValueError(
                "Invalid value for `source_fund_type` ({0}), must be one of {1}"
                .format(source_fund_type, allowed_values)
            )

        self._source_fund_type = source_fund_type

    @property
    def voided_at(self):
        """Gets the voided_at of this PaymentBase.

        Time the *Payment* was voided (as a ISO-8601 timestamp)

        :return: The voided_at of this PaymentBase.
        :rtype: datetime
        """
        return self._voided_at

    @voided_at.setter
    def voided_at(self, voided_at):
        """Sets the voided_at of this PaymentBase.

        Time the *Payment* was voided (as a ISO-8601 timestamp)

        :param voided_at: The voided_at of this PaymentBase.
        :type voided_at: datetime
        """

        self._voided_at = voided_at

    @property
    def created_at(self):
        """Gets the created_at of this PaymentBase.

        The time the *Payment* was created (as a ISO-8601 timestamp)

        :return: The created_at of this PaymentBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PaymentBase.

        The time the *Payment* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this PaymentBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this PaymentBase.

        The time the *Payment* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this PaymentBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this PaymentBase.

        The time the *Payment* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this PaymentBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
