# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.polymorphic_custom_rate_activity_description_base import PolymorphicCustomRateActivityDescriptionBase
from openapi_server.models.polymorphic_custom_rate_group_base import PolymorphicCustomRateGroupBase
from openapi_server.models.polymorphic_custom_rate_user_base import PolymorphicCustomRateUserBase
from openapi_server import util


class PolymorphicCustomRate(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, rate: float=None, award: float=None, note: str=None, _date: date=None, user: PolymorphicCustomRateUserBase=None, group: PolymorphicCustomRateGroupBase=None, activity_description: PolymorphicCustomRateActivityDescriptionBase=None):
        """PolymorphicCustomRate - a model defined in OpenAPI

        :param id: The id of this PolymorphicCustomRate.
        :param etag: The etag of this PolymorphicCustomRate.
        :param created_at: The created_at of this PolymorphicCustomRate.
        :param updated_at: The updated_at of this PolymorphicCustomRate.
        :param rate: The rate of this PolymorphicCustomRate.
        :param award: The award of this PolymorphicCustomRate.
        :param note: The note of this PolymorphicCustomRate.
        :param _date: The _date of this PolymorphicCustomRate.
        :param user: The user of this PolymorphicCustomRate.
        :param group: The group of this PolymorphicCustomRate.
        :param activity_description: The activity_description of this PolymorphicCustomRate.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'rate': float,
            'award': float,
            'note': str,
            '_date': date,
            'user': PolymorphicCustomRateUserBase,
            'group': PolymorphicCustomRateGroupBase,
            'activity_description': PolymorphicCustomRateActivityDescriptionBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'rate': 'rate',
            'award': 'award',
            'note': 'note',
            '_date': 'date',
            'user': 'user',
            'group': 'group',
            'activity_description': 'activity_description'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._rate = rate
        self._award = award
        self._note = note
        self.__date = _date
        self._user = user
        self._group = group
        self._activity_description = activity_description

    @classmethod
    def from_dict(cls, dikt: dict) -> 'PolymorphicCustomRate':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The PolymorphicCustomRate of this PolymorphicCustomRate.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this PolymorphicCustomRate.

        The unique identifier for the custom rate

        :return: The id of this PolymorphicCustomRate.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PolymorphicCustomRate.

        The unique identifier for the custom rate

        :param id: The id of this PolymorphicCustomRate.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this PolymorphicCustomRate.

        ETag for the *PolymorphicCustomRate*

        :return: The etag of this PolymorphicCustomRate.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this PolymorphicCustomRate.

        ETag for the *PolymorphicCustomRate*

        :param etag: The etag of this PolymorphicCustomRate.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this PolymorphicCustomRate.

        The time the *PolymorphicCustomRate* was created (as a ISO-8601 timestamp)

        :return: The created_at of this PolymorphicCustomRate.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PolymorphicCustomRate.

        The time the *PolymorphicCustomRate* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this PolymorphicCustomRate.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this PolymorphicCustomRate.

        The time the *PolymorphicCustomRate* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this PolymorphicCustomRate.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this PolymorphicCustomRate.

        The time the *PolymorphicCustomRate* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this PolymorphicCustomRate.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def rate(self):
        """Gets the rate of this PolymorphicCustomRate.

        If `custom_rate.type` is `HourlyRate`, it is the dollar amount of the custom rate of the User or Group for the Matter.  If `custom_rate.type` is `FlatRate`, it is the dollar amount of the custom flat rate for the Matter.  If `custom_rate.type` is `ContingencyFee`, it is the percentage of the contingency fee awarded to the user for the Matter. The value may also be expressed as string that represents a rational number such as `1/3`.  If the user does not have sufficient rate visibility, the rates are hidden. 

        :return: The rate of this PolymorphicCustomRate.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this PolymorphicCustomRate.

        If `custom_rate.type` is `HourlyRate`, it is the dollar amount of the custom rate of the User or Group for the Matter.  If `custom_rate.type` is `FlatRate`, it is the dollar amount of the custom flat rate for the Matter.  If `custom_rate.type` is `ContingencyFee`, it is the percentage of the contingency fee awarded to the user for the Matter. The value may also be expressed as string that represents a rational number such as `1/3`.  If the user does not have sufficient rate visibility, the rates are hidden. 

        :param rate: The rate of this PolymorphicCustomRate.
        :type rate: float
        """

        self._rate = rate

    @property
    def award(self):
        """Gets the award of this PolymorphicCustomRate.

        The value of the ContingencyFee award.

        :return: The award of this PolymorphicCustomRate.
        :rtype: float
        """
        return self._award

    @award.setter
    def award(self, award):
        """Sets the award of this PolymorphicCustomRate.

        The value of the ContingencyFee award.

        :param award: The award of this PolymorphicCustomRate.
        :type award: float
        """

        self._award = award

    @property
    def note(self):
        """Gets the note of this PolymorphicCustomRate.

        Details about the ContingencyFee award.

        :return: The note of this PolymorphicCustomRate.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this PolymorphicCustomRate.

        Details about the ContingencyFee award.

        :param note: The note of this PolymorphicCustomRate.
        :type note: str
        """

        self._note = note

    @property
    def _date(self):
        """Gets the _date of this PolymorphicCustomRate.

        The date of the ContingencyFee award.

        :return: The _date of this PolymorphicCustomRate.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this PolymorphicCustomRate.

        The date of the ContingencyFee award.

        :param _date: The _date of this PolymorphicCustomRate.
        :type _date: date
        """

        self.__date = _date

    @property
    def user(self):
        """Gets the user of this PolymorphicCustomRate.


        :return: The user of this PolymorphicCustomRate.
        :rtype: PolymorphicCustomRateUserBase
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this PolymorphicCustomRate.


        :param user: The user of this PolymorphicCustomRate.
        :type user: PolymorphicCustomRateUserBase
        """

        self._user = user

    @property
    def group(self):
        """Gets the group of this PolymorphicCustomRate.


        :return: The group of this PolymorphicCustomRate.
        :rtype: PolymorphicCustomRateGroupBase
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this PolymorphicCustomRate.


        :param group: The group of this PolymorphicCustomRate.
        :type group: PolymorphicCustomRateGroupBase
        """

        self._group = group

    @property
    def activity_description(self):
        """Gets the activity_description of this PolymorphicCustomRate.


        :return: The activity_description of this PolymorphicCustomRate.
        :rtype: PolymorphicCustomRateActivityDescriptionBase
        """
        return self._activity_description

    @activity_description.setter
    def activity_description(self, activity_description):
        """Sets the activity_description of this PolymorphicCustomRate.


        :param activity_description: The activity_description of this PolymorphicCustomRate.
        :type activity_description: PolymorphicCustomRateActivityDescriptionBase
        """

        self._activity_description = activity_description
