# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class PolymorphicCustomRateBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, created_at: datetime=None, updated_at: datetime=None, rate: float=None, award: float=None, note: str=None, _date: date=None):
        """PolymorphicCustomRateBase - a model defined in OpenAPI

        :param id: The id of this PolymorphicCustomRateBase.
        :param etag: The etag of this PolymorphicCustomRateBase.
        :param created_at: The created_at of this PolymorphicCustomRateBase.
        :param updated_at: The updated_at of this PolymorphicCustomRateBase.
        :param rate: The rate of this PolymorphicCustomRateBase.
        :param award: The award of this PolymorphicCustomRateBase.
        :param note: The note of this PolymorphicCustomRateBase.
        :param _date: The _date of this PolymorphicCustomRateBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'created_at': datetime,
            'updated_at': datetime,
            'rate': float,
            'award': float,
            'note': str,
            '_date': date
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'rate': 'rate',
            'award': 'award',
            'note': 'note',
            '_date': 'date'
        }

        self._id = id
        self._etag = etag
        self._created_at = created_at
        self._updated_at = updated_at
        self._rate = rate
        self._award = award
        self._note = note
        self.__date = _date

    @classmethod
    def from_dict(cls, dikt: dict) -> 'PolymorphicCustomRateBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The PolymorphicCustomRate_base of this PolymorphicCustomRateBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this PolymorphicCustomRateBase.

        The unique identifier for the custom rate

        :return: The id of this PolymorphicCustomRateBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PolymorphicCustomRateBase.

        The unique identifier for the custom rate

        :param id: The id of this PolymorphicCustomRateBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this PolymorphicCustomRateBase.

        ETag for the *PolymorphicCustomRate*

        :return: The etag of this PolymorphicCustomRateBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this PolymorphicCustomRateBase.

        ETag for the *PolymorphicCustomRate*

        :param etag: The etag of this PolymorphicCustomRateBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def created_at(self):
        """Gets the created_at of this PolymorphicCustomRateBase.

        The time the *PolymorphicCustomRate* was created (as a ISO-8601 timestamp)

        :return: The created_at of this PolymorphicCustomRateBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PolymorphicCustomRateBase.

        The time the *PolymorphicCustomRate* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this PolymorphicCustomRateBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this PolymorphicCustomRateBase.

        The time the *PolymorphicCustomRate* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this PolymorphicCustomRateBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this PolymorphicCustomRateBase.

        The time the *PolymorphicCustomRate* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this PolymorphicCustomRateBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def rate(self):
        """Gets the rate of this PolymorphicCustomRateBase.

        If `custom_rate.type` is `HourlyRate`, it is the dollar amount of the custom rate of the User or Group for the Matter.  If `custom_rate.type` is `FlatRate`, it is the dollar amount of the custom flat rate for the Matter.  If `custom_rate.type` is `ContingencyFee`, it is the percentage of the contingency fee awarded to the user for the Matter. The value may also be expressed as string that represents a rational number such as `1/3`.  If the user does not have sufficient rate visibility, the rates are hidden. 

        :return: The rate of this PolymorphicCustomRateBase.
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this PolymorphicCustomRateBase.

        If `custom_rate.type` is `HourlyRate`, it is the dollar amount of the custom rate of the User or Group for the Matter.  If `custom_rate.type` is `FlatRate`, it is the dollar amount of the custom flat rate for the Matter.  If `custom_rate.type` is `ContingencyFee`, it is the percentage of the contingency fee awarded to the user for the Matter. The value may also be expressed as string that represents a rational number such as `1/3`.  If the user does not have sufficient rate visibility, the rates are hidden. 

        :param rate: The rate of this PolymorphicCustomRateBase.
        :type rate: float
        """

        self._rate = rate

    @property
    def award(self):
        """Gets the award of this PolymorphicCustomRateBase.

        The value of the ContingencyFee award.

        :return: The award of this PolymorphicCustomRateBase.
        :rtype: float
        """
        return self._award

    @award.setter
    def award(self, award):
        """Sets the award of this PolymorphicCustomRateBase.

        The value of the ContingencyFee award.

        :param award: The award of this PolymorphicCustomRateBase.
        :type award: float
        """

        self._award = award

    @property
    def note(self):
        """Gets the note of this PolymorphicCustomRateBase.

        Details about the ContingencyFee award.

        :return: The note of this PolymorphicCustomRateBase.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this PolymorphicCustomRateBase.

        Details about the ContingencyFee award.

        :param note: The note of this PolymorphicCustomRateBase.
        :type note: str
        """

        self._note = note

    @property
    def _date(self):
        """Gets the _date of this PolymorphicCustomRateBase.

        The date of the ContingencyFee award.

        :return: The _date of this PolymorphicCustomRateBase.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this PolymorphicCustomRateBase.

        The date of the ContingencyFee award.

        :param _date: The _date of this PolymorphicCustomRateBase.
        :type _date: date
        """

        self.__date = _date
