# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class PracticeAreaCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, category: str=None, code: str=None, name: str=None):
        """PracticeAreaCreateRequestData - a model defined in OpenAPI

        :param category: The category of this PracticeAreaCreateRequestData.
        :param code: The code of this PracticeAreaCreateRequestData.
        :param name: The name of this PracticeAreaCreateRequestData.
        """
        self.openapi_types = {
            'category': str,
            'code': str,
            'name': str
        }

        self.attribute_map = {
            'category': 'category',
            'code': 'code',
            'name': 'name'
        }

        self._category = category
        self._code = code
        self._name = name

    @classmethod
    def from_dict(cls, dikt: dict) -> 'PracticeAreaCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The PracticeArea_create_request_data of this PracticeAreaCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def category(self):
        """Gets the category of this PracticeAreaCreateRequestData.

        The practice area category associated with the *PracticeArea*. The friendly display values corresponding to the enum strings: * Administrative * Admiralty / Maritime * Anti-Trust / Competition * Appellate * Banking / Finance * Bankruptcy * Business Formation / Compliance * Civil Litigation * Civil Rights / Constitutional * Collections & Debt * Commercial / Sale of Goods * Commercial Litigation * Construction * Consumer Protection * Contracts * Corporate Litigation * Criminal * Disability / Social Security * Education * Elder * Employment / Labor * Energy / Environmental * Ethics * Family * Food / Drug * General Practice * Government * Healthcare * Immigration * In-House Counsel * Insurance * Intellectual Property * International * Juvenile * Legal Aid * Mediation / Arbitration * Medical Malpractice * Military * Multi-Practice * Non-Profit / Pro Bono * Other * Personal Injury * Privacy / Information Security * Private Client * Product Liability * Real Estate * Science / Technology * Securities / Mergers & Acquisitions * Small Claims * Sports / Entertainment / Gaming * Tax * Telecommunications * Traffic Offenses * Transportation * Tribal * Trusts * Wills & Estates * Worker's Compensation 

        :return: The category of this PracticeAreaCreateRequestData.
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this PracticeAreaCreateRequestData.

        The practice area category associated with the *PracticeArea*. The friendly display values corresponding to the enum strings: * Administrative * Admiralty / Maritime * Anti-Trust / Competition * Appellate * Banking / Finance * Bankruptcy * Business Formation / Compliance * Civil Litigation * Civil Rights / Constitutional * Collections & Debt * Commercial / Sale of Goods * Commercial Litigation * Construction * Consumer Protection * Contracts * Corporate Litigation * Criminal * Disability / Social Security * Education * Elder * Employment / Labor * Energy / Environmental * Ethics * Family * Food / Drug * General Practice * Government * Healthcare * Immigration * In-House Counsel * Insurance * Intellectual Property * International * Juvenile * Legal Aid * Mediation / Arbitration * Medical Malpractice * Military * Multi-Practice * Non-Profit / Pro Bono * Other * Personal Injury * Privacy / Information Security * Private Client * Product Liability * Real Estate * Science / Technology * Securities / Mergers & Acquisitions * Small Claims * Sports / Entertainment / Gaming * Tax * Telecommunications * Traffic Offenses * Transportation * Tribal * Trusts * Wills & Estates * Worker's Compensation 

        :param category: The category of this PracticeAreaCreateRequestData.
        :type category: str
        """
        allowed_values = ["administrative", "admiralty_and_maritime", "anti_trust_and_competition", "appellate", "banking_and_finance", "bankruptcy", "business_formation_and_compliance", "civil_litigation", "civil_rights_and_constitutional", "collections_and_debt", "commercial_and_sale_of_goods", "commercial_litigation", "construction", "consumer_protection", "contracts", "corporate_litigation", "criminal", "disability_and_social_security", "education", "elder", "employment_and_labor", "energy_and_environmental", "ethics", "family", "food_and_drug", "general_practice", "government", "healthcare", "immigration", "in_house_counsel", "insurance", "intellectual_property", "international", "juvenile", "legal_aid", "mediation_and_arbitration", "medical_malpractice", "military", "multi_practice", "non_profit_and_pro_bono", "other", "personal_injury", "privacy_and_information_security", "private_client", "product_liability", "real_estate", "science_and_technology", "securities_and_mergers_and_acquisitions", "small_claims", "sports_and_entertainment_and_gaming", "tax", "telecommunications", "traffic_offenses", "transportation", "tribal", "trusts", "wills_and_estates", "workers_compensation"]  # noqa: E501
        if category not in allowed_values:
            raise ValueError(
                "Invalid value for `category` ({0}), must be one of {1}"
                .format(category, allowed_values)
            )

        self._category = category

    @property
    def code(self):
        """Gets the code of this PracticeAreaCreateRequestData.

        The code attached to the PracticeArea.

        :return: The code of this PracticeAreaCreateRequestData.
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this PracticeAreaCreateRequestData.

        The code attached to the PracticeArea.

        :param code: The code of this PracticeAreaCreateRequestData.
        :type code: str
        """

        self._code = code

    @property
    def name(self):
        """Gets the name of this PracticeAreaCreateRequestData.

        Name of the PracticeArea.

        :return: The name of this PracticeAreaCreateRequestData.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PracticeAreaCreateRequestData.

        Name of the PracticeArea.

        :param name: The name of this PracticeAreaCreateRequestData.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name
