# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.address_base import AddressBase
from openapi_server.models.avatar_base import AvatarBase
from openapi_server.models.contact_base import ContactBase
from openapi_server.models.custom_field_value_base import CustomFieldValueBase
from openapi_server.models.email_address_base import EmailAddressBase
from openapi_server.models.phone_number_base import PhoneNumberBase
from openapi_server.models.relationship_base import RelationshipBase
from openapi_server.models.web_site_base import WebSiteBase
from openapi_server import util


class RelatedContacts(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, contact_id: int=None, name: str=None, first_name: str=None, middle_name: str=None, last_name: str=None, type: str=None, created_at: datetime=None, updated_at: datetime=None, prefix: str=None, title: str=None, initials: str=None, is_matter_client: bool=None, primary_email_address: str=None, primary_phone_number: str=None, client_connect_user_id: int=None, avatar: AvatarBase=None, company: ContactBase=None, primary_address: AddressBase=None, primary_web_site: WebSiteBase=None, secondary_address: AddressBase=None, secondary_web_site: WebSiteBase=None, addresses: List[AddressBase]=None, custom_field_values: List[CustomFieldValueBase]=None, email_addresses: List[EmailAddressBase]=None, phone_numbers: List[PhoneNumberBase]=None, web_sites: List[WebSiteBase]=None, relationship: RelationshipBase=None):
        """RelatedContacts - a model defined in OpenAPI

        :param id: The id of this RelatedContacts.
        :param contact_id: The contact_id of this RelatedContacts.
        :param name: The name of this RelatedContacts.
        :param first_name: The first_name of this RelatedContacts.
        :param middle_name: The middle_name of this RelatedContacts.
        :param last_name: The last_name of this RelatedContacts.
        :param type: The type of this RelatedContacts.
        :param created_at: The created_at of this RelatedContacts.
        :param updated_at: The updated_at of this RelatedContacts.
        :param prefix: The prefix of this RelatedContacts.
        :param title: The title of this RelatedContacts.
        :param initials: The initials of this RelatedContacts.
        :param is_matter_client: The is_matter_client of this RelatedContacts.
        :param primary_email_address: The primary_email_address of this RelatedContacts.
        :param primary_phone_number: The primary_phone_number of this RelatedContacts.
        :param client_connect_user_id: The client_connect_user_id of this RelatedContacts.
        :param avatar: The avatar of this RelatedContacts.
        :param company: The company of this RelatedContacts.
        :param primary_address: The primary_address of this RelatedContacts.
        :param primary_web_site: The primary_web_site of this RelatedContacts.
        :param secondary_address: The secondary_address of this RelatedContacts.
        :param secondary_web_site: The secondary_web_site of this RelatedContacts.
        :param addresses: The addresses of this RelatedContacts.
        :param custom_field_values: The custom_field_values of this RelatedContacts.
        :param email_addresses: The email_addresses of this RelatedContacts.
        :param phone_numbers: The phone_numbers of this RelatedContacts.
        :param web_sites: The web_sites of this RelatedContacts.
        :param relationship: The relationship of this RelatedContacts.
        """
        self.openapi_types = {
            'id': int,
            'contact_id': int,
            'name': str,
            'first_name': str,
            'middle_name': str,
            'last_name': str,
            'type': str,
            'created_at': datetime,
            'updated_at': datetime,
            'prefix': str,
            'title': str,
            'initials': str,
            'is_matter_client': bool,
            'primary_email_address': str,
            'primary_phone_number': str,
            'client_connect_user_id': int,
            'avatar': AvatarBase,
            'company': ContactBase,
            'primary_address': AddressBase,
            'primary_web_site': WebSiteBase,
            'secondary_address': AddressBase,
            'secondary_web_site': WebSiteBase,
            'addresses': List[AddressBase],
            'custom_field_values': List[CustomFieldValueBase],
            'email_addresses': List[EmailAddressBase],
            'phone_numbers': List[PhoneNumberBase],
            'web_sites': List[WebSiteBase],
            'relationship': RelationshipBase
        }

        self.attribute_map = {
            'id': 'id',
            'contact_id': 'contact_id',
            'name': 'name',
            'first_name': 'first_name',
            'middle_name': 'middle_name',
            'last_name': 'last_name',
            'type': 'type',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'prefix': 'prefix',
            'title': 'title',
            'initials': 'initials',
            'is_matter_client': 'is_matter_client',
            'primary_email_address': 'primary_email_address',
            'primary_phone_number': 'primary_phone_number',
            'client_connect_user_id': 'client_connect_user_id',
            'avatar': 'avatar',
            'company': 'company',
            'primary_address': 'primary_address',
            'primary_web_site': 'primary_web_site',
            'secondary_address': 'secondary_address',
            'secondary_web_site': 'secondary_web_site',
            'addresses': 'addresses',
            'custom_field_values': 'custom_field_values',
            'email_addresses': 'email_addresses',
            'phone_numbers': 'phone_numbers',
            'web_sites': 'web_sites',
            'relationship': 'relationship'
        }

        self._id = id
        self._contact_id = contact_id
        self._name = name
        self._first_name = first_name
        self._middle_name = middle_name
        self._last_name = last_name
        self._type = type
        self._created_at = created_at
        self._updated_at = updated_at
        self._prefix = prefix
        self._title = title
        self._initials = initials
        self._is_matter_client = is_matter_client
        self._primary_email_address = primary_email_address
        self._primary_phone_number = primary_phone_number
        self._client_connect_user_id = client_connect_user_id
        self._avatar = avatar
        self._company = company
        self._primary_address = primary_address
        self._primary_web_site = primary_web_site
        self._secondary_address = secondary_address
        self._secondary_web_site = secondary_web_site
        self._addresses = addresses
        self._custom_field_values = custom_field_values
        self._email_addresses = email_addresses
        self._phone_numbers = phone_numbers
        self._web_sites = web_sites
        self._relationship = relationship

    @classmethod
    def from_dict(cls, dikt: dict) -> 'RelatedContacts':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The RelatedContacts of this RelatedContacts.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this RelatedContacts.

        Unique identifier for the *RelatedContacts*

        :return: The id of this RelatedContacts.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RelatedContacts.

        Unique identifier for the *RelatedContacts*

        :param id: The id of this RelatedContacts.
        :type id: int
        """

        self._id = id

    @property
    def contact_id(self):
        """Gets the contact_id of this RelatedContacts.

        The id of the *RelatedContacts*

        :return: The contact_id of this RelatedContacts.
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this RelatedContacts.

        The id of the *RelatedContacts*

        :param contact_id: The contact_id of this RelatedContacts.
        :type contact_id: int
        """

        self._contact_id = contact_id

    @property
    def name(self):
        """Gets the name of this RelatedContacts.

        The full name of the *RelatedContacts*

        :return: The name of this RelatedContacts.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RelatedContacts.

        The full name of the *RelatedContacts*

        :param name: The name of this RelatedContacts.
        :type name: str
        """

        self._name = name

    @property
    def first_name(self):
        """Gets the first_name of this RelatedContacts.

        First name of the Person

        :return: The first_name of this RelatedContacts.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this RelatedContacts.

        First name of the Person

        :param first_name: The first_name of this RelatedContacts.
        :type first_name: str
        """

        self._first_name = first_name

    @property
    def middle_name(self):
        """Gets the middle_name of this RelatedContacts.

        Middle name of the Person

        :return: The middle_name of this RelatedContacts.
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this RelatedContacts.

        Middle name of the Person

        :param middle_name: The middle_name of this RelatedContacts.
        :type middle_name: str
        """

        self._middle_name = middle_name

    @property
    def last_name(self):
        """Gets the last_name of this RelatedContacts.

        Last name of the Person

        :return: The last_name of this RelatedContacts.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this RelatedContacts.

        Last name of the Person

        :param last_name: The last_name of this RelatedContacts.
        :type last_name: str
        """

        self._last_name = last_name

    @property
    def type(self):
        """Gets the type of this RelatedContacts.

        The type of the *RelatedContacts*

        :return: The type of this RelatedContacts.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RelatedContacts.

        The type of the *RelatedContacts*

        :param type: The type of this RelatedContacts.
        :type type: str
        """
        allowed_values = ["Company", "Person"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def created_at(self):
        """Gets the created_at of this RelatedContacts.

        The time the *RelatedContacts* was created (as a ISO-8601 timestamp)

        :return: The created_at of this RelatedContacts.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this RelatedContacts.

        The time the *RelatedContacts* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this RelatedContacts.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this RelatedContacts.

        The time the *RelatedContacts* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this RelatedContacts.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this RelatedContacts.

        The time the *RelatedContacts* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this RelatedContacts.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def prefix(self):
        """Gets the prefix of this RelatedContacts.

        The prefix of the *RelatedContacts* (Mr, Mrs, etc)

        :return: The prefix of this RelatedContacts.
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this RelatedContacts.

        The prefix of the *RelatedContacts* (Mr, Mrs, etc)

        :param prefix: The prefix of this RelatedContacts.
        :type prefix: str
        """

        self._prefix = prefix

    @property
    def title(self):
        """Gets the title of this RelatedContacts.

        The designated title of the *RelatedContacts*

        :return: The title of this RelatedContacts.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this RelatedContacts.

        The designated title of the *RelatedContacts*

        :param title: The title of this RelatedContacts.
        :type title: str
        """

        self._title = title

    @property
    def initials(self):
        """Gets the initials of this RelatedContacts.

        The initials of the *RelatedContacts*

        :return: The initials of this RelatedContacts.
        :rtype: str
        """
        return self._initials

    @initials.setter
    def initials(self, initials):
        """Sets the initials of this RelatedContacts.

        The initials of the *RelatedContacts*

        :param initials: The initials of this RelatedContacts.
        :type initials: str
        """

        self._initials = initials

    @property
    def is_matter_client(self):
        """Gets the is_matter_client of this RelatedContacts.

        Whether or not the RelatedContacts is also the client of the matter

        :return: The is_matter_client of this RelatedContacts.
        :rtype: bool
        """
        return self._is_matter_client

    @is_matter_client.setter
    def is_matter_client(self, is_matter_client):
        """Sets the is_matter_client of this RelatedContacts.

        Whether or not the RelatedContacts is also the client of the matter

        :param is_matter_client: The is_matter_client of this RelatedContacts.
        :type is_matter_client: bool
        """

        self._is_matter_client = is_matter_client

    @property
    def primary_email_address(self):
        """Gets the primary_email_address of this RelatedContacts.

        The primary email address of related contact

        :return: The primary_email_address of this RelatedContacts.
        :rtype: str
        """
        return self._primary_email_address

    @primary_email_address.setter
    def primary_email_address(self, primary_email_address):
        """Sets the primary_email_address of this RelatedContacts.

        The primary email address of related contact

        :param primary_email_address: The primary_email_address of this RelatedContacts.
        :type primary_email_address: str
        """

        self._primary_email_address = primary_email_address

    @property
    def primary_phone_number(self):
        """Gets the primary_phone_number of this RelatedContacts.

        The primary phone number of related contact

        :return: The primary_phone_number of this RelatedContacts.
        :rtype: str
        """
        return self._primary_phone_number

    @primary_phone_number.setter
    def primary_phone_number(self, primary_phone_number):
        """Sets the primary_phone_number of this RelatedContacts.

        The primary phone number of related contact

        :param primary_phone_number: The primary_phone_number of this RelatedContacts.
        :type primary_phone_number: str
        """

        self._primary_phone_number = primary_phone_number

    @property
    def client_connect_user_id(self):
        """Gets the client_connect_user_id of this RelatedContacts.

        The client connect ID of the contacts associated user

        :return: The client_connect_user_id of this RelatedContacts.
        :rtype: int
        """
        return self._client_connect_user_id

    @client_connect_user_id.setter
    def client_connect_user_id(self, client_connect_user_id):
        """Sets the client_connect_user_id of this RelatedContacts.

        The client connect ID of the contacts associated user

        :param client_connect_user_id: The client_connect_user_id of this RelatedContacts.
        :type client_connect_user_id: int
        """

        self._client_connect_user_id = client_connect_user_id

    @property
    def avatar(self):
        """Gets the avatar of this RelatedContacts.


        :return: The avatar of this RelatedContacts.
        :rtype: AvatarBase
        """
        return self._avatar

    @avatar.setter
    def avatar(self, avatar):
        """Sets the avatar of this RelatedContacts.


        :param avatar: The avatar of this RelatedContacts.
        :type avatar: AvatarBase
        """

        self._avatar = avatar

    @property
    def company(self):
        """Gets the company of this RelatedContacts.


        :return: The company of this RelatedContacts.
        :rtype: ContactBase
        """
        return self._company

    @company.setter
    def company(self, company):
        """Sets the company of this RelatedContacts.


        :param company: The company of this RelatedContacts.
        :type company: ContactBase
        """

        self._company = company

    @property
    def primary_address(self):
        """Gets the primary_address of this RelatedContacts.


        :return: The primary_address of this RelatedContacts.
        :rtype: AddressBase
        """
        return self._primary_address

    @primary_address.setter
    def primary_address(self, primary_address):
        """Sets the primary_address of this RelatedContacts.


        :param primary_address: The primary_address of this RelatedContacts.
        :type primary_address: AddressBase
        """

        self._primary_address = primary_address

    @property
    def primary_web_site(self):
        """Gets the primary_web_site of this RelatedContacts.


        :return: The primary_web_site of this RelatedContacts.
        :rtype: WebSiteBase
        """
        return self._primary_web_site

    @primary_web_site.setter
    def primary_web_site(self, primary_web_site):
        """Sets the primary_web_site of this RelatedContacts.


        :param primary_web_site: The primary_web_site of this RelatedContacts.
        :type primary_web_site: WebSiteBase
        """

        self._primary_web_site = primary_web_site

    @property
    def secondary_address(self):
        """Gets the secondary_address of this RelatedContacts.


        :return: The secondary_address of this RelatedContacts.
        :rtype: AddressBase
        """
        return self._secondary_address

    @secondary_address.setter
    def secondary_address(self, secondary_address):
        """Sets the secondary_address of this RelatedContacts.


        :param secondary_address: The secondary_address of this RelatedContacts.
        :type secondary_address: AddressBase
        """

        self._secondary_address = secondary_address

    @property
    def secondary_web_site(self):
        """Gets the secondary_web_site of this RelatedContacts.


        :return: The secondary_web_site of this RelatedContacts.
        :rtype: WebSiteBase
        """
        return self._secondary_web_site

    @secondary_web_site.setter
    def secondary_web_site(self, secondary_web_site):
        """Sets the secondary_web_site of this RelatedContacts.


        :param secondary_web_site: The secondary_web_site of this RelatedContacts.
        :type secondary_web_site: WebSiteBase
        """

        self._secondary_web_site = secondary_web_site

    @property
    def addresses(self):
        """Gets the addresses of this RelatedContacts.

        Address

        :return: The addresses of this RelatedContacts.
        :rtype: List[AddressBase]
        """
        return self._addresses

    @addresses.setter
    def addresses(self, addresses):
        """Sets the addresses of this RelatedContacts.

        Address

        :param addresses: The addresses of this RelatedContacts.
        :type addresses: List[AddressBase]
        """

        self._addresses = addresses

    @property
    def custom_field_values(self):
        """Gets the custom_field_values of this RelatedContacts.

        CustomFieldValue

        :return: The custom_field_values of this RelatedContacts.
        :rtype: List[CustomFieldValueBase]
        """
        return self._custom_field_values

    @custom_field_values.setter
    def custom_field_values(self, custom_field_values):
        """Sets the custom_field_values of this RelatedContacts.

        CustomFieldValue

        :param custom_field_values: The custom_field_values of this RelatedContacts.
        :type custom_field_values: List[CustomFieldValueBase]
        """

        self._custom_field_values = custom_field_values

    @property
    def email_addresses(self):
        """Gets the email_addresses of this RelatedContacts.

        EmailAddress

        :return: The email_addresses of this RelatedContacts.
        :rtype: List[EmailAddressBase]
        """
        return self._email_addresses

    @email_addresses.setter
    def email_addresses(self, email_addresses):
        """Sets the email_addresses of this RelatedContacts.

        EmailAddress

        :param email_addresses: The email_addresses of this RelatedContacts.
        :type email_addresses: List[EmailAddressBase]
        """

        self._email_addresses = email_addresses

    @property
    def phone_numbers(self):
        """Gets the phone_numbers of this RelatedContacts.

        PhoneNumber

        :return: The phone_numbers of this RelatedContacts.
        :rtype: List[PhoneNumberBase]
        """
        return self._phone_numbers

    @phone_numbers.setter
    def phone_numbers(self, phone_numbers):
        """Sets the phone_numbers of this RelatedContacts.

        PhoneNumber

        :param phone_numbers: The phone_numbers of this RelatedContacts.
        :type phone_numbers: List[PhoneNumberBase]
        """

        self._phone_numbers = phone_numbers

    @property
    def web_sites(self):
        """Gets the web_sites of this RelatedContacts.

        WebSite

        :return: The web_sites of this RelatedContacts.
        :rtype: List[WebSiteBase]
        """
        return self._web_sites

    @web_sites.setter
    def web_sites(self, web_sites):
        """Sets the web_sites of this RelatedContacts.

        WebSite

        :param web_sites: The web_sites of this RelatedContacts.
        :type web_sites: List[WebSiteBase]
        """

        self._web_sites = web_sites

    @property
    def relationship(self):
        """Gets the relationship of this RelatedContacts.


        :return: The relationship of this RelatedContacts.
        :rtype: RelationshipBase
        """
        return self._relationship

    @relationship.setter
    def relationship(self, relationship):
        """Sets the relationship of this RelatedContacts.


        :param relationship: The relationship of this RelatedContacts.
        :type relationship: RelationshipBase
        """

        self._relationship = relationship
