# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ReminderBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, duration: int=None, next_delivery_at: datetime=None, state: str=None, created_at: datetime=None, updated_at: datetime=None):
        """ReminderBase - a model defined in OpenAPI

        :param id: The id of this ReminderBase.
        :param etag: The etag of this ReminderBase.
        :param duration: The duration of this ReminderBase.
        :param next_delivery_at: The next_delivery_at of this ReminderBase.
        :param state: The state of this ReminderBase.
        :param created_at: The created_at of this ReminderBase.
        :param updated_at: The updated_at of this ReminderBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'duration': int,
            'next_delivery_at': datetime,
            'state': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'duration': 'duration',
            'next_delivery_at': 'next_delivery_at',
            'state': 'state',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._duration = duration
        self._next_delivery_at = next_delivery_at
        self._state = state
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ReminderBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Reminder_base of this ReminderBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ReminderBase.

        Unique identifier for the *Reminder*

        :return: The id of this ReminderBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ReminderBase.

        Unique identifier for the *Reminder*

        :param id: The id of this ReminderBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this ReminderBase.

        ETag for the *Reminder*

        :return: The etag of this ReminderBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this ReminderBase.

        ETag for the *Reminder*

        :param etag: The etag of this ReminderBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def duration(self):
        """Gets the duration of this ReminderBase.

        Time in minutes to remind user before the subject

        :return: The duration of this ReminderBase.
        :rtype: int
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this ReminderBase.

        Time in minutes to remind user before the subject

        :param duration: The duration of this ReminderBase.
        :type duration: int
        """

        self._duration = duration

    @property
    def next_delivery_at(self):
        """Gets the next_delivery_at of this ReminderBase.

        The time the *Reminder* will be delivered (as a ISO-8601 timestamp)

        :return: The next_delivery_at of this ReminderBase.
        :rtype: datetime
        """
        return self._next_delivery_at

    @next_delivery_at.setter
    def next_delivery_at(self, next_delivery_at):
        """Sets the next_delivery_at of this ReminderBase.

        The time the *Reminder* will be delivered (as a ISO-8601 timestamp)

        :param next_delivery_at: The next_delivery_at of this ReminderBase.
        :type next_delivery_at: datetime
        """

        self._next_delivery_at = next_delivery_at

    @property
    def state(self):
        """Gets the state of this ReminderBase.

        The current state of the *Reminder*

        :return: The state of this ReminderBase.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this ReminderBase.

        The current state of the *Reminder*

        :param state: The state of this ReminderBase.
        :type state: str
        """
        allowed_values = ["initializing", "scheduling", "rescheduling", "scheduled", "attempting_delivery", "delivery_failed", "delivered", "delivery_skipped", "invalid_user"]  # noqa: E501
        if state not in allowed_values:
            raise ValueError(
                "Invalid value for `state` ({0}), must be one of {1}"
                .format(state, allowed_values)
            )

        self._state = state

    @property
    def created_at(self):
        """Gets the created_at of this ReminderBase.

        The time the *Reminder* was created (as a ISO-8601 timestamp)

        :return: The created_at of this ReminderBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ReminderBase.

        The time the *Reminder* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this ReminderBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ReminderBase.

        The time the *Reminder* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this ReminderBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ReminderBase.

        The time the *Reminder* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this ReminderBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
