# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.matter_create_request_data_statute_of_limitations_reminders_inner_notification_method import MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
from openapi_server.models.reminder_create_request_data_subject import ReminderCreateRequestDataSubject
from openapi_server import util


class ReminderCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, duration_unit: str=None, duration_value: int=None, notification_method: MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod=None, subject: ReminderCreateRequestDataSubject=None):
        """ReminderCreateRequestData - a model defined in OpenAPI

        :param duration_unit: The duration_unit of this ReminderCreateRequestData.
        :param duration_value: The duration_value of this ReminderCreateRequestData.
        :param notification_method: The notification_method of this ReminderCreateRequestData.
        :param subject: The subject of this ReminderCreateRequestData.
        """
        self.openapi_types = {
            'duration_unit': str,
            'duration_value': int,
            'notification_method': MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod,
            'subject': ReminderCreateRequestDataSubject
        }

        self.attribute_map = {
            'duration_unit': 'duration_unit',
            'duration_value': 'duration_value',
            'notification_method': 'notification_method',
            'subject': 'subject'
        }

        self._duration_unit = duration_unit
        self._duration_value = duration_value
        self._notification_method = notification_method
        self._subject = subject

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ReminderCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Reminder_create_request_data of this ReminderCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def duration_unit(self):
        """Gets the duration_unit of this ReminderCreateRequestData.

        Unit to measure the duration value in.

        :return: The duration_unit of this ReminderCreateRequestData.
        :rtype: str
        """
        return self._duration_unit

    @duration_unit.setter
    def duration_unit(self, duration_unit):
        """Sets the duration_unit of this ReminderCreateRequestData.

        Unit to measure the duration value in.

        :param duration_unit: The duration_unit of this ReminderCreateRequestData.
        :type duration_unit: str
        """
        allowed_values = ["weeks", "days", "hours", "minutes"]  # noqa: E501
        if duration_unit not in allowed_values:
            raise ValueError(
                "Invalid value for `duration_unit` ({0}), must be one of {1}"
                .format(duration_unit, allowed_values)
            )

        self._duration_unit = duration_unit

    @property
    def duration_value(self):
        """Gets the duration_value of this ReminderCreateRequestData.

        Time measured in `duration_unit` to remind user before the subject.

        :return: The duration_value of this ReminderCreateRequestData.
        :rtype: int
        """
        return self._duration_value

    @duration_value.setter
    def duration_value(self, duration_value):
        """Sets the duration_value of this ReminderCreateRequestData.

        Time measured in `duration_unit` to remind user before the subject.

        :param duration_value: The duration_value of this ReminderCreateRequestData.
        :type duration_value: int
        """

        self._duration_value = duration_value

    @property
    def notification_method(self):
        """Gets the notification_method of this ReminderCreateRequestData.


        :return: The notification_method of this ReminderCreateRequestData.
        :rtype: MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
        """
        return self._notification_method

    @notification_method.setter
    def notification_method(self, notification_method):
        """Sets the notification_method of this ReminderCreateRequestData.


        :param notification_method: The notification_method of this ReminderCreateRequestData.
        :type notification_method: MatterCreateRequestDataStatuteOfLimitationsRemindersInnerNotificationMethod
        """
        if notification_method is None:
            raise ValueError("Invalid value for `notification_method`, must not be `None`")

        self._notification_method = notification_method

    @property
    def subject(self):
        """Gets the subject of this ReminderCreateRequestData.


        :return: The subject of this ReminderCreateRequestData.
        :rtype: ReminderCreateRequestDataSubject
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this ReminderCreateRequestData.


        :param subject: The subject of this ReminderCreateRequestData.
        :type subject: ReminderCreateRequestDataSubject
        """
        if subject is None:
            raise ValueError("Invalid value for `subject`, must not be `None`")

        self._subject = subject
