# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class ReminderCreateRequestDataSubject(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, type: str=None):
        """ReminderCreateRequestDataSubject - a model defined in OpenAPI

        :param id: The id of this ReminderCreateRequestDataSubject.
        :param type: The type of this ReminderCreateRequestDataSubject.
        """
        self.openapi_types = {
            'id': int,
            'type': str
        }

        self.attribute_map = {
            'id': 'id',
            'type': 'type'
        }

        self._id = id
        self._type = type

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ReminderCreateRequestDataSubject':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Reminder_create_request_data_subject of this ReminderCreateRequestDataSubject.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this ReminderCreateRequestDataSubject.

        The unique identifier for a single CalendarEntry and Task associated with the Reminder. The keyword `null` is not valid for this field.

        :return: The id of this ReminderCreateRequestDataSubject.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ReminderCreateRequestDataSubject.

        The unique identifier for a single CalendarEntry and Task associated with the Reminder. The keyword `null` is not valid for this field.

        :param id: The id of this ReminderCreateRequestDataSubject.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def type(self):
        """Gets the type of this ReminderCreateRequestDataSubject.

        Model type of the Subject.

        :return: The type of this ReminderCreateRequestDataSubject.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ReminderCreateRequestDataSubject.

        Model type of the Subject.

        :param type: The type of this ReminderCreateRequestDataSubject.
        :type type: str
        """
        allowed_values = ["CalendarEntry", "Task"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type
