# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TaskBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, status: str=None, description: str=None, priority: str=None, due_at: date=None, permission: str=None, completed_at: datetime=None, notify_completion: bool=None, statute_of_limitations: bool=None, time_estimated: int=None, created_at: datetime=None, updated_at: datetime=None, time_entries_count: int=None):
        """TaskBase - a model defined in OpenAPI

        :param id: The id of this TaskBase.
        :param etag: The etag of this TaskBase.
        :param name: The name of this TaskBase.
        :param status: The status of this TaskBase.
        :param description: The description of this TaskBase.
        :param priority: The priority of this TaskBase.
        :param due_at: The due_at of this TaskBase.
        :param permission: The permission of this TaskBase.
        :param completed_at: The completed_at of this TaskBase.
        :param notify_completion: The notify_completion of this TaskBase.
        :param statute_of_limitations: The statute_of_limitations of this TaskBase.
        :param time_estimated: The time_estimated of this TaskBase.
        :param created_at: The created_at of this TaskBase.
        :param updated_at: The updated_at of this TaskBase.
        :param time_entries_count: The time_entries_count of this TaskBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'status': str,
            'description': str,
            'priority': str,
            'due_at': date,
            'permission': str,
            'completed_at': datetime,
            'notify_completion': bool,
            'statute_of_limitations': bool,
            'time_estimated': int,
            'created_at': datetime,
            'updated_at': datetime,
            'time_entries_count': int
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'status': 'status',
            'description': 'description',
            'priority': 'priority',
            'due_at': 'due_at',
            'permission': 'permission',
            'completed_at': 'completed_at',
            'notify_completion': 'notify_completion',
            'statute_of_limitations': 'statute_of_limitations',
            'time_estimated': 'time_estimated',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'time_entries_count': 'time_entries_count'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._status = status
        self._description = description
        self._priority = priority
        self._due_at = due_at
        self._permission = permission
        self._completed_at = completed_at
        self._notify_completion = notify_completion
        self._statute_of_limitations = statute_of_limitations
        self._time_estimated = time_estimated
        self._created_at = created_at
        self._updated_at = updated_at
        self._time_entries_count = time_entries_count

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TaskBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Task_base of this TaskBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this TaskBase.

        Unique identifier for the *Task*

        :return: The id of this TaskBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskBase.

        Unique identifier for the *Task*

        :param id: The id of this TaskBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this TaskBase.

        ETag for the *Task*

        :return: The etag of this TaskBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this TaskBase.

        ETag for the *Task*

        :param etag: The etag of this TaskBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this TaskBase.

        The name of the *Task*

        :return: The name of this TaskBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskBase.

        The name of the *Task*

        :param name: The name of this TaskBase.
        :type name: str
        """

        self._name = name

    @property
    def status(self):
        """Gets the status of this TaskBase.

        Status of the *Task*. (Note that users without advanced tasks can only have either complete or pending)

        :return: The status of this TaskBase.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TaskBase.

        Status of the *Task*. (Note that users without advanced tasks can only have either complete or pending)

        :param status: The status of this TaskBase.
        :type status: str
        """
        allowed_values = ["pending", "in_progress", "in_review", "complete"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def description(self):
        """Gets the description of this TaskBase.

        A detailed description of the *Task*

        :return: The description of this TaskBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TaskBase.

        A detailed description of the *Task*

        :param description: The description of this TaskBase.
        :type description: str
        """

        self._description = description

    @property
    def priority(self):
        """Gets the priority of this TaskBase.

        The priority of the *Task*

        :return: The priority of this TaskBase.
        :rtype: str
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this TaskBase.

        The priority of the *Task*

        :param priority: The priority of this TaskBase.
        :type priority: str
        """
        allowed_values = ["High", "Normal", "Low"]  # noqa: E501
        if priority not in allowed_values:
            raise ValueError(
                "Invalid value for `priority` ({0}), must be one of {1}"
                .format(priority, allowed_values)
            )

        self._priority = priority

    @property
    def due_at(self):
        """Gets the due_at of this TaskBase.

        The date the *Task* is due (as a ISO-8601 date)

        :return: The due_at of this TaskBase.
        :rtype: date
        """
        return self._due_at

    @due_at.setter
    def due_at(self, due_at):
        """Sets the due_at of this TaskBase.

        The date the *Task* is due (as a ISO-8601 date)

        :param due_at: The due_at of this TaskBase.
        :type due_at: date
        """

        self._due_at = due_at

    @property
    def permission(self):
        """Gets the permission of this TaskBase.

        The permission of the *Task*

        :return: The permission of this TaskBase.
        :rtype: str
        """
        return self._permission

    @permission.setter
    def permission(self, permission):
        """Sets the permission of this TaskBase.

        The permission of the *Task*

        :param permission: The permission of this TaskBase.
        :type permission: str
        """

        self._permission = permission

    @property
    def completed_at(self):
        """Gets the completed_at of this TaskBase.

        The time the *Task* was completed (as a ISO-8601 timestamp)

        :return: The completed_at of this TaskBase.
        :rtype: datetime
        """
        return self._completed_at

    @completed_at.setter
    def completed_at(self, completed_at):
        """Sets the completed_at of this TaskBase.

        The time the *Task* was completed (as a ISO-8601 timestamp)

        :param completed_at: The completed_at of this TaskBase.
        :type completed_at: datetime
        """

        self._completed_at = completed_at

    @property
    def notify_completion(self):
        """Gets the notify_completion of this TaskBase.

        Whether to notify the assigner of the task's completion

        :return: The notify_completion of this TaskBase.
        :rtype: bool
        """
        return self._notify_completion

    @notify_completion.setter
    def notify_completion(self, notify_completion):
        """Sets the notify_completion of this TaskBase.

        Whether to notify the assigner of the task's completion

        :param notify_completion: The notify_completion of this TaskBase.
        :type notify_completion: bool
        """

        self._notify_completion = notify_completion

    @property
    def statute_of_limitations(self):
        """Gets the statute_of_limitations of this TaskBase.

        Whether the task is a statute of limitations

        :return: The statute_of_limitations of this TaskBase.
        :rtype: bool
        """
        return self._statute_of_limitations

    @statute_of_limitations.setter
    def statute_of_limitations(self, statute_of_limitations):
        """Sets the statute_of_limitations of this TaskBase.

        Whether the task is a statute of limitations

        :param statute_of_limitations: The statute_of_limitations of this TaskBase.
        :type statute_of_limitations: bool
        """

        self._statute_of_limitations = statute_of_limitations

    @property
    def time_estimated(self):
        """Gets the time_estimated of this TaskBase.

        Time the *Task* should take to complete

        :return: The time_estimated of this TaskBase.
        :rtype: int
        """
        return self._time_estimated

    @time_estimated.setter
    def time_estimated(self, time_estimated):
        """Sets the time_estimated of this TaskBase.

        Time the *Task* should take to complete

        :param time_estimated: The time_estimated of this TaskBase.
        :type time_estimated: int
        """

        self._time_estimated = time_estimated

    @property
    def created_at(self):
        """Gets the created_at of this TaskBase.

        The time the *Task* was created (as a ISO-8601 timestamp)

        :return: The created_at of this TaskBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TaskBase.

        The time the *Task* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this TaskBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this TaskBase.

        The time the *Task* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this TaskBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TaskBase.

        The time the *Task* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this TaskBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def time_entries_count(self):
        """Gets the time_entries_count of this TaskBase.

        The number of time entries associated with this task

        :return: The time_entries_count of this TaskBase.
        :rtype: int
        """
        return self._time_entries_count

    @time_entries_count.setter
    def time_entries_count(self, time_entries_count):
        """Sets the time_entries_count of this TaskBase.

        The number of time entries associated with this task

        :param time_entries_count: The time_entries_count of this TaskBase.
        :type time_entries_count: int
        """

        self._time_entries_count = time_entries_count
