# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TaskTemplateListBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, created_at: datetime=None, description: str=None, id: int=None, etag: str=None, name: str=None, templates_count: int=None, updated_at: datetime=None):
        """TaskTemplateListBase - a model defined in OpenAPI

        :param created_at: The created_at of this TaskTemplateListBase.
        :param description: The description of this TaskTemplateListBase.
        :param id: The id of this TaskTemplateListBase.
        :param etag: The etag of this TaskTemplateListBase.
        :param name: The name of this TaskTemplateListBase.
        :param templates_count: The templates_count of this TaskTemplateListBase.
        :param updated_at: The updated_at of this TaskTemplateListBase.
        """
        self.openapi_types = {
            'created_at': datetime,
            'description': str,
            'id': int,
            'etag': str,
            'name': str,
            'templates_count': int,
            'updated_at': datetime
        }

        self.attribute_map = {
            'created_at': 'created_at',
            'description': 'description',
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'templates_count': 'templates_count',
            'updated_at': 'updated_at'
        }

        self._created_at = created_at
        self._description = description
        self._id = id
        self._etag = etag
        self._name = name
        self._templates_count = templates_count
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TaskTemplateListBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TaskTemplateList_base of this TaskTemplateListBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def created_at(self):
        """Gets the created_at of this TaskTemplateListBase.

        The time the *TaskTemplateList* was created (as a ISO-8601 timestamp)

        :return: The created_at of this TaskTemplateListBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TaskTemplateListBase.

        The time the *TaskTemplateList* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this TaskTemplateListBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def description(self):
        """Gets the description of this TaskTemplateListBase.

        A detailed description of the *TaskTemplateList*

        :return: The description of this TaskTemplateListBase.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TaskTemplateListBase.

        A detailed description of the *TaskTemplateList*

        :param description: The description of this TaskTemplateListBase.
        :type description: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this TaskTemplateListBase.

        Unique identifier for the *TaskTemplateList*

        :return: The id of this TaskTemplateListBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskTemplateListBase.

        Unique identifier for the *TaskTemplateList*

        :param id: The id of this TaskTemplateListBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this TaskTemplateListBase.

        ETag for the *TaskTemplateList*

        :return: The etag of this TaskTemplateListBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this TaskTemplateListBase.

        ETag for the *TaskTemplateList*

        :param etag: The etag of this TaskTemplateListBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this TaskTemplateListBase.

        The name of the *TaskTemplateList*

        :return: The name of this TaskTemplateListBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskTemplateListBase.

        The name of the *TaskTemplateList*

        :param name: The name of this TaskTemplateListBase.
        :type name: str
        """

        self._name = name

    @property
    def templates_count(self):
        """Gets the templates_count of this TaskTemplateListBase.

        How many task templates exist as an association to the *TaskTemplateList*

        :return: The templates_count of this TaskTemplateListBase.
        :rtype: int
        """
        return self._templates_count

    @templates_count.setter
    def templates_count(self, templates_count):
        """Sets the templates_count of this TaskTemplateListBase.

        How many task templates exist as an association to the *TaskTemplateList*

        :param templates_count: The templates_count of this TaskTemplateListBase.
        :type templates_count: int
        """

        self._templates_count = templates_count

    @property
    def updated_at(self):
        """Gets the updated_at of this TaskTemplateListBase.

        The time the *TaskTemplateList* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this TaskTemplateListBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TaskTemplateListBase.

        The time the *TaskTemplateList* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this TaskTemplateListBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
