# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TaskType(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, deleted_at: datetime=None, created_at: datetime=None, updated_at: datetime=None):
        """TaskType - a model defined in OpenAPI

        :param id: The id of this TaskType.
        :param etag: The etag of this TaskType.
        :param name: The name of this TaskType.
        :param deleted_at: The deleted_at of this TaskType.
        :param created_at: The created_at of this TaskType.
        :param updated_at: The updated_at of this TaskType.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'deleted_at': datetime,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'deleted_at': 'deleted_at',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._deleted_at = deleted_at
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TaskType':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TaskType of this TaskType.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this TaskType.

        Unique identifier for the *TaskType*

        :return: The id of this TaskType.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskType.

        Unique identifier for the *TaskType*

        :param id: The id of this TaskType.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this TaskType.

        ETag for the *TaskType*

        :return: The etag of this TaskType.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this TaskType.

        ETag for the *TaskType*

        :param etag: The etag of this TaskType.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this TaskType.

        The name of the *TaskType*

        :return: The name of this TaskType.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskType.

        The name of the *TaskType*

        :param name: The name of this TaskType.
        :type name: str
        """

        self._name = name

    @property
    def deleted_at(self):
        """Gets the deleted_at of this TaskType.

        The time the *TaskType* was deleted (as a ISO-8601 timestamp)

        :return: The deleted_at of this TaskType.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this TaskType.

        The time the *TaskType* was deleted (as a ISO-8601 timestamp)

        :param deleted_at: The deleted_at of this TaskType.
        :type deleted_at: datetime
        """

        self._deleted_at = deleted_at

    @property
    def created_at(self):
        """Gets the created_at of this TaskType.

        The time the *TaskType* was created (as a ISO-8601 timestamp)

        :return: The created_at of this TaskType.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TaskType.

        The time the *TaskType* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this TaskType.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this TaskType.

        The time the *TaskType* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this TaskType.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TaskType.

        The time the *TaskType* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this TaskType.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
