# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TaskTypeCreateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, deleted_at: date=None, name: str=None):
        """TaskTypeCreateRequestData - a model defined in OpenAPI

        :param deleted_at: The deleted_at of this TaskTypeCreateRequestData.
        :param name: The name of this TaskTypeCreateRequestData.
        """
        self.openapi_types = {
            'deleted_at': date,
            'name': str
        }

        self.attribute_map = {
            'deleted_at': 'deleted_at',
            'name': 'name'
        }

        self._deleted_at = deleted_at
        self._name = name

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TaskTypeCreateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TaskType_create_request_data of this TaskTypeCreateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def deleted_at(self):
        """Gets the deleted_at of this TaskTypeCreateRequestData.

        Date the TaskType was disabled. (Expects an ISO-8601 timestamp).

        :return: The deleted_at of this TaskTypeCreateRequestData.
        :rtype: date
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this TaskTypeCreateRequestData.

        Date the TaskType was disabled. (Expects an ISO-8601 timestamp).

        :param deleted_at: The deleted_at of this TaskTypeCreateRequestData.
        :type deleted_at: date
        """

        self._deleted_at = deleted_at

    @property
    def name(self):
        """Gets the name of this TaskTypeCreateRequestData.

        Name of the TaskType.

        :return: The name of this TaskTypeCreateRequestData.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskTypeCreateRequestData.

        Name of the TaskType.

        :param name: The name of this TaskTypeCreateRequestData.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name
