# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.activity_base import ActivityBase
from openapi_server import util


class Timer(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, start_time: datetime=None, elapsed_time: float=None, created_at: datetime=None, updated_at: datetime=None, activity: ActivityBase=None):
        """Timer - a model defined in OpenAPI

        :param id: The id of this Timer.
        :param etag: The etag of this Timer.
        :param start_time: The start_time of this Timer.
        :param elapsed_time: The elapsed_time of this Timer.
        :param created_at: The created_at of this Timer.
        :param updated_at: The updated_at of this Timer.
        :param activity: The activity of this Timer.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'start_time': datetime,
            'elapsed_time': float,
            'created_at': datetime,
            'updated_at': datetime,
            'activity': ActivityBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'start_time': 'start_time',
            'elapsed_time': 'elapsed_time',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'activity': 'activity'
        }

        self._id = id
        self._etag = etag
        self._start_time = start_time
        self._elapsed_time = elapsed_time
        self._created_at = created_at
        self._updated_at = updated_at
        self._activity = activity

    @classmethod
    def from_dict(cls, dikt: dict) -> 'Timer':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The Timer of this Timer.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this Timer.

        Unique identifier for the *Timer*

        :return: The id of this Timer.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Timer.

        Unique identifier for the *Timer*

        :param id: The id of this Timer.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this Timer.

        ETag for the *Timer*

        :return: The etag of this Timer.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this Timer.

        ETag for the *Timer*

        :param etag: The etag of this Timer.
        :type etag: str
        """

        self._etag = etag

    @property
    def start_time(self):
        """Gets the start_time of this Timer.

        The time the *Timer* was started (as ISO-8601 timestamp)

        :return: The start_time of this Timer.
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this Timer.

        The time the *Timer* was started (as ISO-8601 timestamp)

        :param start_time: The start_time of this Timer.
        :type start_time: datetime
        """

        self._start_time = start_time

    @property
    def elapsed_time(self):
        """Gets the elapsed_time of this Timer.

        How much time has elapsed, in hours, since the timer was started

        :return: The elapsed_time of this Timer.
        :rtype: float
        """
        return self._elapsed_time

    @elapsed_time.setter
    def elapsed_time(self, elapsed_time):
        """Sets the elapsed_time of this Timer.

        How much time has elapsed, in hours, since the timer was started

        :param elapsed_time: The elapsed_time of this Timer.
        :type elapsed_time: float
        """

        self._elapsed_time = elapsed_time

    @property
    def created_at(self):
        """Gets the created_at of this Timer.

        The time the *Timer* was created (as a ISO-8601 timestamp)

        :return: The created_at of this Timer.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Timer.

        The time the *Timer* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this Timer.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Timer.

        The time the *Timer* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this Timer.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Timer.

        The time the *Timer* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this Timer.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def activity(self):
        """Gets the activity of this Timer.


        :return: The activity of this Timer.
        :rtype: ActivityBase
        """
        return self._activity

    @activity.setter
    def activity(self, activity):
        """Sets the activity of this Timer.


        :param activity: The activity of this Timer.
        :type activity: ActivityBase
        """

        self._activity = activity
