# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server.models.bill_base import BillBase
from openapi_server.models.contact_base import ContactBase
from openapi_server.models.matter_base import MatterBase
from openapi_server import util


class TrustLineItem(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, _date: date=None, total: float=None, note: str=None, created_at: datetime=None, updated_at: datetime=None, bill: BillBase=None, matter: MatterBase=None, client: ContactBase=None):
        """TrustLineItem - a model defined in OpenAPI

        :param id: The id of this TrustLineItem.
        :param etag: The etag of this TrustLineItem.
        :param _date: The _date of this TrustLineItem.
        :param total: The total of this TrustLineItem.
        :param note: The note of this TrustLineItem.
        :param created_at: The created_at of this TrustLineItem.
        :param updated_at: The updated_at of this TrustLineItem.
        :param bill: The bill of this TrustLineItem.
        :param matter: The matter of this TrustLineItem.
        :param client: The client of this TrustLineItem.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            '_date': date,
            'total': float,
            'note': str,
            'created_at': datetime,
            'updated_at': datetime,
            'bill': BillBase,
            'matter': MatterBase,
            'client': ContactBase
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            '_date': 'date',
            'total': 'total',
            'note': 'note',
            'created_at': 'created_at',
            'updated_at': 'updated_at',
            'bill': 'bill',
            'matter': 'matter',
            'client': 'client'
        }

        self._id = id
        self._etag = etag
        self.__date = _date
        self._total = total
        self._note = note
        self._created_at = created_at
        self._updated_at = updated_at
        self._bill = bill
        self._matter = matter
        self._client = client

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TrustLineItem':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TrustLineItem of this TrustLineItem.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this TrustLineItem.

        Unique identifier for the *TrustLineItem*

        :return: The id of this TrustLineItem.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TrustLineItem.

        Unique identifier for the *TrustLineItem*

        :param id: The id of this TrustLineItem.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this TrustLineItem.

        ETag for the *TrustLineItem*

        :return: The etag of this TrustLineItem.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this TrustLineItem.

        ETag for the *TrustLineItem*

        :param etag: The etag of this TrustLineItem.
        :type etag: str
        """

        self._etag = etag

    @property
    def _date(self):
        """Gets the _date of this TrustLineItem.

        The date of the *TrustLineItem* (as a ISO-8601 date)

        :return: The _date of this TrustLineItem.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this TrustLineItem.

        The date of the *TrustLineItem* (as a ISO-8601 date)

        :param _date: The _date of this TrustLineItem.
        :type _date: date
        """

        self.__date = _date

    @property
    def total(self):
        """Gets the total of this TrustLineItem.

        The total amount for the *TrustLineItem*

        :return: The total of this TrustLineItem.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this TrustLineItem.

        The total amount for the *TrustLineItem*

        :param total: The total of this TrustLineItem.
        :type total: float
        """

        self._total = total

    @property
    def note(self):
        """Gets the note of this TrustLineItem.

        Note for the *TrustLineItem*

        :return: The note of this TrustLineItem.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this TrustLineItem.

        Note for the *TrustLineItem*

        :param note: The note of this TrustLineItem.
        :type note: str
        """

        self._note = note

    @property
    def created_at(self):
        """Gets the created_at of this TrustLineItem.

        The time the *TrustLineItem* was created (as a ISO-8601 timestamp)

        :return: The created_at of this TrustLineItem.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TrustLineItem.

        The time the *TrustLineItem* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this TrustLineItem.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this TrustLineItem.

        The time the *TrustLineItem* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this TrustLineItem.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TrustLineItem.

        The time the *TrustLineItem* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this TrustLineItem.
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def bill(self):
        """Gets the bill of this TrustLineItem.


        :return: The bill of this TrustLineItem.
        :rtype: BillBase
        """
        return self._bill

    @bill.setter
    def bill(self, bill):
        """Sets the bill of this TrustLineItem.


        :param bill: The bill of this TrustLineItem.
        :type bill: BillBase
        """

        self._bill = bill

    @property
    def matter(self):
        """Gets the matter of this TrustLineItem.


        :return: The matter of this TrustLineItem.
        :rtype: MatterBase
        """
        return self._matter

    @matter.setter
    def matter(self, matter):
        """Sets the matter of this TrustLineItem.


        :param matter: The matter of this TrustLineItem.
        :type matter: MatterBase
        """

        self._matter = matter

    @property
    def client(self):
        """Gets the client of this TrustLineItem.


        :return: The client of this TrustLineItem.
        :rtype: ContactBase
        """
        return self._client

    @client.setter
    def client(self, client):
        """Sets the client of this TrustLineItem.


        :param client: The client of this TrustLineItem.
        :type client: ContactBase
        """

        self._client = client
