# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TrustLineItemBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, _date: date=None, total: float=None, note: str=None, created_at: datetime=None, updated_at: datetime=None):
        """TrustLineItemBase - a model defined in OpenAPI

        :param id: The id of this TrustLineItemBase.
        :param etag: The etag of this TrustLineItemBase.
        :param _date: The _date of this TrustLineItemBase.
        :param total: The total of this TrustLineItemBase.
        :param note: The note of this TrustLineItemBase.
        :param created_at: The created_at of this TrustLineItemBase.
        :param updated_at: The updated_at of this TrustLineItemBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            '_date': date,
            'total': float,
            'note': str,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            '_date': 'date',
            'total': 'total',
            'note': 'note',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self.__date = _date
        self._total = total
        self._note = note
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TrustLineItemBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TrustLineItem_base of this TrustLineItemBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this TrustLineItemBase.

        Unique identifier for the *TrustLineItem*

        :return: The id of this TrustLineItemBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TrustLineItemBase.

        Unique identifier for the *TrustLineItem*

        :param id: The id of this TrustLineItemBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this TrustLineItemBase.

        ETag for the *TrustLineItem*

        :return: The etag of this TrustLineItemBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this TrustLineItemBase.

        ETag for the *TrustLineItem*

        :param etag: The etag of this TrustLineItemBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def _date(self):
        """Gets the _date of this TrustLineItemBase.

        The date of the *TrustLineItem* (as a ISO-8601 date)

        :return: The _date of this TrustLineItemBase.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this TrustLineItemBase.

        The date of the *TrustLineItem* (as a ISO-8601 date)

        :param _date: The _date of this TrustLineItemBase.
        :type _date: date
        """

        self.__date = _date

    @property
    def total(self):
        """Gets the total of this TrustLineItemBase.

        The total amount for the *TrustLineItem*

        :return: The total of this TrustLineItemBase.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this TrustLineItemBase.

        The total amount for the *TrustLineItem*

        :param total: The total of this TrustLineItemBase.
        :type total: float
        """

        self._total = total

    @property
    def note(self):
        """Gets the note of this TrustLineItemBase.

        Note for the *TrustLineItem*

        :return: The note of this TrustLineItemBase.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this TrustLineItemBase.

        Note for the *TrustLineItem*

        :param note: The note of this TrustLineItemBase.
        :type note: str
        """

        self._note = note

    @property
    def created_at(self):
        """Gets the created_at of this TrustLineItemBase.

        The time the *TrustLineItem* was created (as a ISO-8601 timestamp)

        :return: The created_at of this TrustLineItemBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TrustLineItemBase.

        The time the *TrustLineItem* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this TrustLineItemBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this TrustLineItemBase.

        The time the *TrustLineItem* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this TrustLineItemBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TrustLineItemBase.

        The time the *TrustLineItem* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this TrustLineItemBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
