# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class TrustLineItemUpdateRequestData(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, _date: date=None, note: str=None, total: float=None):
        """TrustLineItemUpdateRequestData - a model defined in OpenAPI

        :param _date: The _date of this TrustLineItemUpdateRequestData.
        :param note: The note of this TrustLineItemUpdateRequestData.
        :param total: The total of this TrustLineItemUpdateRequestData.
        """
        self.openapi_types = {
            '_date': date,
            'note': str,
            'total': float
        }

        self.attribute_map = {
            '_date': 'date',
            'note': 'note',
            'total': 'total'
        }

        self.__date = _date
        self._note = note
        self._total = total

    @classmethod
    def from_dict(cls, dikt: dict) -> 'TrustLineItemUpdateRequestData':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The TrustLineItem_update_request_data of this TrustLineItemUpdateRequestData.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def _date(self):
        """Gets the _date of this TrustLineItemUpdateRequestData.

        Date for the TrustLineItem. (Expects an ISO-8601 date).

        :return: The _date of this TrustLineItemUpdateRequestData.
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this TrustLineItemUpdateRequestData.

        Date for the TrustLineItem. (Expects an ISO-8601 date).

        :param _date: The _date of this TrustLineItemUpdateRequestData.
        :type _date: date
        """

        self.__date = _date

    @property
    def note(self):
        """Gets the note of this TrustLineItemUpdateRequestData.

        Note for the TrustLineItem.

        :return: The note of this TrustLineItemUpdateRequestData.
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this TrustLineItemUpdateRequestData.

        Note for the TrustLineItem.

        :param note: The note of this TrustLineItemUpdateRequestData.
        :type note: str
        """

        self._note = note

    @property
    def total(self):
        """Gets the total of this TrustLineItemUpdateRequestData.

        Total amount the TrustLineItem is for.

        :return: The total of this TrustLineItemUpdateRequestData.
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this TrustLineItemUpdateRequestData.

        Total amount the TrustLineItem is for.

        :param total: The total of this TrustLineItemUpdateRequestData.
        :type total: float
        """

        self._total = total
