# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class UtbmsSetBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, name: str=None, enabled: bool=None, created_at: datetime=None, updated_at: datetime=None):
        """UtbmsSetBase - a model defined in OpenAPI

        :param id: The id of this UtbmsSetBase.
        :param etag: The etag of this UtbmsSetBase.
        :param name: The name of this UtbmsSetBase.
        :param enabled: The enabled of this UtbmsSetBase.
        :param created_at: The created_at of this UtbmsSetBase.
        :param updated_at: The updated_at of this UtbmsSetBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'name': str,
            'enabled': bool,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'name': 'name',
            'enabled': 'enabled',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._name = name
        self._enabled = enabled
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'UtbmsSetBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The UtbmsSet_base of this UtbmsSetBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this UtbmsSetBase.

        Unique identifier for the *UtbmsSet*

        :return: The id of this UtbmsSetBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UtbmsSetBase.

        Unique identifier for the *UtbmsSet*

        :param id: The id of this UtbmsSetBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this UtbmsSetBase.

        ETag for the *UtbmsSet*

        :return: The etag of this UtbmsSetBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this UtbmsSetBase.

        ETag for the *UtbmsSet*

        :param etag: The etag of this UtbmsSetBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def name(self):
        """Gets the name of this UtbmsSetBase.

        The name of the *UtbmsSet*

        :return: The name of this UtbmsSetBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UtbmsSetBase.

        The name of the *UtbmsSet*

        :param name: The name of this UtbmsSetBase.
        :type name: str
        """

        self._name = name

    @property
    def enabled(self):
        """Gets the enabled of this UtbmsSetBase.

        Whether the *UtbmsSet* is enabled for the current account.

        :return: The enabled of this UtbmsSetBase.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this UtbmsSetBase.

        Whether the *UtbmsSet* is enabled for the current account.

        :param enabled: The enabled of this UtbmsSetBase.
        :type enabled: bool
        """

        self._enabled = enabled

    @property
    def created_at(self):
        """Gets the created_at of this UtbmsSetBase.

        The time the *UtbmsSet* was created (as a ISO-8601 timestamp)

        :return: The created_at of this UtbmsSetBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this UtbmsSetBase.

        The time the *UtbmsSet* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this UtbmsSetBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this UtbmsSetBase.

        The time the *UtbmsSet* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this UtbmsSetBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this UtbmsSetBase.

        The time the *UtbmsSet* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this UtbmsSetBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
