# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from openapi_server.models.base_model import Model
from openapi_server import util


class WebSiteBase(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, etag: str=None, address: str=None, name: str=None, default_web_site: bool=None, created_at: datetime=None, updated_at: datetime=None):
        """WebSiteBase - a model defined in OpenAPI

        :param id: The id of this WebSiteBase.
        :param etag: The etag of this WebSiteBase.
        :param address: The address of this WebSiteBase.
        :param name: The name of this WebSiteBase.
        :param default_web_site: The default_web_site of this WebSiteBase.
        :param created_at: The created_at of this WebSiteBase.
        :param updated_at: The updated_at of this WebSiteBase.
        """
        self.openapi_types = {
            'id': int,
            'etag': str,
            'address': str,
            'name': str,
            'default_web_site': bool,
            'created_at': datetime,
            'updated_at': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'etag': 'etag',
            'address': 'address',
            'name': 'name',
            'default_web_site': 'default_web_site',
            'created_at': 'created_at',
            'updated_at': 'updated_at'
        }

        self._id = id
        self._etag = etag
        self._address = address
        self._name = name
        self._default_web_site = default_web_site
        self._created_at = created_at
        self._updated_at = updated_at

    @classmethod
    def from_dict(cls, dikt: dict) -> 'WebSiteBase':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The WebSite_base of this WebSiteBase.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this WebSiteBase.

        Unique identifier for the *WebSite*

        :return: The id of this WebSiteBase.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WebSiteBase.

        Unique identifier for the *WebSite*

        :param id: The id of this WebSiteBase.
        :type id: int
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this WebSiteBase.

        ETag for the *WebSite*

        :return: The etag of this WebSiteBase.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this WebSiteBase.

        ETag for the *WebSite*

        :param etag: The etag of this WebSiteBase.
        :type etag: str
        """

        self._etag = etag

    @property
    def address(self):
        """Gets the address of this WebSiteBase.

        The address of the *WebSite*

        :return: The address of this WebSiteBase.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this WebSiteBase.

        The address of the *WebSite*

        :param address: The address of this WebSiteBase.
        :type address: str
        """

        self._address = address

    @property
    def name(self):
        """Gets the name of this WebSiteBase.

        The type of *WebSite* it is

        :return: The name of this WebSiteBase.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this WebSiteBase.

        The type of *WebSite* it is

        :param name: The name of this WebSiteBase.
        :type name: str
        """
        allowed_values = ["Work", "Personal", "Twitter", "Facebook", "LinkedIn", "Instant Messenger", "Other"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def default_web_site(self):
        """Gets the default_web_site of this WebSiteBase.

        Whether it is the default for this contact

        :return: The default_web_site of this WebSiteBase.
        :rtype: bool
        """
        return self._default_web_site

    @default_web_site.setter
    def default_web_site(self, default_web_site):
        """Sets the default_web_site of this WebSiteBase.

        Whether it is the default for this contact

        :param default_web_site: The default_web_site of this WebSiteBase.
        :type default_web_site: bool
        """

        self._default_web_site = default_web_site

    @property
    def created_at(self):
        """Gets the created_at of this WebSiteBase.

        The time the *WebSite* was created (as a ISO-8601 timestamp)

        :return: The created_at of this WebSiteBase.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this WebSiteBase.

        The time the *WebSite* was created (as a ISO-8601 timestamp)

        :param created_at: The created_at of this WebSiteBase.
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this WebSiteBase.

        The time the *WebSite* was last updated (as a ISO-8601 timestamp)

        :return: The updated_at of this WebSiteBase.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this WebSiteBase.

        The time the *WebSite* was last updated (as a ISO-8601 timestamp)

        :param updated_at: The updated_at of this WebSiteBase.
        :type updated_at: datetime
        """

        self._updated_at = updated_at
